<?php
include_once(getabspath("classes/printpage.php"));

function DisplayMasterTableInfoForPrint_Liquidation_Release($params)
{
	global $cman;
	
	$detailtable = $params["detailtable"];
	$keys = $params["keys"];
	
	$xt = new Xtempl();
	
	$tName = "Liquidation Release";
	$xt->eventsObject = getEventObject($tName);
	
	$mParams  = array();
	$mParams["xt"] = &$xt;
	$mParams["pageType"] = PAGE_PRINT;
	$mParams["tName"] = $tName;
	$masterPage = new PrintPage($mParams);
	
	$cipherer = new RunnerCipherer( $tName );
	$settings = new ProjectSettings($tName, PAGE_PRINT);
	$connection = $cman->byTable( $tName );
	
	$masterQuery = $settings->getSQLQuery();
	$viewControls = new ViewControlsContainer($settings, PAGE_PRINT, $masterPage);
	
	$where = "";
	$keysAssoc = array();
	$showKeys = "";

	if( $detailtable == "project_replenishment_detail" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("Liquidation_Release","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}
	
	if( !$where )
		return;
	
	$str = SecuritySQL("Export", $tName );
	if( strlen($str) )
		$where.= " and ".$str;
	
	$strWhere = whereAdd( $masterQuery->m_where->toSql($masterQuery), $where );
	if( strlen($strWhere) )
		$strWhere= " where ".$strWhere." ";
		
	$strSQL = $masterQuery->HeadToSql().' '.$masterQuery->FromToSql().$strWhere.$masterQuery->TailToSql();
	LogInfo($strSQL);
	
	$data = $cipherer->DecryptFetchedArray( $connection->query( $strSQL )->fetchAssoc() );
	if( !$data )
		return;
	
	// reassign pagetitlelabel function adding extra params
	$xt->assign_function("pagetitlelabel", "xt_pagetitlelabel", array("record" => $data, "settings" => $settings));	
	
	$keylink = "";
	$keylink.= "&key1=".runner_htmlspecialchars(rawurlencode(@$data["id"]));
	
	$xt->assign("TXNID_mastervalue", $viewControls->showDBValue("TXNID", $data, $keylink));
	$format = $settings->getViewFormat("TXNID");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("TXNID")))
		$class = ' rnr-field-number';
		
	$xt->assign("TXNID_class", $class); // add class for field header as field value
	$xt->assign("Transadate_mastervalue", $viewControls->showDBValue("Transadate", $data, $keylink));
	$format = $settings->getViewFormat("Transadate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Transadate")))
		$class = ' rnr-field-number';
		
	$xt->assign("Transadate_class", $class); // add class for field header as field value
	$xt->assign("Business_Partner_mastervalue", $viewControls->showDBValue("Business_Partner", $data, $keylink));
	$format = $settings->getViewFormat("Business_Partner");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Business_Partner")))
		$class = ' rnr-field-number';
		
	$xt->assign("Business_Partner_class", $class); // add class for field header as field value
	$xt->assign("Payable_Account_mastervalue", $viewControls->showDBValue("Payable_Account", $data, $keylink));
	$format = $settings->getViewFormat("Payable_Account");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Payable_Account")))
		$class = ' rnr-field-number';
		
	$xt->assign("Payable_Account_class", $class); // add class for field header as field value
	$xt->assign("Gross_Purchase_mastervalue", $viewControls->showDBValue("Gross_Purchase", $data, $keylink));
	$format = $settings->getViewFormat("Gross_Purchase");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Gross_Purchase")))
		$class = ' rnr-field-number';
		
	$xt->assign("Gross_Purchase_class", $class); // add class for field header as field value
	$xt->assign("Discount_Amount_mastervalue", $viewControls->showDBValue("Discount_Amount", $data, $keylink));
	$format = $settings->getViewFormat("Discount_Amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Discount_Amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("Discount_Amount_class", $class); // add class for field header as field value
	$xt->assign("Discount_Account_mastervalue", $viewControls->showDBValue("Discount_Account", $data, $keylink));
	$format = $settings->getViewFormat("Discount_Account");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Discount_Account")))
		$class = ' rnr-field-number';
		
	$xt->assign("Discount_Account_class", $class); // add class for field header as field value
	$xt->assign("Vat_Amount_mastervalue", $viewControls->showDBValue("Vat_Amount", $data, $keylink));
	$format = $settings->getViewFormat("Vat_Amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Vat_Amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("Vat_Amount_class", $class); // add class for field header as field value
	$xt->assign("VAT_Account_mastervalue", $viewControls->showDBValue("VAT_Account", $data, $keylink));
	$format = $settings->getViewFormat("VAT_Account");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("VAT_Account")))
		$class = ' rnr-field-number';
		
	$xt->assign("VAT_Account_class", $class); // add class for field header as field value
	$xt->assign("EWT_Amount_mastervalue", $viewControls->showDBValue("EWT_Amount", $data, $keylink));
	$format = $settings->getViewFormat("EWT_Amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("EWT_Amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("EWT_Amount_class", $class); // add class for field header as field value
	$xt->assign("EWT_Account_mastervalue", $viewControls->showDBValue("EWT_Account", $data, $keylink));
	$format = $settings->getViewFormat("EWT_Account");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("EWT_Account")))
		$class = ' rnr-field-number';
		
	$xt->assign("EWT_Account_class", $class); // add class for field header as field value
	$xt->assign("Net_Amount_mastervalue", $viewControls->showDBValue("Net_Amount", $data, $keylink));
	$format = $settings->getViewFormat("Net_Amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Net_Amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("Net_Amount_class", $class); // add class for field header as field value
	$xt->assign("Taxable_mastervalue", $viewControls->showDBValue("Taxable", $data, $keylink));
	$format = $settings->getViewFormat("Taxable");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Taxable")))
		$class = ' rnr-field-number';
		
	$xt->assign("Taxable_class", $class); // add class for field header as field value
	$xt->assign("Remarks_mastervalue", $viewControls->showDBValue("Remarks", $data, $keylink));
	$format = $settings->getViewFormat("Remarks");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Remarks")))
		$class = ' rnr-field-number';
		
	$xt->assign("Remarks_class", $class); // add class for field header as field value
	$xt->assign("vatable_mastervalue", $viewControls->showDBValue("vatable", $data, $keylink));
	$format = $settings->getViewFormat("vatable");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("vatable")))
		$class = ' rnr-field-number';
		
	$xt->assign("vatable_class", $class); // add class for field header as field value
	$xt->assign("atc_mastervalue", $viewControls->showDBValue("atc", $data, $keylink));
	$format = $settings->getViewFormat("atc");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("atc")))
		$class = ' rnr-field-number';
		
	$xt->assign("atc_class", $class); // add class for field header as field value
	$xt->assign("ewt_rate_mastervalue", $viewControls->showDBValue("ewt_rate", $data, $keylink));
	$format = $settings->getViewFormat("ewt_rate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("ewt_rate")))
		$class = ' rnr-field-number';
		
	$xt->assign("ewt_rate_class", $class); // add class for field header as field value
	$xt->assign("Net_pay_mastervalue", $viewControls->showDBValue("Net_pay", $data, $keylink));
	$format = $settings->getViewFormat("Net_pay");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Net_pay")))
		$class = ' rnr-field-number';
		
	$xt->assign("Net_pay_class", $class); // add class for field header as field value
	$xt->assign("ref_no_mastervalue", $viewControls->showDBValue("ref_no", $data, $keylink));
	$format = $settings->getViewFormat("ref_no");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("ref_no")))
		$class = ' rnr-field-number';
		
	$xt->assign("ref_no_class", $class); // add class for field header as field value
	$xt->assign("file_mastervalue", $viewControls->showDBValue("file", $data, $keylink));
	$format = $settings->getViewFormat("file");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("file")))
		$class = ' rnr-field-number';
		
	$xt->assign("file_class", $class); // add class for field header as field value
	$xt->assign("discount_type_mastervalue", $viewControls->showDBValue("discount_type", $data, $keylink));
	$format = $settings->getViewFormat("discount_type");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount_type")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_type_class", $class); // add class for field header as field value
	$xt->assign("discount_rate_mastervalue", $viewControls->showDBValue("discount_rate", $data, $keylink));
	$format = $settings->getViewFormat("discount_rate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount_rate")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_rate_class", $class); // add class for field header as field value
	$xt->assign("discount_code_mastervalue", $viewControls->showDBValue("discount_code", $data, $keylink));
	$format = $settings->getViewFormat("discount_code");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("discount_code")))
		$class = ' rnr-field-number';
		
	$xt->assign("discount_code_class", $class); // add class for field header as field value
	$xt->assign("project_mastervalue", $viewControls->showDBValue("project", $data, $keylink));
	$format = $settings->getViewFormat("project");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("project")))
		$class = ' rnr-field-number';
		
	$xt->assign("project_class", $class); // add class for field header as field value
	$xt->assign("sales_rep_mastervalue", $viewControls->showDBValue("sales_rep", $data, $keylink));
	$format = $settings->getViewFormat("sales_rep");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("sales_rep")))
		$class = ' rnr-field-number';
		
	$xt->assign("sales_rep_class", $class); // add class for field header as field value
	$xt->assign("approved_by_mastervalue", $viewControls->showDBValue("approved_by", $data, $keylink));
	$format = $settings->getViewFormat("approved_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("approved_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("approved_by_class", $class); // add class for field header as field value
	$xt->assign("checked_by_mastervalue", $viewControls->showDBValue("checked_by", $data, $keylink));
	$format = $settings->getViewFormat("checked_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("checked_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("checked_by_class", $class); // add class for field header as field value
	$xt->assign("vatable_purchase_mastervalue", $viewControls->showDBValue("vatable_purchase", $data, $keylink));
	$format = $settings->getViewFormat("vatable_purchase");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("vatable_purchase")))
		$class = ' rnr-field-number';
		
	$xt->assign("vatable_purchase_class", $class); // add class for field header as field value
	$xt->assign("non_vatable_purchase_mastervalue", $viewControls->showDBValue("non_vatable_purchase", $data, $keylink));
	$format = $settings->getViewFormat("non_vatable_purchase");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("non_vatable_purchase")))
		$class = ' rnr-field-number';
		
	$xt->assign("non_vatable_purchase_class", $class); // add class for field header as field value
	$xt->assign("invoice_no_mastervalue", $viewControls->showDBValue("invoice_no", $data, $keylink));
	$format = $settings->getViewFormat("invoice_no");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("invoice_no")))
		$class = ' rnr-field-number';
		
	$xt->assign("invoice_no_class", $class); // add class for field header as field value
	$xt->assign("employee_liquidation_mastervalue", $viewControls->showDBValue("employee_liquidation", $data, $keylink));
	$format = $settings->getViewFormat("employee_liquidation");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("employee_liquidation")))
		$class = ' rnr-field-number';
		
	$xt->assign("employee_liquidation_class", $class); // add class for field header as field value
	$xt->assign("balance_mastervalue", $viewControls->showDBValue("balance", $data, $keylink));
	$format = $settings->getViewFormat("balance");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("balance")))
		$class = ' rnr-field-number';
		
	$xt->assign("balance_class", $class); // add class for field header as field value
	$xt->assign("company_mastervalue", $viewControls->showDBValue("company", $data, $keylink));
	$format = $settings->getViewFormat("company");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("company")))
		$class = ' rnr-field-number';
		
	$xt->assign("company_class", $class); // add class for field header as field value
	$xt->assign("bank_mastervalue", $viewControls->showDBValue("bank", $data, $keylink));
	$format = $settings->getViewFormat("bank");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("bank")))
		$class = ' rnr-field-number';
		
	$xt->assign("bank_class", $class); // add class for field header as field value
	$xt->assign("Print1_mastervalue", $viewControls->showDBValue("Print1", $data, $keylink));
	$format = $settings->getViewFormat("Print1");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Print1")))
		$class = ' rnr-field-number';
		
	$xt->assign("Print1_class", $class); // add class for field header as field value
	$xt->assign("release_rel_mastervalue", $viewControls->showDBValue("release_rel", $data, $keylink));
	$format = $settings->getViewFormat("release_rel");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("release_rel")))
		$class = ' rnr-field-number';
		
	$xt->assign("release_rel_class", $class); // add class for field header as field value
	$xt->assign("release_date_rel_mastervalue", $viewControls->showDBValue("release_date_rel", $data, $keylink));
	$format = $settings->getViewFormat("release_date_rel");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("release_date_rel")))
		$class = ' rnr-field-number';
		
	$xt->assign("release_date_rel_class", $class); // add class for field header as field value
	$xt->assign("release_rep_mastervalue", $viewControls->showDBValue("release_rep", $data, $keylink));
	$format = $settings->getViewFormat("release_rep");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("release_rep")))
		$class = ' rnr-field-number';
		
	$xt->assign("release_rep_class", $class); // add class for field header as field value
	$xt->assign("release_date_rep_mastervalue", $viewControls->showDBValue("release_date_rep", $data, $keylink));
	$format = $settings->getViewFormat("release_date_rep");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("release_date_rep")))
		$class = ' rnr-field-number';
		
	$xt->assign("release_date_rep_class", $class); // add class for field header as field value

	$layout = GetPageLayout("Liquidation_Release", 'masterprint');
	if( $layout )
		$xt->assign("pageattrs", 'class="'.$layout->style." page-".$layout->name.'"');

	$xt->displayPartial(GetTemplateName("Liquidation_Release", "masterprint"));
}

?>