<?php
include_once(getabspath("classes/printpage.php"));

function DisplayMasterTableInfoForPrint_Loan_for_checking($params)
{
	global $cman;
	
	$detailtable = $params["detailtable"];
	$keys = $params["keys"];
	
	$xt = new Xtempl();
	
	$tName = "Loan_for_checking";
	$xt->eventsObject = getEventObject($tName);
	
	$mParams  = array();
	$mParams["xt"] = &$xt;
	$mParams["pageType"] = PAGE_PRINT;
	$mParams["tName"] = $tName;
	$masterPage = new PrintPage($mParams);
	
	$cipherer = new RunnerCipherer( $tName );
	$settings = new ProjectSettings($tName, PAGE_PRINT);
	$connection = $cman->byTable( $tName );
	
	$masterQuery = $settings->getSQLQuery();
	$viewControls = new ViewControlsContainer($settings, PAGE_PRINT, $masterPage);
	
	$where = "";
	$keysAssoc = array();
	$showKeys = "";

	if( $detailtable == "loan_detail_for_checking" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("Loan_for_checking","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}
	
	if( !$where )
		return;
	
	$str = SecuritySQL("Export", $tName );
	if( strlen($str) )
		$where.= " and ".$str;
	
	$strWhere = whereAdd( $masterQuery->m_where->toSql($masterQuery), $where );
	if( strlen($strWhere) )
		$strWhere= " where ".$strWhere." ";
		
	$strSQL = $masterQuery->HeadToSql().' '.$masterQuery->FromToSql().$strWhere.$masterQuery->TailToSql();
	LogInfo($strSQL);
	
	$data = $cipherer->DecryptFetchedArray( $connection->query( $strSQL )->fetchAssoc() );
	if( !$data )
		return;
	
	// reassign pagetitlelabel function adding extra params
	$xt->assign_function("pagetitlelabel", "xt_pagetitlelabel", array("record" => $data, "settings" => $settings));	
	
	$keylink = "";
	$keylink.= "&key1=".runner_htmlspecialchars(rawurlencode(@$data["id"]));
	
	$xt->assign("Print_mastervalue", $viewControls->showDBValue("Print", $data, $keylink));
	$format = $settings->getViewFormat("Print");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Print")))
		$class = ' rnr-field-number';
		
	$xt->assign("Print_class", $class); // add class for field header as field value
	$xt->assign("loan_no_mastervalue", $viewControls->showDBValue("loan_no", $data, $keylink));
	$format = $settings->getViewFormat("loan_no");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("loan_no")))
		$class = ' rnr-field-number';
		
	$xt->assign("loan_no_class", $class); // add class for field header as field value
	$xt->assign("date_mastervalue", $viewControls->showDBValue("date", $data, $keylink));
	$format = $settings->getViewFormat("date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("date")))
		$class = ' rnr-field-number';
		
	$xt->assign("date_class", $class); // add class for field header as field value
	$xt->assign("loan_type_mastervalue", $viewControls->showDBValue("loan_type", $data, $keylink));
	$format = $settings->getViewFormat("loan_type");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("loan_type")))
		$class = ' rnr-field-number';
		
	$xt->assign("loan_type_class", $class); // add class for field header as field value
	$xt->assign("no_of_payment_mastervalue", $viewControls->showDBValue("no_of_payment", $data, $keylink));
	$format = $settings->getViewFormat("no_of_payment");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("no_of_payment")))
		$class = ' rnr-field-number';
		
	$xt->assign("no_of_payment_class", $class); // add class for field header as field value
	$xt->assign("loan_amount_mastervalue", $viewControls->showDBValue("loan_amount", $data, $keylink));
	$format = $settings->getViewFormat("loan_amount");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("loan_amount")))
		$class = ' rnr-field-number';
		
	$xt->assign("loan_amount_class", $class); // add class for field header as field value
	$xt->assign("checked_by_mastervalue", $viewControls->showDBValue("checked_by", $data, $keylink));
	$format = $settings->getViewFormat("checked_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("checked_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("checked_by_class", $class); // add class for field header as field value
	$xt->assign("approved_by_mastervalue", $viewControls->showDBValue("approved_by", $data, $keylink));
	$format = $settings->getViewFormat("approved_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("approved_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("approved_by_class", $class); // add class for field header as field value
	$xt->assign("remarks_mastervalue", $viewControls->showDBValue("remarks", $data, $keylink));
	$format = $settings->getViewFormat("remarks");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("remarks")))
		$class = ' rnr-field-number';
		
	$xt->assign("remarks_class", $class); // add class for field header as field value
	$xt->assign("file_mastervalue", $viewControls->showDBValue("file", $data, $keylink));
	$format = $settings->getViewFormat("file");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("file")))
		$class = ' rnr-field-number';
		
	$xt->assign("file_class", $class); // add class for field header as field value
	$xt->assign("employee_mastervalue", $viewControls->showDBValue("employee", $data, $keylink));
	$format = $settings->getViewFormat("employee");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("employee")))
		$class = ' rnr-field-number';
		
	$xt->assign("employee_class", $class); // add class for field header as field value
	$xt->assign("status_mastervalue", $viewControls->showDBValue("status", $data, $keylink));
	$format = $settings->getViewFormat("status");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("status")))
		$class = ' rnr-field-number';
		
	$xt->assign("status_class", $class); // add class for field header as field value
	$xt->assign("status_remarks_mastervalue", $viewControls->showDBValue("status_remarks", $data, $keylink));
	$format = $settings->getViewFormat("status_remarks");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("status_remarks")))
		$class = ' rnr-field-number';
		
	$xt->assign("status_remarks_class", $class); // add class for field header as field value
	$xt->assign("approved_date_mastervalue", $viewControls->showDBValue("approved_date", $data, $keylink));
	$format = $settings->getViewFormat("approved_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("approved_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("approved_date_class", $class); // add class for field header as field value
	$xt->assign("prepared_by_mastervalue", $viewControls->showDBValue("prepared_by", $data, $keylink));
	$format = $settings->getViewFormat("prepared_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("prepared_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("prepared_by_class", $class); // add class for field header as field value
	$xt->assign("modified_by_mastervalue", $viewControls->showDBValue("modified_by", $data, $keylink));
	$format = $settings->getViewFormat("modified_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("modified_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("modified_by_class", $class); // add class for field header as field value
	$xt->assign("modified_date_mastervalue", $viewControls->showDBValue("modified_date", $data, $keylink));
	$format = $settings->getViewFormat("modified_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("modified_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("modified_date_class", $class); // add class for field header as field value
	$xt->assign("checked_date_mastervalue", $viewControls->showDBValue("checked_date", $data, $keylink));
	$format = $settings->getViewFormat("checked_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("checked_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("checked_date_class", $class); // add class for field header as field value
	$xt->assign("prepared_date_mastervalue", $viewControls->showDBValue("prepared_date", $data, $keylink));
	$format = $settings->getViewFormat("prepared_date");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("prepared_date")))
		$class = ' rnr-field-number';
		
	$xt->assign("prepared_date_class", $class); // add class for field header as field value

	$layout = GetPageLayout("Loan_for_checking", 'masterprint');
	if( $layout )
		$xt->assign("pageattrs", 'class="'.$layout->style." page-".$layout->name.'"');

	$xt->displayPartial(GetTemplateName("Loan_for_checking", "masterprint"));
}

?>