<?php
function DisplayMasterTableInfo_Project_phases($params)
{
	$keys = $params["keys"];
	$detailtable = $params["detailtable"];
	$data = $params["masterRecordData"];
	
	$xt = new Xtempl();
	$tName = "Project_phases";
	$xt->eventsObject = getEventObject($tName);
	
	include_once('classes/listpage.php');
	include_once('classes/listpage_simple.php');
	$mParams  = array();
	$mParams["xt"] = &$xt;
	$mParams["mode"] = LIST_MASTER;
	$mParams["pageType"] = PAGE_LIST;
	$mParams["flyId"] = $params["recId"];
	$masterPage = ListPage::createListPage($tName, $mParams);
	
	$settings = $masterPage->pSet;
	$viewControls = new ViewControlsContainer($settings, PAGE_LIST, $masterPage);
	
	$keysAssoc = array();
	$showKeys = "";	

	if($detailtable == "tasks")
	{
		$keysAssoc["TaskID"] = $keys[1-1];
				
				$keyValue = $viewControls->showDBValue("TaskID", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("Project_phases","TaskID").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);
	}

	if( !$data || !count($data) )
		return;
	
	// reassign pagetitlelabel function adding extra params
	$xt->assign_function("pagetitlelabel", "xt_pagetitlelabel", array("record" => $data, "settings" => $settings));
	
	$keylink = "";
	$keylink.= "&key1=".runner_htmlspecialchars(rawurlencode(@$data["TaskID"]));
	
	$xt->assign("TaskID_mastervalue", $viewControls->showDBValue("TaskID", $data, $keylink));
	$format = $settings->getViewFormat("TaskID");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("TaskID")))
		$class = ' rnr-field-number';
		
	$xt->assign("TaskID_class", $class); // add class for field header as field value
	$xt->assign("ProjectID_mastervalue", $viewControls->showDBValue("ProjectID", $data, $keylink));
	$format = $settings->getViewFormat("ProjectID");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("ProjectID")))
		$class = ' rnr-field-number';
		
	$xt->assign("ProjectID_class", $class); // add class for field header as field value
	$xt->assign("TaskName_mastervalue", $viewControls->showDBValue("TaskName", $data, $keylink));
	$format = $settings->getViewFormat("TaskName");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("TaskName")))
		$class = ' rnr-field-number';
		
	$xt->assign("TaskName_class", $class); // add class for field header as field value
	$xt->assign("AssignedTo_mastervalue", $viewControls->showDBValue("AssignedTo", $data, $keylink));
	$format = $settings->getViewFormat("AssignedTo");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("AssignedTo")))
		$class = ' rnr-field-number';
		
	$xt->assign("AssignedTo_class", $class); // add class for field header as field value
	$xt->assign("Notes_mastervalue", $viewControls->showDBValue("Notes", $data, $keylink));
	$format = $settings->getViewFormat("Notes");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Notes")))
		$class = ' rnr-field-number';
		
	$xt->assign("Notes_class", $class); // add class for field header as field value
	$xt->assign("IsGroup_mastervalue", $viewControls->showDBValue("IsGroup", $data, $keylink));
	$format = $settings->getViewFormat("IsGroup");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("IsGroup")))
		$class = ' rnr-field-number';
		
	$xt->assign("IsGroup_class", $class); // add class for field header as field value
	$xt->assign("BarColorHex_mastervalue", $viewControls->showDBValue("BarColorHex", $data, $keylink));
	$format = $settings->getViewFormat("BarColorHex");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("BarColorHex")))
		$class = ' rnr-field-number';
		
	$xt->assign("BarColorHex_class", $class); // add class for field header as field value

	$layout = GetPageLayout("Project_phases", 'masterlist');
	if( $layout )
		$xt->assign("pageattrs", 'class="'.$layout->style." page-".$layout->name.'"');
	
	$xt->displayPartial(GetTemplateName("Project_phases", "masterlist"));
}

?>