<?php
class AuditTrailTable
{
	var $logTableName="basic_system_audit";
	var $params;
	
	var $strLogin="login";
	var $strFailLogin="failed login";
	var $strLogout="logout";
	var $strChPass="change password";
	var $strAdd="add";
	var $strEdit="edit";
	var $strDelete="delete";
	var $strAccess="access";
	var $strKeysHeader="---Keys";
	var $strFieldsHeader="---Fields";
	var $columnDate="Date";
	var $columnTime="Time";
	var $columnIP="IP";
	var $columnUser="User";
	var $columnTable="Table";
	var $columnAction="Action";
	var $columnKey="Key field";
	var $columnField="Field";
	var $columnOldValue="Old value";
	var $columnNewValue="New value";
	var $attLogin=0;
	var $timeLogin=0;
	var $maxFieldLength = 300;

	/**
	 * @type Connection
	 */
	protected $connection;
	
	function AuditTrailTable()
	{
		global $cman;
		
		$this->connection = $cman->getForAudit();		
		$userid="";
		if(@$_SESSION["UserID"])
			$userid=$_SESSION["UserID"];
			
		$this->params=array($_SERVER["REMOTE_ADDR"],$userid);
	}
	
    function LogLogin($pUsername)
    {
    }
	
    function LogLoginFailed($pUsername)
    {
    }
	
    function LogLogout()
    {
    }
	
    function LogChPassword()
    {
    }
	
    function LogAdd($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strAdd, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			$str="";
			if(count($keys)>0)
			{
				$str.=$this->strKeysHeader."\r\n";
				foreach($keys as $idx=>$val)
					$str.=$idx." : ".$val."\r\n";
			}
			$strFields="";
			if($this->logValueEnable($str_table))
			{
				foreach($values as $idx=>$val)
				{
					if($val!="" && !array_key_exists($idx,$keys))
					{
						$strFields.=$idx." [new]: ";
						if(IsBinaryType($pSet->getFieldType($idx)))
							$v="<binary value>";
						else
						{
							$v=str_replace(array("\r\n","\n","\t")," ",$val);
							if(strlen($v)>$this->maxFieldLength)
								$v=runner_substr($val,0,$this->maxFieldLength);
						}
						$strFields.=$v."\r\n";
					}
				}
			}
			if($strFields!="")
				$str.=$this->strFieldsHeader."\r\n".$strFields;
			
			$this->insert(now(), $this->params[0], $this->params[1], $str_table, $this->strAdd, $str);
		}
		return $retval;
    }
	
    function LogEdit($str_table,$newvalues,$oldvalues,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strEdit, $this->params, $table, $keys, $newvalues, $oldvalues);
		if($retval)
		{
			$str="";
			if(count($keys)>0)
			{
				$str.=$this->strKeysHeader."\r\n";
				foreach($newvalues as $idx=>$val)
				{
					if(array_key_exists($idx,$keys))
					{
						if($val!=$oldvalues[$idx])
						{
							$str.=$idx." [old]: ".$oldvalues[$idx]."\r\n";
							$str.=$idx." [new]: ".$val."\r\n";
						}
						else
							$str.=$idx." : ".$val."\r\n";
					}
				}
			}
			$strFields="";
			if($this->logValueEnable($str_table))
			{
				$v="";
				foreach($newvalues as $idx=>$val)
				{
					$type=$pSet->getFieldType($idx);
					if(IsBinaryType($type))
						continue;
					if(IsDateFieldType($type))
					{
						$newvalue=format_datetime_custom(db2time($newvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
						$oldvalue=format_datetime_custom(db2time($oldvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
					}
					else
					{
						$newvalue=$newvalues[$idx];
						$oldvalue=$oldvalues[$idx];
					}
					if($newvalue!=$oldvalue && !array_key_exists($idx,$keys))
					{
						$strFields.=$idx." [old]: ";
						if(IsBinaryType($type))
							$v="<binary value>";
						else
						{
							$v=str_replace(array("\r\n","\n","\t")," ",$oldvalue);
							if(strlen($v)>$this->maxFieldLength)
								$v=runner_substr($v,0,$this->maxFieldLength);
						}
						$strFields.=$v."\r\n";
												
						$strFields.=$idx." [new]: ";
						if(IsBinaryType($type))
							$v="<binary value>";
						else
						{
							$v=str_replace(array("\r\n","\n","\t")," ",$newvalue);
							if(strlen($v)>$this->maxFieldLength)
								$v=runner_substr($v,0,$this->maxFieldLength);
						}
						$strFields.=$v."\r\n";
					}
				}
				$v="";
			}
			if($strFields!="")
				$str.=$this->strFieldsHeader."\r\n".$strFields;
			
			$this->insert(now(), $this->params[0], $this->params[1], $str_table, $this->strEdit, $str);
		}
		return $retval;
    }
	
    function LogDelete($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strDelete, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			$str="";
			if(count($keys)>0)
			{
				$str.=$this->strKeysHeader."\r\n";
				foreach($keys as $idx=>$val)
					$str.=$idx." : ".$val."\r\n";
			}
			$strFields="";
			if($this->logValueEnable($str_table))
			{
				$v="";
				foreach($values as $idx=>$val)
				{
					if($val!="" && !array_key_exists($idx,$keys))
					{
						$strFields.=$idx." [old]: ";
						if(IsBinaryType($pSet->getFieldType($idx)))
							$v="<binary value>";
						else
						{	
							$v=str_replace(array("\r\n","\n","\t")," ",$val);
							if(strlen($v)>$this->maxFieldLength)
								$v=runner_substr($v,0,$this->maxFieldLength);
						}
						$strFields.=$v."\r\n";
					}
				}
			}
			if($strFields!="")
				$str.=$this->strFieldsHeader."\r\n".$strFields;
			
			$this->insert(now(), $this->params[0], $this->params[1], $str_table, $this->strDelete, $str);
		}
		return $retval;
    }
    
    function LogAddEvent($message,$description="",$stable="")
    {
		global $globalEvents;
		$retval=true;
		$table=$stable;
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($message, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			$this->insert(now(), $this->params[0], $this->params[1], $stable, $message, $description);
		}
		return $retval;
    }
	
    function LoginSuccessful()
    {
		if($this->attLogin>0 && $this->timeLogin>0)
		{
			$where = $this->connection->addFieldWrappers("ip"). "=" .$this->connection->prepareString($_SERVER["REMOTE_ADDR"]). 
				" AND " .$this->connection->addFieldWrappers("action"). "=" .$this->connection->prepareString($this->strAccess);
			$sql = "DELETE FROM " .$this->connection->addTableWrappers( $this->logTableName ). " WHERE " .$where;
			
			$this->connection->exec( $sql );
		}
		
    }
	
    function LoginUnsuccessful($pUsername)
    {
		if($this->attLogin>0 && $this->timeLogin>0)
		{
			$this->insert(now(), $_SERVER["REMOTE_ADDR"], $pUsername, "", $this->strAccess, "");
		}
    }
    
	function LoginAccess()
	{
		if( $this->attLogin > 0 && $this->timeLogin > 0 )
		{
			$where = $this->connection->addFieldWrappers("ip"). "=" .$this->connection->prepareString($_SERVER["REMOTE_ADDR"]). 
				" AND " .$this->connection->addFieldWrappers("action"). "=".$this->connection->prepareString("access");
			$orderBy = $this->connection->addFieldWrappers("id")." asc";
			$sql = "SELECT * FROM " .$this->connection->addTableWrappers( $this->logTableName ). " WHERE " .$where. " ORDER BY " .$orderBy;
			
			$qResult = $this->connection->query( $sql );
			
			$i = 0;
			while( $data = $qResult->fetchAssoc() )
			{
				if( secondsPassedFrom($data["datetime"]) / 60 <= $this->timeLogin )
				{
					if($i==0)
						$firstAccess=$data["datetime"];
					$i+=1;
				}
			}
			
			if( $i >= $this->attLogin )
				return ceil($this->timeLogin-secondsPassedFrom($firstAccess) / 60);
		}

		return false;
	}
	
	function logValueEnable($table)
	{
		if($table=="business_partner")
		{
			return true;
		}
		if($table=="item")
		{
			return true;
		}
		if($table=="credit_terms")
		{
			return true;
		}
		if($table=="shipping_terms")
		{
			return true;
		}
		if($table=="cash_receipt")
		{
			return true;
		}
		if($table=="purchase")
		{
			return true;
		}
		if($table=="cash_disbursment")
		{
			return true;
		}
		if($table=="general_journal")
		{
			return true;
		}
		if($table=="report_center")
		{
			return true;
		}
		if($table=="Sales Report")
		{
			return true;
		}
		if($table=="Disbursement Reports")
		{
			return true;
		}
		if($table=="Financial Reports")
		{
			return true;
		}
		if($table=="Purchase Reports")
		{
			return true;
		}
		if($table=="Receivable Reports")
		{
			return true;
		}
		if($table=="Taxation Reports")
		{
			return true;
		}
		if($table=="system_user")
		{
			return true;
		}
		if($table=="fiscal_year")
		{
			return true;
		}
		if($table=="beg_bal")
		{
			return true;
		}
		if($table=="ewt")
		{
			return true;
		}
		if($table=="bank")
		{
			return true;
		}
		if($table=="cost_center")
		{
			return true;
		}
		if($table=="General Journal Reports")
		{
			return true;
		}
		if($table=="Inventory Reports")
		{
			return true;
		}
		if($table=="accounting_period")
		{
			return true;
		}
		if($table=="bank_recon")
		{
			return true;
		}
		if($table=="deposit")
		{
			return true;
		}
		if($table=="account_classification")
		{
			return true;
		}
		if($table=="chart_of_accounts")
		{
			return true;
		}
		if($table=="recon_CR")
		{
			return true;
		}
		if($table=="Recon_deposit")
		{
			return true;
		}
		if($table=="Recon_CV")
		{
			return true;
		}
		if($table=="Recon_GV_dep")
		{
			return true;
		}
		if($table=="Recon_GV_CV")
		{
			return true;
		}
		if($table=="vat_atc")
		{
			return true;
		}
		if($table=="rdo")
		{
			return true;
		}
		if($table=="2550q")
		{
			return true;
		}
		if($table=="2550m")
		{
			return true;
		}
		if($table=="dr")
		{
			return true;
		}
		if($table=="purchase_order")
		{
			return true;
		}
		if($table=="purchase_order_receiving")
		{
			return true;
		}
		if($table=="System_preference")
		{
			return true;
		}
		if($table=="ppe_list")
		{
			return true;
		}
		if($table=="discounts")
		{
			return true;
		}
		if($table=="item_group")
		{
			return true;
		}
		if($table=="location")
		{
			return true;
		}
		if($table=="meetings")
		{
			return true;
		}
		if($table=="calls")
		{
			return true;
		}
		if($table=="campaign")
		{
			return true;
		}
		if($table=="reimbursement")
		{
			return true;
		}
		if($table=="reimbursement_detail")
		{
			return false;
		}
		if($table=="Target_customers")
		{
			return true;
		}
		if($table=="quotation")
		{
			return true;
		}
		if($table=="case")
		{
			return true;
		}
		if($table=="projects")
		{
			return true;
		}
		if($table=="production")
		{
			return true;
		}
		if($table=="issue")
		{
			return true;
		}
		if($table=="issue_detail")
		{
			return false;
		}
		if($table=="disposed")
		{
			return true;
		}
		if($table=="disposed_detail")
		{
			return false;
		}
		if($table=="backload")
		{
			return true;
		}
		if($table=="backload_detail")
		{
			return false;
		}
		if($table=="vehicle")
		{
			return true;
		}
		if($table=="payroll_item")
		{
			return true;
		}
		if($table=="uom")
		{
			return true;
		}
		if($table=="trip_ticket")
		{
			return true;
		}
		if($table=="accident")
		{
			return true;
		}
		if($table=="approver_list")
		{
			return true;
		}
		if($table=="area")
		{
			return true;
		}
		if($table=="attendance")
		{
			return true;
		}
		if($table=="currency")
		{
			return true;
		}
		if($table=="medical")
		{
			return true;
		}
		if($table=="position")
		{
			return true;
		}
		if($table=="service_center")
		{
			return true;
		}
		if($table=="seminar")
		{
			return true;
		}
		if($table=="service_report")
		{
			return true;
		}
		if($table=="service_report_detail")
		{
			return false;
		}
		if($table=="tax_status")
		{
			return true;
		}
		if($table=="training")
		{
			return true;
		}
		if($table=="competitor")
		{
			return true;
		}
		if($table=="campaign_type")
		{
			return true;
		}
		if($table=="fixed_asset_return_detail")
		{
			return false;
		}
		if($table=="fixed_assets_return")
		{
			return true;
		}
		if($table=="Prospect_customers")
		{
			return true;
		}
		if($table=="trip_detail")
		{
			return true;
		}
		if($table=="beg_baldetail")
		{
			return true;
		}
		if($table=="cash_disbursement_detail2")
		{
			return false;
		}
		if($table=="case_solutions")
		{
			return true;
		}
		if($table=="cash_disbursment_detail")
		{
			return false;
		}
		if($table=="cash_receipt_detail")
		{
			return false;
		}
		if($table=="cash_receipt_detail2")
		{
			return false;
		}
		if($table=="general_journal_detail")
		{
			return false;
		}
		if($table=="employee_list")
		{
			return true;
		}
		if($table=="petty_cash")
		{
			return true;
		}
		if($table=="petty_cash_detail")
		{
			return false;
		}
		if($table=="center_replenishment")
		{
			return true;
		}
		if($table=="center_replenishment_detail")
		{
			return false;
		}
		if($table=="credit_memo")
		{
			return true;
		}
		if($table=="credit_memo_detail")
		{
			return false;
		}
		if($table=="debit_memo")
		{
			return true;
		}
		if($table=="debit_memo_detail")
		{
			return false;
		}
		if($table=="project_replenishment")
		{
			return true;
		}
		if($table=="project_replenishment_detail")
		{
			return false;
		}
		if($table=="business_partner_group")
		{
			return true;
		}
		if($table=="Sales_Representatives")
		{
			return true;
		}
		if($table=="Types_of_leaves")
		{
			return true;
		}
		if($table=="payroll_mode")
		{
			return true;
		}
		if($table=="payroll_account_type")
		{
			return true;
		}
		if($table=="Types_of_Overtime")
		{
			return true;
		}
		if($table=="Types_of_Loan")
		{
			return true;
		}
		if($table=="sales")
		{
			return true;
		}
		if($table=="sales_detail")
		{
			return false;
		}
		if($table=="Payroll_Company_Setup")
		{
			return true;
		}
		if($table=="item_bill_of_materials")
		{
			return true;
		}
		if($table=="item_uom_conversion")
		{
			return true;
		}
		if($table=="tranasactions_for_approval")
		{
			return true;
		}
		if($table=="deposit_detail")
		{
			return false;
		}
		if($table=="purchase_detail")
		{
			return false;
		}
		if($table=="dr_detail")
		{
			return false;
		}
		if($table=="purchase_order_detail")
		{
			return false;
		}
		if($table=="Sales_Order_for_checking")
		{
			return true;
		}
		if($table=="sales_order_detail_for_checking")
		{
			return true;
		}
		if($table=="Sales_Order_for_approval")
		{
			return true;
		}
		if($table=="sales_order_detail_for_approval")
		{
			return true;
		}
		if($table=="Quotation_for_approval")
		{
			return true;
		}
		if($table=="Quotation_for_checking")
		{
			return true;
		}
		if($table=="quotation_detail_for_checking")
		{
			return true;
		}
		if($table=="quotation_detail_for_approval")
		{
			return true;
		}
		if($table=="Reimbursement_for_checking")
		{
			return true;
		}
		if($table=="reimbursement_detail_for_checking")
		{
			return false;
		}
		if($table=="Reimbursement_for_approval")
		{
			return true;
		}
		if($table=="reimbursement_detail_for_approval")
		{
			return false;
		}
		if($table=="Project_Replenishment_for_checking")
		{
			return true;
		}
		if($table=="project_replenishment_detail_for_checking")
		{
			return false;
		}
		if($table=="Project_Replenishment_for_approval")
		{
			return true;
		}
		if($table=="project_replenishment_detail_for_approval")
		{
			return false;
		}
		if($table=="center_replenishment_detail_for_checking")
		{
			return false;
		}
		if($table=="center_replenishment_detail_for_approval")
		{
			return true;
		}
		if($table=="Purchases_Order_for_checking2")
		{
			return true;
		}
		if($table=="purchase_order_detail_for_checking")
		{
			return false;
		}
		if($table=="Purchases_Order_for_approval2")
		{
			return true;
		}
		if($table=="purchase_order_detail_for_approval")
		{
			return false;
		}
		if($table=="Receiving_for_checking2")
		{
			return true;
		}
		if($table=="purchase_order_receiving_detail_for_checking")
		{
			return false;
		}
		if($table=="Receiving_for_approval2")
		{
			return true;
		}
		if($table=="purchase_order_receiving_detail_for_approval")
		{
			return false;
		}
		if($table=="Delivery_Receipt_for_checking")
		{
			return true;
		}
		if($table=="dr_detail_for_checking")
		{
			return false;
		}
		if($table=="Delivery_Receipt_for_approval")
		{
			return true;
		}
		if($table=="dr_detail_for_approval")
		{
			return false;
		}
		if($table=="Production_for_checking")
		{
			return true;
		}
		if($table=="production_detail_for_checking")
		{
			return false;
		}
		if($table=="Production_for_approval")
		{
			return true;
		}
		if($table=="production_detail_for_approval")
		{
			return false;
		}
		if($table=="Issue_for_checking")
		{
			return true;
		}
		if($table=="supply_issue_detail_for_checking")
		{
			return false;
		}
		if($table=="Issue_for_approval")
		{
			return true;
		}
		if($table=="supply_issue_detail_for_approval")
		{
			return false;
		}
		if($table=="Return_for_checking")
		{
			return true;
		}
		if($table=="supply_return_detail_for_checking")
		{
			return false;
		}
		if($table=="Return_for_approval")
		{
			return true;
		}
		if($table=="supply_return_detail_approval")
		{
			return false;
		}
		if($table=="supply_disposed_detail_for_checking")
		{
			return false;
		}
		if($table=="Disposal_for_approval")
		{
			return true;
		}
		if($table=="supply_disposed_detail_for_approval")
		{
			return false;
		}
		if($table=="Fixed_Asset_Issue_for_checking")
		{
			return true;
		}
		if($table=="Fixed_Asset_Issue_for_approval")
		{
			return true;
		}
		if($table=="fixed_asset_issue_detail_for_approval")
		{
			return false;
		}
		if($table=="fixed_asset_issue_detail_for_checking")
		{
			return false;
		}
		if($table=="Fixed_Asset_Return_for_checking")
		{
			return true;
		}
		if($table=="fixed_asset_return_detail_for_checking")
		{
			return false;
		}
		if($table=="Fixed_Asset_Return_for_approval")
		{
			return true;
		}
		if($table=="fixed_asset_return_detail_for_approval")
		{
			return false;
		}
		if($table=="Petty_Cash_for_checking")
		{
			return true;
		}
		if($table=="petty_cash_detail_for_checking")
		{
			return false;
		}
		if($table=="Petty_Cash_for_approval")
		{
			return true;
		}
		if($table=="petty_cash_detail_for_approval")
		{
			return false;
		}
		if($table=="Deposit_for_checking")
		{
			return true;
		}
		if($table=="deposit_detail_for_checking")
		{
			return false;
		}
		if($table=="Deposit_for_approval")
		{
			return true;
		}
		if($table=="deposit_detail_for_approval")
		{
			return false;
		}
		if($table=="Credit_Memo_for_checking")
		{
			return true;
		}
		if($table=="credit_memo_detail_for_checking")
		{
			return false;
		}
		if($table=="Credit_Memo_for_approval")
		{
			return true;
		}
		if($table=="credit_memo_detail_for_approval")
		{
			return false;
		}
		if($table=="Debit_Memo_for_checking")
		{
			return true;
		}
		if($table=="debit_memo_detail_for_checking")
		{
			return false;
		}
		if($table=="debit_memo_for_approval")
		{
			return true;
		}
		if($table=="debit_memo_detail_for_approval")
		{
			return false;
		}
		if($table=="Purchases_for_checking")
		{
			return true;
		}
		if($table=="credit_purchase_detail_for_checking")
		{
			return false;
		}
		if($table=="Purchases_for_approval")
		{
			return true;
		}
		if($table=="credit_purchase_detail_for_approval")
		{
			return false;
		}
		if($table=="Sales_for_checking")
		{
			return true;
		}
		if($table=="Sales_for_approval")
		{
			return true;
		}
		if($table=="credit_sales_detail_for_checking")
		{
			return false;
		}
		if($table=="credit_sales_detail_for_approval")
		{
			return false;
		}
		if($table=="Cash_Disbursement_for_checking")
		{
			return true;
		}
		if($table=="check_voucher_detail_for_checking")
		{
			return false;
		}
		if($table=="check_voucher_detail2_for_checking")
		{
			return false;
		}
		if($table=="Cash_Disbursement_for_approval")
		{
			return true;
		}
		if($table=="check_voucher_detail_for_approval")
		{
			return false;
		}
		if($table=="check_voucher_detail2_for_approval")
		{
			return false;
		}
		if($table=="document")
		{
			return true;
		}
		if($table=="General_Journal_for_checking")
		{
			return true;
		}
		if($table=="general_journal_detail_for_checking")
		{
			return false;
		}
		if($table=="General_Journal_for_approval")
		{
			return true;
		}
		if($table=="general_journal_detail_for_approval")
		{
			return false;
		}
		if($table=="for_submissions")
		{
			return true;
		}
		if($table=="submission_details")
		{
			return false;
		}
		if($table=="sales_order_detail_billing_dates")
		{
			return false;
		}
		if($table=="Submission_Search")
		{
			return true;
		}
		if($table=="Submission_Reminders")
		{
			return true;
		}
		if($table=="years")
		{
			return true;
		}
		if($table=="document_type")
		{
			return true;
		}
		if($table=="estimate")
		{
			return true;
		}
		if($table=="estimate_detail")
		{
			return false;
		}
		if($table=="purchase_request")
		{
			return true;
		}
		if($table=="purchase_request_detail")
		{
			return false;
		}
		if($table=="inv_adj_detail")
		{
			return false;
		}
		if($table=="inventory_adj")
		{
			return true;
		}
		if($table=="inventory_tranfer")
		{
			return true;
		}
		if($table=="inventory_transfer_detail")
		{
			return false;
		}
		if($table=="Customers")
		{
			return true;
		}
		if($table=="Suppliers")
		{
			return true;
		}
		if($table=="Target_contacts")
		{
			return true;
		}
		if($table=="Prospect_contacts")
		{
			return true;
		}
		if($table=="Customer_Contacts")
		{
			return true;
		}
		if($table=="Supplier_Contacts")
		{
			return true;
		}
		if($table=="Statement_of_Account")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_approval")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_checking")
		{
			return true;
		}
		if($table=="Inventory_Adjustment_for_checking")
		{
			return true;
		}
		if($table=="inv_adj_detail_for_checking")
		{
			return false;
		}
		if($table=="Inventory_Adjustment_for_approval")
		{
			return true;
		}
		if($table=="inv_adj_detail_for_approval")
		{
			return false;
		}
		if($table=="for_checking")
		{
			return true;
		}
		if($table=="for_approval")
		{
			return true;
		}
		if($table=="Estimate_for_approval")
		{
			return true;
		}
		if($table=="Estimate_for_checking")
		{
			return true;
		}
		if($table=="estimate_detail_for_checking")
		{
			return false;
		}
		if($table=="estimate_detail_for_approval")
		{
			return false;
		}
		if($table=="Follow_up")
		{
			return true;
		}
		if($table=="coming_meetings")
		{
			return true;
		}
		if($table=="tasks")
		{
			return true;
		}
		if($table=="Project_phases")
		{
			return true;
		}
		if($table=="origin_fa")
		{
			return true;
		}
		if($table=="origin_serialized_supply")
		{
			return true;
		}
		if($table=="2301")
		{
			return true;
		}
		if($table=="Prospect_customers_to_Customer")
		{
			return true;
		}
		if($table=="lyl_estimate")
		{
			return true;
		}
		if($table=="lyl_estimate_detail")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_aluminum")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_e_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_glass")
		{
			return false;
		}
		if($table=="recuring_benefits")
		{
			return true;
		}
		if($table=="recuring_deductions")
		{
			return true;
		}
		if($table=="recurring_benefits_detail")
		{
			return false;
		}
		if($table=="recurring_deductions_detail")
		{
			return false;
		}
		if($table=="production_request")
		{
			return true;
		}
		if($table=="production_request_detail")
		{
			return false;
		}
		if($table=="attendance_summary")
		{
			return true;
		}
		if($table=="Other_Incentives")
		{
			return true;
		}
		if($table=="Other_Deductions")
		{
			return true;
		}
		if($table=="department")
		{
			return true;
		}
		if($table=="journal_entry_cash_disbursement")
		{
			return true;
		}
		if($table=="journal_entry_cash_receipt")
		{
			return true;
		}
		if($table=="journal_entry_center_replenishment")
		{
			return true;
		}
		if($table=="journal_entry_credit_memo")
		{
			return true;
		}
		if($table=="journal_entry_debit_memo")
		{
			return true;
		}
		if($table=="journal_entry_depreciation")
		{
			return true;
		}
		if($table=="journal_entry_general_journal")
		{
			return true;
		}
		if($table=="journal_entry_inventory_adjustment")
		{
			return true;
		}
		if($table=="journal_entry_petty_cash")
		{
			return true;
		}
		if($table=="journal_entry_project_replenishment")
		{
			return true;
		}
		if($table=="journal_entry_purchases")
		{
			return true;
		}
		if($table=="journal_entry_replenishment")
		{
			return true;
		}
		if($table=="journal_entry_service_revenue")
		{
			return true;
		}
		if($table=="Credit_Card_monitoring")
		{
			return true;
		}
		if($table=="sales_report_per_item Chart")
		{
			return false;
		}
		if($table=="Leave_for_approval")
		{
			return true;
		}
		if($table=="loan_for_approval")
		{
			return true;
		}
		if($table=="loan_detail_for_approval")
		{
			return true;
		}
		if($table=="Overtime_for_approval")
		{
			return true;
		}
		if($table=="Purchase_Request_for_approval")
		{
			return true;
		}
		if($table=="purchase_request_detail_approval")
		{
			return false;
		}
		if($table=="Production_Request_for_approval")
		{
			return true;
		}
		if($table=="production_request_detail_for_approval")
		{
			return false;
		}
		if($table=="Inventory_Transfer_for_approval")
		{
			return true;
		}
		if($table=="inventory_transfer_detail_for_approval")
		{
			return false;
		}
		if($table=="Leave_for_checking")
		{
			return true;
		}
		if($table=="Loan_for_checking")
		{
			return true;
		}
		if($table=="loan_detail_for_checking")
		{
			return true;
		}
		if($table=="Overtime_for_checking")
		{
			return true;
		}
		if($table=="Purchase_Request_for_checking")
		{
			return true;
		}
		if($table=="Production_Request_for_checking")
		{
			return true;
		}
		if($table=="Inventory_Transfer_for_checking")
		{
			return true;
		}
		if($table=="inventory_transfer_detail_for_checking")
		{
			return false;
		}
		if($table=="attendance_type")
		{
			return true;
		}
		if($table=="Backload_for_approval")
		{
			return true;
		}
		if($table=="backload_detail_for_approval")
		{
			return false;
		}
		if($table=="Backload_for_checking")
		{
			return true;
		}
		if($table=="backload_detail_for_checking")
		{
			return false;
		}
		if($table=="Cash_Receipt_for_approval")
		{
			return true;
		}
		if($table=="Cash_Receipt_for_checking")
		{
			return true;
		}
		if($table=="cash_receipt_detail_for_checking")
		{
			return false;
		}
		if($table=="cash_receipt_detail_for_approval")
		{
			return false;
		}
		if($table=="Payroll_Entry_for_approval")
		{
			return true;
		}
		if($table=="Payroll_Entry_for_checking")
		{
			return true;
		}
		if($table=="payroll_entry_detail_for_approval")
		{
			return false;
		}
		if($table=="payroll_entry_detail_for_checking")
		{
			return false;
		}
		if($table=="Process_Payroll_for_approval")
		{
			return true;
		}
		if($table=="Process_Payroll_for_checking")
		{
			return true;
		}
		if($table=="process_payroll_detail_for_approval")
		{
			return false;
		}
		if($table=="process_payroll_detail_for_checking")
		{
			return false;
		}
		if($table=="Service_Report_for_approval")
		{
			return true;
		}
		if($table=="Service_Report_for_checking")
		{
			return true;
		}
		if($table=="service_report_detail_for_approval")
		{
			return false;
		}
		if($table=="service_report_detail_for_checking")
		{
			return false;
		}
		if($table=="Banch Reports")
		{
			return true;
		}
		if($table=="journal_entry_production")
		{
			return true;
		}
		if($table=="journal_entry_deposit")
		{
			return true;
		}
		if($table=="production_request_bom")
		{
			return true;
		}
		if($table=="production_bom")
		{
			return true;
		}
		if($table=="company_info")
		{
			return true;
		}
		if($table=="return")
		{
			return true;
		}
		if($table=="return_detail")
		{
			return false;
		}
		if($table=="fixed_asset_issue")
		{
			return true;
		}
		if($table=="fixed_asset_issue_detail")
		{
			return false;
		}
		if($table=="production_request_detail_for_checking")
		{
			return false;
		}
		if($table=="cash_disbursment_detail_for_approval")
		{
			return false;
		}
		if($table=="cash_disbursment_detail_for_checking")
		{
			return false;
		}
		if($table=="purchase_request_detail_for_checking")
		{
			return false;
		}
		if($table=="trip_ticket_for_approval")
		{
			return true;
		}
		if($table=="trip_ticket_for_checking")
		{
			return true;
		}
		if($table=="trip_detail_for_approval")
		{
			return true;
		}
		if($table=="trip_detail_for_checking")
		{
			return true;
		}
		if($table=="sales_report")
		{
			return false;
		}
		if($table=="Customer_Balance_Report")
		{
			return false;
		}
		if($table=="Customer_Balance_Report_detail")
		{
			return false;
		}
		if($table=="Collection_Report_per_Customer")
		{
			return false;
		}
		if($table=="Aging_of_AR_Report")
		{
			return false;
		}
		if($table=="Aging_of_AR_Report_detail")
		{
			return false;
		}
		if($table=="Payment_per_Supplier_Report")
		{
			return false;
		}
		if($table=="Aging of_AP_Report")
		{
			return false;
		}
		if($table=="Aging of_AP_Report_detail")
		{
			return false;
		}
		if($table=="Inventory_Balance_Report")
		{
			return false;
		}
		if($table=="Inventory_Valuation_Report")
		{
			return false;
		}
		if($table=="Inventory_Below_Reorder_Point_Report")
		{
			return false;
		}
		if($table=="Sales_Report_per_BP")
		{
			return false;
		}
		if($table=="Sales_Report_per_Item")
		{
			return false;
		}
		if($table=="Sales_Report_per_Cost_Center")
		{
			return false;
		}
		if($table=="Sales_Report_per_BP_detail")
		{
			return false;
		}
		if($table=="Sales_Report_per_Item_detail")
		{
			return false;
		}
		if($table=="Sales_Report_per_Cost_Center_detail")
		{
			return false;
		}
		if($table=="Purchase_Report")
		{
			return false;
		}
		if($table=="Purchase_Report_per_BP")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Item")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Cost_Center")
		{
			return false;
		}
		if($table=="Purchase_Report_per_BP_detail")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Item_detail")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Cost_Center_detail")
		{
			return false;
		}
		if($table=="Transaction Registry")
		{
			return false;
		}
		if($table=="Sales_Report_per_sales_rep")
		{
			return false;
		}
		if($table=="PDC_Registry_Report")
		{
			return false;
		}
		if($table=="Available_Vehicles")
		{
			return false;
		}
		if($table=="Trip_Ticket_Report")
		{
			return false;
		}
		if($table=="Purchase_Request_Report")
		{
			return false;
		}
		if($table=="Purchase_Import_Costing")
		{
			return false;
		}
		if($table=="Production_Costing_Report")
		{
			return false;
		}
		if($table=="Production_Report")
		{
			return false;
		}
		if($table=="Closed_Opportunities")
		{
			return false;
		}
		if($table=="Cases_with_Sotutions")
		{
			return false;
		}
		if($table=="Totals_Cases_Created")
		{
			return false;
		}
		if($table=="Totals_Open_Cases_by_Agent")
		{
			return false;
		}
		if($table=="Campaign_Contacts")
		{
			return false;
		}
		if($table=="Campaign_leads")
		{
			return false;
		}
		if($table=="Campaign_ROI_Analysis")
		{
			return false;
		}
		if($table=="Campaign_Revenue")
		{
			return false;
		}
		if($table=="Opportunity_Schedule")
		{
			return false;
		}
		if($table=="Sales_by_Account")
		{
			return false;
		}
		if($table=="Sales_by_Lead_Source")
		{
			return false;
		}
		if($table=="Sales_by_Partner")
		{
			return false;
		}
		if($table=="Sales_by_Rep")
		{
			return false;
		}
		if($table=="Leave_Ledger_Report")
		{
			return false;
		}
		if($table=="Leave_Summary")
		{
			return false;
		}
		if($table=="Payroll_Register")
		{
			return false;
		}
		if($table=="Employee_Leave_History")
		{
			return false;
		}
		if($table=="Employee_Register")
		{
			return false;
		}
		if($table=="DR_Reports")
		{
			return false;
		}
		if($table=="Sales_Order_Report")
		{
			return false;
		}
		if($table=="Case_History")
		{
			return false;
		}
		if($table=="quality_control")
		{
			return true;
		}
		if($table=="quality_control_detail")
		{
			return false;
		}
		if($table=="budget")
		{
			return true;
		}
		if($table=="budget_detail")
		{
			return false;
		}
		if($table=="repairs_and_maintenance")
		{
			return true;
		}
		if($table=="production_form")
		{
			return true;
		}
		if($table=="bluewave_employees")
		{
			return true;
		}
		if($table=="bluewave_employees_detail")
		{
			return false;
		}
		if($table=="bluewave_employees_detail2")
		{
			return false;
		}
		if($table=="bluewave_employees_detail3")
		{
			return false;
		}
		if($table=="bluewave_employees_detail4")
		{
			return false;
		}
		if($table=="bluewave_employees_detail5")
		{
			return false;
		}
		if($table=="bluewave_employees_detail6")
		{
			return false;
		}
		if($table=="rfp")
		{
			return true;
		}
		if($table=="telex")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_detail")
		{
			return false;
		}
		if($table=="repair_list")
		{
			return true;
		}
		if($table=="marketing_colateral")
		{
			return true;
		}
		if($table=="email")
		{
			return true;
		}
		if($table=="accessories")
		{
			return true;
		}
		if($table=="sales_order_materials_detail")
		{
			return false;
		}
		if($table=="sales_order_progress_billing_detail")
		{
			return false;
		}
		if($table=="sub_contract")
		{
			return true;
		}
		if($table=="sub_contract_billing_detail")
		{
			return false;
		}
		if($table=="sub_contract_detail")
		{
			return true;
		}
		if($table=="Monthly_Pag-ibig_Summary_Report")
		{
			return false;
		}
		if($table=="Monthly_Philhealth_Report")
		{
			return false;
		}
		if($table=="Monthly_Philhealth_Summary_Report")
		{
			return false;
		}
		if($table=="Monthly_SSS_Report")
		{
			return false;
		}
		if($table=="Monthly_SSS_Report_by_Department_Report")
		{
			return false;
		}
		if($table=="Monthly_Withholding_Tax_Prooflist_Report")
		{
			return false;
		}
		if($table=="Monthly_Witholding_Tax_Collection_List_by_Department_Report")
		{
			return false;
		}
		if($table=="Overtime_Summary_Report")
		{
			return false;
		}
		if($table=="Monthly_Pag-ibig_Report")
		{
			return false;
		}
		if($table=="sales_order")
		{
			return true;
		}
		if($table=="sales_order_detail")
		{
			return false;
		}
		if($table=="vat_relief_importation")
		{
			return true;
		}
		if($table=="vat_relief_purchases")
		{
			return true;
		}
		if($table=="vat_relief_sales")
		{
			return true;
		}
		if($table=="journal_ppe_disposal")
		{
			return true;
		}
		if($table=="credit_memo_detail_cgs")
		{
			return true;
		}
		if($table=="marketing_request_form")
		{
			return true;
		}
		if($table=="Quotation_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Sales_Order_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Delivery_Receipt_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Sales_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Backload_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Purchase_Request_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Purchase_Order_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Purchase_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Cash_Disbursement_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Debit_Memo_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Purchase_Request_Dashboard_Item")
		{
			return false;
		}
		if($table=="Purchase_Order_Dashboard_Item")
		{
			return false;
		}
		if($table=="Purchase_Order_Receiving_Dashboard_Item")
		{
			return false;
		}
		if($table=="Production_Dashboard_Item")
		{
			return false;
		}
		if($table=="sub_contract_for_approval")
		{
			return true;
		}
		if($table=="sub_contract_for_checking")
		{
			return true;
		}
		if($table=="sub_contract_detail_for_approval")
		{
			return true;
		}
		if($table=="sub_contract_detail_for_checking")
		{
			return true;
		}
		if($table=="budget_for_approval")
		{
			return true;
		}
		if($table=="budget_for_checking")
		{
			return true;
		}
		if($table=="budget_detail_for_checking")
		{
			return true;
		}
		if($table=="budget_detail_for_approval")
		{
			return true;
		}
		if($table=="undertime_for_approval")
		{
			return true;
		}
		if($table=="undertime_for_checking")
		{
			return true;
		}
		if($table=="request_for_payment_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment_for_checking")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_detail_for_approval")
		{
			return false;
		}
		if($table=="request_for_payment_detail_for_approval")
		{
			return false;
		}
		if($table=="request_for_payment_detail_for_checking")
		{
			return false;
		}
		if($table=="repairs_and_maintenance_for_approval")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_for_checking")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_detail_for_checking")
		{
			return false;
		}
		if($table=="Disposal_for_checking")
		{
			return true;
		}
		if($table=="Active_campaign_report")
		{
			return false;
		}
		if($table=="For_Billing_report")
		{
			return false;
		}
		if($table=="sales_order_for_project_mngmt")
		{
			return false;
		}
		if($table=="inventory_transfer_cost_detail")
		{
			return false;
		}
		if($table=="Supplier_Balance_Report_Details")
		{
			return false;
		}
		if($table=="Supplier_Balance_Report")
		{
			return false;
		}
		if($table=="Inventory_per_Cost_center_Report")
		{
			return false;
		}
		if($table=="Deposit_Report")
		{
			return false;
		}
		if($table=="SO_for_Billing_Report")
		{
			return false;
		}
		if($table=="Billing_due_dates_Report")
		{
			return false;
		}
		if($table=="Packing_List_Report")
		{
			return false;
		}
		if($table=="Open_Trip_Ticket_Report")
		{
			return false;
		}
		if($table=="Transfer_Report")
		{
			return false;
		}
		if($table=="Production_Report_invw")
		{
			return false;
		}
		if($table=="Supply_per_Department__Report_invw")
		{
			return false;
		}
		if($table=="Item_Balances_Report_invw")
		{
			return false;
		}
		if($table=="Open_Case_Report_s")
		{
			return false;
		}
		if($table=="Sales_Order_per_Campaign_Report_marketing")
		{
			return false;
		}
		if($table=="Sales_per_campaign_Report_marketing")
		{
			return false;
		}
		if($table=="Asset_per_Accountability_Report_invw")
		{
			return false;
		}
		if($table=="Deposit_in_transit_Report")
		{
			return false;
		}
		if($table=="Outstanding_Checks_Report")
		{
			return false;
		}
		if($table=="Absences_Detail_Report")
		{
			return false;
		}
		if($table=="Absences_Report")
		{
			return false;
		}
		if($table=="Attendance_Report")
		{
			return false;
		}
		if($table=="DTR_Report")
		{
			return false;
		}
		if($table=="Summary_of_Tardiness_Report")
		{
			return false;
		}
		if($table=="Followup_Report")
		{
			return false;
		}
		if($table=="Coming_Meeting_Report")
		{
			return false;
		}
		if($table=="Meeting_Report")
		{
			return false;
		}
		if($table=="Next_Action_Report")
		{
			return false;
		}
		if($table=="Calls_Report")
		{
			return false;
		}
		if($table=="sales_per_sales_rep_Report")
		{
			return false;
		}
		if($table=="Expense_per_Project_Report")
		{
			return false;
		}
		if($table=="Tardiness_Report_Summary")
		{
			return false;
		}
		if($table=="Timekeeping_(Hours_Worked)_Report_Summary")
		{
			return false;
		}
		if($table=="Withholding_Tax_Collection_List_per_Month_Report")
		{
			return false;
		}
		if($table=="Business_Owner_Dashboard")
		{
			return false;
		}
		if($table=="Finance_Dashboard")
		{
			return false;
		}
		if($table=="Purchasing_Dashboard")
		{
			return false;
		}
		if($table=="Production_Dashboard")
		{
			return false;
		}
		if($table=="Marketing_Dashboard")
		{
			return false;
		}
		if($table=="Support_Dashboard")
		{
			return false;
		}
		if($table=="Sales_Dashboard")
		{
			return false;
		}
		if($table=="Human_Resource_Dashboard")
		{
			return false;
		}
		if($table=="Project_Manager_Dashboard")
		{
			return false;
		}
		if($table=="System_Admistration_Dashboard")
		{
			return false;
		}
		if($table=="purchase_report_per_item Chart")
		{
			return false;
		}
		if($table=="System_Audit_Report")
		{
			return false;
		}
		if($table=="sale_cost_detail")
		{
			return false;
		}
		if($table=="currency_exchange_rate")
		{
			return true;
		}
		if($table=="cash_receipt_cost_detail")
		{
			return false;
		}
		if($table=="production_cost_detail")
		{
			return false;
		}
		if($table=="Employee")
		{
			return false;
		}
		if($table=="Quotation_Dashboard")
		{
			return false;
		}
		if($table=="Sales_Order_Dashboard")
		{
			return false;
		}
		if($table=="Reimbursement_Dashboard")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_SaleRep")
		{
			return false;
		}
		if($table=="Loan_Dashboard")
		{
			return false;
		}
		if($table=="Leave_Dashboard")
		{
			return false;
		}
		if($table=="Over_Time_Dashboard")
		{
			return false;
		}
		if($table=="Undertime_Dashboard")
		{
			return false;
		}
		if($table=="Fieldwork_Dashboard")
		{
			return false;
		}
		if($table=="Change_Time_Dashboard")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_Employee")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_Customer")
		{
			return false;
		}
		if($table=="lyl_estimate_dr")
		{
			return true;
		}
		if($table=="lyl_estimate_dr_detail")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_aluminum")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_e_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_glass")
		{
			return false;
		}
		if($table=="sum_dr_qty")
		{
			return true;
		}
		if($table=="check_book_registry")
		{
			return true;
		}
		if($table=="check_book_registry_detail")
		{
			return false;
		}
		if($table=="vat_type")
		{
			return true;
		}
		if($table=="quotation_detail")
		{
			return false;
		}
		if($table=="bal_purchase_order_detail")
		{
			return false;
		}
		if($table=="bal_sales_detail")
		{
			return false;
		}
		if($table=="pending_items_reminders")
		{
			return false;
		}
		if($table=="petty_cash_for_liquidation")
		{
			return false;
		}
		if($table=="payment_method")
		{
			return true;
		}
		if($table=="account_type")
		{
			return true;
		}
		if($table=="phase")
		{
			return true;
		}
		if($table=="item_cost_recalculation")
		{
			return true;
		}
		if($table=="issue_components")
		{
			return true;
		}
		if($table=="issue_components_detail")
		{
			return false;
		}
		if($table=="unbuild_assemblies")
		{
			return true;
		}
		if($table=="unbuild_assemblies_detail")
		{
			return false;
		}
		if($table=="demand_plan")
		{
			return true;
		}
		if($table=="input_vat_allocation")
		{
			return true;
		}
		if($table=="case_type")
		{
			return true;
		}
		if($table=="qc_inspection")
		{
			return true;
		}
		if($table=="packing_list_for_checking")
		{
			return true;
		}
		if($table=="packing_list_for_approval")
		{
			return true;
		}
		if($table=="packing_list_detail_for_checking")
		{
			return false;
		}
		if($table=="packing_list_detail_for_approval")
		{
			return false;
		}
		if($table=="disposed_inv_detail")
		{
			return false;
		}
		if($table=="disposed_inv")
		{
			return true;
		}
		if($table=="disposed_inv_for_checking")
		{
			return true;
		}
		if($table=="disposed_inv_for_approval")
		{
			return true;
		}
		if($table=="disposed_inv_detail_for_checking")
		{
			return false;
		}
		if($table=="disposed_inv_detail_for_approval")
		{
			return false;
		}
		if($table=="For_Approval_Dashboard")
		{
			return false;
		}
		if($table=="For_Checking_Dashboard")
		{
			return false;
		}
		if($table=="Customer_For_Approval")
		{
			return false;
		}
		if($table=="request_for_payment_report")
		{
			return false;
		}
		if($table=="credit_memo_report")
		{
			return false;
		}
		if($table=="debit_memo_report")
		{
			return false;
		}
		if($table=="production_request_report")
		{
			return false;
		}
		if($table=="Supplies_Balance_report")
		{
			return false;
		}
		if($table=="approved_sales_order")
		{
			return false;
		}
		if($table=="purchase_order_for_receiving")
		{
			return false;
		}
		if($table=="Dashboard")
		{
			return false;
		}
		if($table=="packing_list")
		{
			return true;
		}
		if($table=="packing_list_detail")
		{
			return false;
		}
		if($table=="open_quote")
		{
			return true;
		}
		if($table=="open_estimates")
		{
			return true;
		}
		if($table=="open_po")
		{
			return true;
		}
		if($table=="open_pr")
		{
			return true;
		}
		if($table=="open_production_request")
		{
			return true;
		}
		if($table=="open_qc")
		{
			return true;
		}
		if($table=="open_receiving")
		{
			return true;
		}
		if($table=="open_request_for_payment")
		{
			return true;
		}
		if($table=="open_so")
		{
			return true;
		}
		if($table=="open_so_for_invoice")
		{
			return true;
		}
		if($table=="open_so_for_project_management")
		{
			return true;
		}
		if($table=="open_backload")
		{
			return true;
		}
		if($table=="purchase_order_receiving_detail")
		{
			return false;
		}
		if($table=="Purchase_Order_Receiving_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="avg_inv")
		{
			return true;
		}
		if($table=="open_backload_Report")
		{
			return false;
		}
		if($table=="open_estimates_Report")
		{
			return false;
		}
		if($table=="open_po_Report")
		{
			return false;
		}
		if($table=="open_pr_Report")
		{
			return false;
		}
		if($table=="open_production_request_Report")
		{
			return false;
		}
		if($table=="open_qc_Report")
		{
			return false;
		}
		if($table=="open_so_for_project_management_Report")
		{
			return false;
		}
		if($table=="open_so_for_invoice_Report")
		{
			return false;
		}
		if($table=="open_so_Report")
		{
			return false;
		}
		if($table=="open_receiving_Report")
		{
			return false;
		}
		if($table=="monthly_consuption_for_production_Report")
		{
			return false;
		}
		if($table=="issue_components_for_approval")
		{
			return true;
		}
		if($table=="issue_components_for_checking")
		{
			return true;
		}
		if($table=="issue_components_detail_for_checking")
		{
			return false;
		}
		if($table=="issue_components_detail_for_approval")
		{
			return false;
		}
		if($table=="fieldwork_for_approval")
		{
			return true;
		}
		if($table=="fieldwork_for_checking")
		{
			return true;
		}
		if($table=="Purchases_Order_for_checking")
		{
			return true;
		}
		if($table=="Purchases_Order_for_approval")
		{
			return true;
		}
		if($table=="Receiving_for_checking")
		{
			return true;
		}
		if($table=="Receiving_for_approval")
		{
			return true;
		}
		if($table=="inventory_tranfer_Report")
		{
			return false;
		}
		if($table=="Purchase_vs_Production_Report")
		{
			return false;
		}
		if($table=="cash_sales_Report")
		{
			return false;
		}
		if($table=="Center_Replenishment_for_approval")
		{
			return true;
		}
		if($table=="Center_Replenishment_for_checking")
		{
			return true;
		}
		if($table=="Purchase_vs_Production")
		{
			return true;
		}
		if($table=="Production_Summary")
		{
			return false;
		}
		if($table=="pending_production_request")
		{
			return false;
		}
		if($table=="unbuild_assemblies_for_checking")
		{
			return true;
		}
		if($table=="unbuild_assemblies_for_approval")
		{
			return true;
		}
		if($table=="unbuild_assemblies_detail_for_checking")
		{
			return true;
		}
		if($table=="quality_control_for_approval")
		{
			return true;
		}
		if($table=="quality_control_for_checking")
		{
			return true;
		}
		if($table=="quality_control_detail_for_approval")
		{
			return false;
		}
		if($table=="raw_cake_balance")
		{
			return false;
		}
		if($table=="bal_cashreceipt")
		{
			return true;
		}
		if($table=="bal_cashpayment")
		{
			return true;
		}
		if($table=="opportunity")
		{
			return true;
		}
		if($table=="Current_Accounts")
		{
			return true;
		}
		if($table=="bal_lyl_acc")
		{
			return true;
		}
		if($table=="bal_lyl_glass")
		{
			return true;
		}
		if($table=="bal_lyl_eacc")
		{
			return true;
		}
		if($table=="bal_lyl_allum")
		{
			return true;
		}
		if($table=="opportunity_details")
		{
			return false;
		}
		if($table=="Collection_Report_per_Sales_Rep")
		{
			return false;
		}
		if($table=="Inventory_per_lot_no")
		{
			return false;
		}
		if($table=="marketing_request_form_for_checking")
		{
			return true;
		}
		if($table=="marketing_request_form_for_approval")
		{
			return true;
		}
		if($table=="Accounts_Payable_Dashboard")
		{
			return false;
		}
		if($table=="201")
		{
			return true;
		}
		if($table=="Cashflow_forcast")
		{
			return false;
		}
		if($table=="Business_Owner_Sales_Report")
		{
			return false;
		}
		if($table=="Business_Owner_Purchase_Report")
		{
			return false;
		}
		if($table=="Business_Owner_Cash_Balance")
		{
			return false;
		}
		if($table=="Business_Owner_Top_Customer_Income")
		{
			return false;
		}
		if($table=="AR_Billing_due_dates_Report")
		{
			return false;
		}
		if($table=="AR_Aging_of_AR_Report")
		{
			return false;
		}
		if($table=="AR_Top_5_Customer_balances")
		{
			return false;
		}
		if($table=="AR_Progress_Billing_Alert")
		{
			return false;
		}
		if($table=="Account_Receivable_Dashboard")
		{
			return false;
		}
		if($table=="Finance_Cash_Balance")
		{
			return false;
		}
		if($table=="Finance_approved_request_for_payment")
		{
			return false;
		}
		if($table=="Finance_Cash_flow_forcast")
		{
			return false;
		}
		if($table=="Finance_Approved_Employee_Loan")
		{
			return false;
		}
		if($table=="Finance_Cash_Balances")
		{
			return false;
		}
		if($table=="AP_Aging_of_Payables")
		{
			return false;
		}
		if($table=="Purchasing_Item_below_reorder")
		{
			return false;
		}
		if($table=="production_per_item")
		{
			return false;
		}
		if($table=="AP_Top_5_Supplier_balances")
		{
			return false;
		}
		if($table=="Warehouse_Item_balances")
		{
			return false;
		}
		if($table=="DR_per_Item")
		{
			return false;
		}
		if($table=="Logistic_Open_Trip_Ticket")
		{
			return false;
		}
		if($table=="Logistic_Available_Vehicles")
		{
			return false;
		}
		if($table=="Marketing_Open_Campaign")
		{
			return false;
		}
		if($table=="Marketing_Sales_per_campaign")
		{
			return false;
		}
		if($table=="Support_Open_Case_Report")
		{
			return false;
		}
		if($table=="Support_Service_center")
		{
			return false;
		}
		if($table=="Sale_Meeting_Report")
		{
			return false;
		}
		if($table=="Sales_Next_Action_Report")
		{
			return false;
		}
		if($table=="HR_attendance_summary")
		{
			return false;
		}
		if($table=="HR_Birthday_Alert")
		{
			return false;
		}
		if($table=="HR_holiday")
		{
			return false;
		}
		if($table=="Project_Expense_per_Project")
		{
			return false;
		}
		if($table=="Project_Expense_per_Project_graph")
		{
			return false;
		}
		if($table=="Petty_Cash_Balance")
		{
			return false;
		}
		if($table=="Petty_Cash_Unliquidated")
		{
			return false;
		}
		if($table=="Petty_Cash_Purchases_per_Item")
		{
			return false;
		}
		if($table=="Petty_Cash_Dashboard")
		{
			return false;
		}
		if($table=="Accounting_Income_per_Center")
		{
			return false;
		}
		if($table=="open_quote_Report")
		{
			return false;
		}
		if($table=="Open_cases_per_agent")
		{
			return false;
		}
		if($table=="Marketing_sales_per_campaing_chart")
		{
			return false;
		}
		if($table=="Logistics_Dashboard")
		{
			return false;
		}
		if($table=="Accounting_Dashboard")
		{
			return false;
		}
		if($table=="AP_open_po_receiving")
		{
			return false;
		}
		if($table=="Production_Inventory_Balance_Report")
		{
			return false;
		}
		if($table=="Production_WIP")
		{
			return false;
		}
		if($table=="Warehouse_Dashboard")
		{
			return false;
		}
		if($table=="Warehouse_Inventory_Balance_Report")
		{
			return false;
		}
		if($table=="logistic_open_inventory_tranfer")
		{
			return false;
		}
		if($table=="Sales_Leads")
		{
			return false;
		}
		if($table=="Sales_opportunity_Next_Action")
		{
			return false;
		}
		if($table=="Sales_Active_opportunity")
		{
			return false;
		}
		if($table=="intercompany_sales_order_detail")
		{
			return false;
		}
		if($table=="intercompany_sales_order")
		{
			return true;
		}
		if($table=="production_detail")
		{
			return false;
		}
		if($table=="quality_control_detail_for_checking")
		{
			return true;
		}
		if($table=="lyl_estimate_for_approval")
		{
			return true;
		}
		if($table=="lyl_estimate_dr_for_approval")
		{
			return true;
		}
		if($table=="lyl_estimate_detail_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_aluminum_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_e_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_glass_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_aluminum_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_e_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_glass_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_for_checking")
		{
			return true;
		}
		if($table=="lyl_estimate_detail_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_aluminum_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_e_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_glass_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_for_checking")
		{
			return true;
		}
		if($table=="lyl_estimate_dr_detail_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_aluminum_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_e_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_glass_for_checking")
		{
			return false;
		}
		if($table=="EWT_Certificates_summay")
		{
			return false;
		}
		if($table=="1601e")
		{
			return true;
		}
		if($table=="1601eform")
		{
			return true;
		}
		if($table=="1601fform")
		{
			return true;
		}
		if($table=="tax_person_status")
		{
			return true;
		}
		if($table=="journal_entry_inv_transfer")
		{
			return true;
		}
		if($table=="Recon_withdraw")
		{
			return true;
		}
		if($table=="lot")
		{
			return true;
		}
		if($table=="serial_no")
		{
			return true;
		}
		if($table=="request_for_quote")
		{
			return true;
		}
		if($table=="request_for_quoter_detail")
		{
			return false;
		}
		if($table=="request_for_quote_for_checking")
		{
			return true;
		}
		if($table=="request_for_quote_for_approval")
		{
			return true;
		}
		if($table=="request_for_quoter_detail_for_checking")
		{
			return false;
		}
		if($table=="request_for_quoter_detail_for_approval")
		{
			return false;
		}
		if($table=="estimate_cost")
		{
			return false;
		}
		if($table=="airlines")
		{
			return false;
		}
		if($table=="airport")
		{
			return false;
		}
		if($table=="inco_terms")
		{
			return false;
		}
		if($table=="seaports")
		{
			return false;
		}
		if($table=="shipment_classification")
		{
			return false;
		}
		if($table=="shipping_lines")
		{
			return false;
		}
		if($table=="bal_sales_order_detail")
		{
			return false;
		}
		if($table=="project_cont_seal")
		{
			return false;
		}
		if($table=="project_house")
		{
			return true;
		}
		if($table=="billable_liquidation")
		{
			return false;
		}
		if($table=="billable_pettycash")
		{
			return false;
		}
		if($table=="billable_checkvoucher")
		{
			return false;
		}
		if($table=="projects_dashboard")
		{
			return false;
		}
		if($table=="employees")
		{
			return false;
		}
		if($table=="admin_rights")
		{
			return false;
		}
		if($table=="admin_members")
		{
			return true;
		}
		if($table=="admin_users")
		{
			return true;
		}
		if($table=="company")
		{
			return false;
		}
		if($table=="notifiy quotation Report")
		{
			return false;
		}
		if($table=="expenses Report")
		{
			return false;
		}
		if($table=="petty cash release")
		{
			return true;
		}
		if($table=="petty cash replenishment")
		{
			return true;
		}
		if($table=="Employee Advance Release")
		{
			return true;
		}
		if($table=="Employee Advance Replenishment")
		{
			return true;
		}
		if($table=="Liquidation Release")
		{
			return true;
		}
		if($table=="Liquidation Replenishment")
		{
			return true;
		}
		if($table=="Billable Cost Report")
		{
			return false;
		}
		if($table=="centerrep_pettycash")
		{
			return false;
		}
		if($table=="centerrep_empadvance")
		{
			return false;
		}
		if($table=="centerrep_liquidation")
		{
			return false;
		}
		if($table=="replenishment_pettycash")
		{
			return false;
		}
		if($table=="replenishment_liquidation")
		{
			return false;
		}
		if($table=="replenishment_empadv")
		{
			return false;
		}
		if($table=="bank_statement")
		{
			return false;
		}
		if($table=="other_charges")
		{
			return false;
		}
		if($table=="change_password")
		{
			return true;
		}
		if($table=="project_liquidation_detail2")
		{
			return false;
		}
		if($table=="balance_advance")
		{
			return false;
		}
		if($table=="project_replenishment_deposited")
		{
			return true;
		}
		if($table=="bal_center_replenishment")
		{
			return false;
		}
		if($table=="Project and Pettycash Report")
		{
			return false;
		}
		if($table=="Project and EmpAdv Report")
		{
			return false;
		}
		if($table=="Project and Liquidation Report")
		{
			return false;
		}
		if($table=="Project and Sales Report")
		{
			return false;
		}
		if($table=="Project and Voucher Report")
		{
			return false;
		}
		if($table=="projects_view")
		{
			return true;
		}
		if($table=="projects_lite")
		{
			return true;
		}
		if($table=="shipping_date")
		{
			return false;
		}
		if($table=="entry_detail_sales")
		{
			return false;
		}
		if($table=="entry_detail_pettycash")
		{
			return false;
		}
		if($table=="entry_detail_cash_disbursement")
		{
			return false;
		}
		if($table=="representative")
		{
			return false;
		}
		if($table=="sales_sub_invoice")
		{
			return false;
		}
		if($table=="search_cash_disbursement")
		{
			return false;
		}
		if($table=="sales_business_partner")
		{
			return true;
		}
		if($table=="canvas")
		{
			return true;
		}
		if($table=="canvas_detail")
		{
			return false;
		}
		if($table=="request_for_payment")
		{
			return false;
		}
		if($table=="request_for_payment_detail")
		{
			return false;
		}
		if($table=="po_netpr")
		{
			return false;
		}
		if($table=="request_for_payment_imp")
		{
			return false;
		}
		if($table=="birsalesrelief")
		{
			return false;
		}
	}
	
	protected function insert($datetime, $ip, $user, $table, $action, $description)
	{
		$sql = "INSERT INTO " .$this->connection->addTableWrappers( $this->logTableName ).
			" (" .$this->connection->addFieldWrappers("datetime").
			"," .$this->connection->addFieldWrappers("ip").
			"," .$this->connection->addFieldWrappers("user").
			"," .$this->connection->addFieldWrappers("table"). 
			"," .$this->connection->addFieldWrappers("action").
			"," .$this->connection->addFieldWrappers("description").
			") VALUES (" .$this->connection->addDateQuotes($datetime).
			"," .$this->connection->prepareString($ip). 
			"," .$this->connection->prepareString($user).
			"," .$this->connection->prepareString($table).
			"," .$this->connection->prepareString($action). 
			"," .$this->connection->prepareString($description).
			")";
		
		return $this->connection->exec( $sql );
	}
}

class AuditTrailFile
{
	var $logfile="audit.log";
	var $strLogin="login";
	var $strFailLogin="failed login";
	var $strLogout="logout";
	var $strChPass="change password";
	var $strAdd="add";
	var $strEdit="edit";
	var $strDelete="delete";
	var $strAccess="access";
	var $strKeysHeader="---Keys";
	var $strFieldsHeader="---Fields";
	var $columnDate="Date";
	var $columnTime="Time";
	var $columnIP="IP";
	var $columnUser="User";
	var $columnTable="Table";
	var $columnAction="Action";
	var $columnKey="Key field";
	var $columnField="Field";
	var $columnOldValue="Old value";
	var $columnNewValue="New value";
	var $params;
	var $maxFieldLength = 300;
	
	function AuditTrailFile()
	{
		$userid="";
		if(@$_SESSION["UserID"])
			$userid=$_SESSION["UserID"];
		$this->params=array($_SERVER["REMOTE_ADDR"],$userid);
	}
	
    function LogLogin($pUsername)
    {
		    }
	
    function LogLoginFailed($pUsername)
    {
		    }
	
    function LogLogout()
    {
    }
	
    function LogChPassword()
    {
    }
	
    function LogAdd($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strAdd, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			if(count($keys)>0)
			{
				$key="";
				foreach($keys as $idx=>$val)
				{
					if($key!="")
						$key.=",";
					$key.=$val;
				}
			}

			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strAdd.chr(9).$key;
			$str_add="";
			if($this->logValueEnable($str_table))
			{
				foreach($values as $idx=>$val)
				{
					if($val!="" && !array_key_exists($idx,$keys))
					{
						$v="";
						if(IsBinaryType($pSet->getFieldType($idx)))
							$v="<binary value>"."\r\n";
						else
						{
							$v=str_replace(array("\r\n","\n","\t")," ",$val);
							if(strlen($v)>$this->maxFieldLength)
								$v=runner_substr($v,0,$this->maxFieldLength);
						}
						$str_add.=$str.chr(9).$idx.chr(9).chr(9).$v."\r\n";
					}
				}
			}
			else
				$str_add.=$str."\r\n";
			
			$this->writeToLogFile( $str_add );
		}
		return $retval;
    }
	
    function LogEdit($str_table,$newvalues,$oldvalues,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strEdit, $this->params, $table, $keys, $newvalues, $oldvalues);
		if($retval)
		{
			if(count($keys)>0)
			{
				$key="";
				foreach($keys as $idx=>$val)
				{
					if($key!="")
						$key.=",";
					$key.=$val;
				}
			}

			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strEdit.chr(9).$key;
			$putsValue=true;
			$str_add="";
			if($this->logValueEnable($str_table))
			{
				foreach($newvalues as $idx=>$val)
				{
					$type=$pSet->getFieldType($idx);
					if(IsBinaryType($type))
						continue;
					if(IsDateFieldType($type))
					{
						$newvalue=format_datetime_custom(db2time($newvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
						$oldvalue=format_datetime_custom(db2time($oldvalues[$idx]),"yyyy-MM-dd HH:mm:ss");
					}
					else
					{
						$newvalue=$newvalues[$idx];
						$oldvalue=$oldvalues[$idx];
					}
					if($newvalue!=$oldvalue)
					{
						$v1="";
						if(IsBinaryType($type))
							$v1="<binary value>";
						else
						{
							$v1=str_replace(array("\r\n","\n","\t")," ",$oldvalue);
							if(strlen($v1)>$this->maxFieldLength)
								$v1=runner_substr($v1,0,$this->maxFieldLength);
						}
						
						$v2="";
						if(IsBinaryType($type))
							$v2="<binary value>";
						else
						{
							$v2=str_replace(array("\r\n","\n","\t")," ",$newvalue);
							if(strlen($v2)>$this->maxFieldLength)
								$v2=runner_substr($v2,0,$this->maxFieldLength);
						}
						$str_add.=$str.chr(9).$idx.chr(9).$v1.chr(9).$v2."\r\n";
					}
				}
			}
			else
				$str_add.=$str."\r\n";
			$this->writeToLogFile( $str_add );
		}
		return $retval;
    }
	
    function LogDelete($str_table,$values,$keys)
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$pSet = new ProjectSettings($str_table);
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($this->strDelete, $this->params, $table, $keys, $values, $arr);
		if($retval)
		{
			if(count($keys)>0)
			{
				$key="";
				foreach($keys as $idx=>$val)
				{
					if($key!="")
						$key.=",";
					$key.=$val;
				}
			}
			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$this->params[0].chr(9).$this->params[1].chr(9).$table.chr(9).$this->strDelete.chr(9).$key;
			$str_add="";
			if($this->logValueEnable($str_table))
			{
				foreach($values as $idx=>$val)
				{
					$v="";
					if(IsBinaryType($pSet->getFieldType($idx)))
						$v="<binary value>";
					else
					{
						$v=str_replace(array("\r\n","\n","\t")," ",$val);
						if(strlen($v)>$this->maxFieldLength)
							$v=runner_substr($v,0,$this->maxFieldLength);
					}
					$str_add.=$str.chr(9).$idx.chr(9).$v."\r\n";
				}
			}
			else
				$str_add=$str."\r\n";
				
			$this->writeToLogFile( $str_add );
		}
		return $retval;
    }
	
	function writeToLogFile( $str )
	{
		$p=strrpos($this->logfile,".");
		$logfileName=runner_substr($this->logfile,0,$p);
		$logfileExt=runner_substr($this->logfile,$p+1, strlen($this->logfile)-1);
		$tn=$logfileName."_".format_datetime_custom(db2time(now()),"yyyyMMdd").".".$logfileExt;
		
		$fullname = getabspath($tn);
		$fsize = 0;
		if (file_exists($fullname)){
			$fsize = filesize($fullname);
		}
		$str_to_append = "";
		if( !$fsize )
		{
			$str_to_append = $this->columnDate.chr(9).$this->columnTime.chr(9).$this->columnIP.chr(9).$this->columnUser.chr(9).$this->columnTable.chr(9).$this->columnAction.chr(9).$this->columnKey.chr(9).$this->columnField.chr(9).$this->columnOldValue.chr(9).$this->columnNewValue."\r\n";
		}
		$str_to_append .= $str;
		append_to_file( $fullname, $str_to_append );
		
	}
	
	function LogAddEvent($message,$description="",$str_table="")
    {
		global $globalEvents;
		$retval=true;
		$table=$str_table;
		$arr=array();
		if($globalEvents->exists("OnAuditLog"))
			$retval=$globalEvents->OnAuditLog($message, $this->params, $table, $arr, $arr, $arr);
		if($retval)
		{
			$str=format_datetime_custom(db2time(now()),"MMM dd,yyyy").chr(9).format_datetime_custom(db2time(now()),"HH:mm:ss").chr(9).$params[0].chr(9).$params[1].chr(9).$table.chr(9).$message.chr(9).$description."\r\n";
			$this->writeToLogFile( $str );
		}
		return $retval;
    }
    
    function LoginAccess()
	{
		return false;
	}
	
	function LoginSuccessful()
    {
		return true;
    }
	
    function LoginUnsuccessful($pUsername)
    {	
		return true;
	}
	
	function logValueEnable($table)
	{
		if($table=="business_partner")
		{
			return true;
		}
		if($table=="item")
		{
			return true;
		}
		if($table=="credit_terms")
		{
			return true;
		}
		if($table=="shipping_terms")
		{
			return true;
		}
		if($table=="cash_receipt")
		{
			return true;
		}
		if($table=="purchase")
		{
			return true;
		}
		if($table=="cash_disbursment")
		{
			return true;
		}
		if($table=="general_journal")
		{
			return true;
		}
		if($table=="report_center")
		{
			return true;
		}
		if($table=="Sales Report")
		{
			return true;
		}
		if($table=="Disbursement Reports")
		{
			return true;
		}
		if($table=="Financial Reports")
		{
			return true;
		}
		if($table=="Purchase Reports")
		{
			return true;
		}
		if($table=="Receivable Reports")
		{
			return true;
		}
		if($table=="Taxation Reports")
		{
			return true;
		}
		if($table=="system_user")
		{
			return true;
		}
		if($table=="fiscal_year")
		{
			return true;
		}
		if($table=="beg_bal")
		{
			return true;
		}
		if($table=="ewt")
		{
			return true;
		}
		if($table=="bank")
		{
			return true;
		}
		if($table=="cost_center")
		{
			return true;
		}
		if($table=="General Journal Reports")
		{
			return true;
		}
		if($table=="Inventory Reports")
		{
			return true;
		}
		if($table=="accounting_period")
		{
			return true;
		}
		if($table=="bank_recon")
		{
			return true;
		}
		if($table=="deposit")
		{
			return true;
		}
		if($table=="account_classification")
		{
			return true;
		}
		if($table=="chart_of_accounts")
		{
			return true;
		}
		if($table=="recon_CR")
		{
			return true;
		}
		if($table=="Recon_deposit")
		{
			return true;
		}
		if($table=="Recon_CV")
		{
			return true;
		}
		if($table=="Recon_GV_dep")
		{
			return true;
		}
		if($table=="Recon_GV_CV")
		{
			return true;
		}
		if($table=="vat_atc")
		{
			return true;
		}
		if($table=="rdo")
		{
			return true;
		}
		if($table=="2550q")
		{
			return true;
		}
		if($table=="2550m")
		{
			return true;
		}
		if($table=="dr")
		{
			return true;
		}
		if($table=="purchase_order")
		{
			return true;
		}
		if($table=="purchase_order_receiving")
		{
			return true;
		}
		if($table=="System_preference")
		{
			return true;
		}
		if($table=="ppe_list")
		{
			return true;
		}
		if($table=="discounts")
		{
			return true;
		}
		if($table=="item_group")
		{
			return true;
		}
		if($table=="location")
		{
			return true;
		}
		if($table=="meetings")
		{
			return true;
		}
		if($table=="calls")
		{
			return true;
		}
		if($table=="campaign")
		{
			return true;
		}
		if($table=="reimbursement")
		{
			return true;
		}
		if($table=="reimbursement_detail")
		{
			return false;
		}
		if($table=="Target_customers")
		{
			return true;
		}
		if($table=="quotation")
		{
			return true;
		}
		if($table=="case")
		{
			return true;
		}
		if($table=="projects")
		{
			return true;
		}
		if($table=="production")
		{
			return true;
		}
		if($table=="issue")
		{
			return true;
		}
		if($table=="issue_detail")
		{
			return false;
		}
		if($table=="disposed")
		{
			return true;
		}
		if($table=="disposed_detail")
		{
			return false;
		}
		if($table=="backload")
		{
			return true;
		}
		if($table=="backload_detail")
		{
			return false;
		}
		if($table=="vehicle")
		{
			return true;
		}
		if($table=="payroll_item")
		{
			return true;
		}
		if($table=="uom")
		{
			return true;
		}
		if($table=="trip_ticket")
		{
			return true;
		}
		if($table=="accident")
		{
			return true;
		}
		if($table=="approver_list")
		{
			return true;
		}
		if($table=="area")
		{
			return true;
		}
		if($table=="attendance")
		{
			return true;
		}
		if($table=="currency")
		{
			return true;
		}
		if($table=="medical")
		{
			return true;
		}
		if($table=="position")
		{
			return true;
		}
		if($table=="service_center")
		{
			return true;
		}
		if($table=="seminar")
		{
			return true;
		}
		if($table=="service_report")
		{
			return true;
		}
		if($table=="service_report_detail")
		{
			return false;
		}
		if($table=="tax_status")
		{
			return true;
		}
		if($table=="training")
		{
			return true;
		}
		if($table=="competitor")
		{
			return true;
		}
		if($table=="campaign_type")
		{
			return true;
		}
		if($table=="fixed_asset_return_detail")
		{
			return false;
		}
		if($table=="fixed_assets_return")
		{
			return true;
		}
		if($table=="Prospect_customers")
		{
			return true;
		}
		if($table=="trip_detail")
		{
			return true;
		}
		if($table=="beg_baldetail")
		{
			return true;
		}
		if($table=="cash_disbursement_detail2")
		{
			return false;
		}
		if($table=="case_solutions")
		{
			return true;
		}
		if($table=="cash_disbursment_detail")
		{
			return false;
		}
		if($table=="cash_receipt_detail")
		{
			return false;
		}
		if($table=="cash_receipt_detail2")
		{
			return false;
		}
		if($table=="general_journal_detail")
		{
			return false;
		}
		if($table=="employee_list")
		{
			return true;
		}
		if($table=="petty_cash")
		{
			return true;
		}
		if($table=="petty_cash_detail")
		{
			return false;
		}
		if($table=="center_replenishment")
		{
			return true;
		}
		if($table=="center_replenishment_detail")
		{
			return false;
		}
		if($table=="credit_memo")
		{
			return true;
		}
		if($table=="credit_memo_detail")
		{
			return false;
		}
		if($table=="debit_memo")
		{
			return true;
		}
		if($table=="debit_memo_detail")
		{
			return false;
		}
		if($table=="project_replenishment")
		{
			return true;
		}
		if($table=="project_replenishment_detail")
		{
			return false;
		}
		if($table=="business_partner_group")
		{
			return true;
		}
		if($table=="Sales_Representatives")
		{
			return true;
		}
		if($table=="Types_of_leaves")
		{
			return true;
		}
		if($table=="payroll_mode")
		{
			return true;
		}
		if($table=="payroll_account_type")
		{
			return true;
		}
		if($table=="Types_of_Overtime")
		{
			return true;
		}
		if($table=="Types_of_Loan")
		{
			return true;
		}
		if($table=="sales")
		{
			return true;
		}
		if($table=="sales_detail")
		{
			return false;
		}
		if($table=="Payroll_Company_Setup")
		{
			return true;
		}
		if($table=="item_bill_of_materials")
		{
			return true;
		}
		if($table=="item_uom_conversion")
		{
			return true;
		}
		if($table=="tranasactions_for_approval")
		{
			return true;
		}
		if($table=="deposit_detail")
		{
			return false;
		}
		if($table=="purchase_detail")
		{
			return false;
		}
		if($table=="dr_detail")
		{
			return false;
		}
		if($table=="purchase_order_detail")
		{
			return false;
		}
		if($table=="Sales_Order_for_checking")
		{
			return true;
		}
		if($table=="sales_order_detail_for_checking")
		{
			return true;
		}
		if($table=="Sales_Order_for_approval")
		{
			return true;
		}
		if($table=="sales_order_detail_for_approval")
		{
			return true;
		}
		if($table=="Quotation_for_approval")
		{
			return true;
		}
		if($table=="Quotation_for_checking")
		{
			return true;
		}
		if($table=="quotation_detail_for_checking")
		{
			return true;
		}
		if($table=="quotation_detail_for_approval")
		{
			return true;
		}
		if($table=="Reimbursement_for_checking")
		{
			return true;
		}
		if($table=="reimbursement_detail_for_checking")
		{
			return false;
		}
		if($table=="Reimbursement_for_approval")
		{
			return true;
		}
		if($table=="reimbursement_detail_for_approval")
		{
			return false;
		}
		if($table=="Project_Replenishment_for_checking")
		{
			return true;
		}
		if($table=="project_replenishment_detail_for_checking")
		{
			return false;
		}
		if($table=="Project_Replenishment_for_approval")
		{
			return true;
		}
		if($table=="project_replenishment_detail_for_approval")
		{
			return false;
		}
		if($table=="center_replenishment_detail_for_checking")
		{
			return false;
		}
		if($table=="center_replenishment_detail_for_approval")
		{
			return true;
		}
		if($table=="Purchases_Order_for_checking2")
		{
			return true;
		}
		if($table=="purchase_order_detail_for_checking")
		{
			return false;
		}
		if($table=="Purchases_Order_for_approval2")
		{
			return true;
		}
		if($table=="purchase_order_detail_for_approval")
		{
			return false;
		}
		if($table=="Receiving_for_checking2")
		{
			return true;
		}
		if($table=="purchase_order_receiving_detail_for_checking")
		{
			return false;
		}
		if($table=="Receiving_for_approval2")
		{
			return true;
		}
		if($table=="purchase_order_receiving_detail_for_approval")
		{
			return false;
		}
		if($table=="Delivery_Receipt_for_checking")
		{
			return true;
		}
		if($table=="dr_detail_for_checking")
		{
			return false;
		}
		if($table=="Delivery_Receipt_for_approval")
		{
			return true;
		}
		if($table=="dr_detail_for_approval")
		{
			return false;
		}
		if($table=="Production_for_checking")
		{
			return true;
		}
		if($table=="production_detail_for_checking")
		{
			return false;
		}
		if($table=="Production_for_approval")
		{
			return true;
		}
		if($table=="production_detail_for_approval")
		{
			return false;
		}
		if($table=="Issue_for_checking")
		{
			return true;
		}
		if($table=="supply_issue_detail_for_checking")
		{
			return false;
		}
		if($table=="Issue_for_approval")
		{
			return true;
		}
		if($table=="supply_issue_detail_for_approval")
		{
			return false;
		}
		if($table=="Return_for_checking")
		{
			return true;
		}
		if($table=="supply_return_detail_for_checking")
		{
			return false;
		}
		if($table=="Return_for_approval")
		{
			return true;
		}
		if($table=="supply_return_detail_approval")
		{
			return false;
		}
		if($table=="supply_disposed_detail_for_checking")
		{
			return false;
		}
		if($table=="Disposal_for_approval")
		{
			return true;
		}
		if($table=="supply_disposed_detail_for_approval")
		{
			return false;
		}
		if($table=="Fixed_Asset_Issue_for_checking")
		{
			return true;
		}
		if($table=="Fixed_Asset_Issue_for_approval")
		{
			return true;
		}
		if($table=="fixed_asset_issue_detail_for_approval")
		{
			return false;
		}
		if($table=="fixed_asset_issue_detail_for_checking")
		{
			return false;
		}
		if($table=="Fixed_Asset_Return_for_checking")
		{
			return true;
		}
		if($table=="fixed_asset_return_detail_for_checking")
		{
			return false;
		}
		if($table=="Fixed_Asset_Return_for_approval")
		{
			return true;
		}
		if($table=="fixed_asset_return_detail_for_approval")
		{
			return false;
		}
		if($table=="Petty_Cash_for_checking")
		{
			return true;
		}
		if($table=="petty_cash_detail_for_checking")
		{
			return false;
		}
		if($table=="Petty_Cash_for_approval")
		{
			return true;
		}
		if($table=="petty_cash_detail_for_approval")
		{
			return false;
		}
		if($table=="Deposit_for_checking")
		{
			return true;
		}
		if($table=="deposit_detail_for_checking")
		{
			return false;
		}
		if($table=="Deposit_for_approval")
		{
			return true;
		}
		if($table=="deposit_detail_for_approval")
		{
			return false;
		}
		if($table=="Credit_Memo_for_checking")
		{
			return true;
		}
		if($table=="credit_memo_detail_for_checking")
		{
			return false;
		}
		if($table=="Credit_Memo_for_approval")
		{
			return true;
		}
		if($table=="credit_memo_detail_for_approval")
		{
			return false;
		}
		if($table=="Debit_Memo_for_checking")
		{
			return true;
		}
		if($table=="debit_memo_detail_for_checking")
		{
			return false;
		}
		if($table=="debit_memo_for_approval")
		{
			return true;
		}
		if($table=="debit_memo_detail_for_approval")
		{
			return false;
		}
		if($table=="Purchases_for_checking")
		{
			return true;
		}
		if($table=="credit_purchase_detail_for_checking")
		{
			return false;
		}
		if($table=="Purchases_for_approval")
		{
			return true;
		}
		if($table=="credit_purchase_detail_for_approval")
		{
			return false;
		}
		if($table=="Sales_for_checking")
		{
			return true;
		}
		if($table=="Sales_for_approval")
		{
			return true;
		}
		if($table=="credit_sales_detail_for_checking")
		{
			return false;
		}
		if($table=="credit_sales_detail_for_approval")
		{
			return false;
		}
		if($table=="Cash_Disbursement_for_checking")
		{
			return true;
		}
		if($table=="check_voucher_detail_for_checking")
		{
			return false;
		}
		if($table=="check_voucher_detail2_for_checking")
		{
			return false;
		}
		if($table=="Cash_Disbursement_for_approval")
		{
			return true;
		}
		if($table=="check_voucher_detail_for_approval")
		{
			return false;
		}
		if($table=="check_voucher_detail2_for_approval")
		{
			return false;
		}
		if($table=="document")
		{
			return true;
		}
		if($table=="General_Journal_for_checking")
		{
			return true;
		}
		if($table=="general_journal_detail_for_checking")
		{
			return false;
		}
		if($table=="General_Journal_for_approval")
		{
			return true;
		}
		if($table=="general_journal_detail_for_approval")
		{
			return false;
		}
		if($table=="for_submissions")
		{
			return true;
		}
		if($table=="submission_details")
		{
			return false;
		}
		if($table=="sales_order_detail_billing_dates")
		{
			return false;
		}
		if($table=="Submission_Search")
		{
			return true;
		}
		if($table=="Submission_Reminders")
		{
			return true;
		}
		if($table=="years")
		{
			return true;
		}
		if($table=="document_type")
		{
			return true;
		}
		if($table=="estimate")
		{
			return true;
		}
		if($table=="estimate_detail")
		{
			return false;
		}
		if($table=="purchase_request")
		{
			return true;
		}
		if($table=="purchase_request_detail")
		{
			return false;
		}
		if($table=="inv_adj_detail")
		{
			return false;
		}
		if($table=="inventory_adj")
		{
			return true;
		}
		if($table=="inventory_tranfer")
		{
			return true;
		}
		if($table=="inventory_transfer_detail")
		{
			return false;
		}
		if($table=="Customers")
		{
			return true;
		}
		if($table=="Suppliers")
		{
			return true;
		}
		if($table=="Target_contacts")
		{
			return true;
		}
		if($table=="Prospect_contacts")
		{
			return true;
		}
		if($table=="Customer_Contacts")
		{
			return true;
		}
		if($table=="Supplier_Contacts")
		{
			return true;
		}
		if($table=="Statement_of_Account")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_approval")
		{
			return true;
		}
		if($table=="Change_Time_Schedule_for_checking")
		{
			return true;
		}
		if($table=="Inventory_Adjustment_for_checking")
		{
			return true;
		}
		if($table=="inv_adj_detail_for_checking")
		{
			return false;
		}
		if($table=="Inventory_Adjustment_for_approval")
		{
			return true;
		}
		if($table=="inv_adj_detail_for_approval")
		{
			return false;
		}
		if($table=="for_checking")
		{
			return true;
		}
		if($table=="for_approval")
		{
			return true;
		}
		if($table=="Estimate_for_approval")
		{
			return true;
		}
		if($table=="Estimate_for_checking")
		{
			return true;
		}
		if($table=="estimate_detail_for_checking")
		{
			return false;
		}
		if($table=="estimate_detail_for_approval")
		{
			return false;
		}
		if($table=="Follow_up")
		{
			return true;
		}
		if($table=="coming_meetings")
		{
			return true;
		}
		if($table=="tasks")
		{
			return true;
		}
		if($table=="Project_phases")
		{
			return true;
		}
		if($table=="origin_fa")
		{
			return true;
		}
		if($table=="origin_serialized_supply")
		{
			return true;
		}
		if($table=="2301")
		{
			return true;
		}
		if($table=="Prospect_customers_to_Customer")
		{
			return true;
		}
		if($table=="lyl_estimate")
		{
			return true;
		}
		if($table=="lyl_estimate_detail")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_aluminum")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_e_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_glass")
		{
			return false;
		}
		if($table=="recuring_benefits")
		{
			return true;
		}
		if($table=="recuring_deductions")
		{
			return true;
		}
		if($table=="recurring_benefits_detail")
		{
			return false;
		}
		if($table=="recurring_deductions_detail")
		{
			return false;
		}
		if($table=="production_request")
		{
			return true;
		}
		if($table=="production_request_detail")
		{
			return false;
		}
		if($table=="attendance_summary")
		{
			return true;
		}
		if($table=="Other_Incentives")
		{
			return true;
		}
		if($table=="Other_Deductions")
		{
			return true;
		}
		if($table=="department")
		{
			return true;
		}
		if($table=="journal_entry_cash_disbursement")
		{
			return true;
		}
		if($table=="journal_entry_cash_receipt")
		{
			return true;
		}
		if($table=="journal_entry_center_replenishment")
		{
			return true;
		}
		if($table=="journal_entry_credit_memo")
		{
			return true;
		}
		if($table=="journal_entry_debit_memo")
		{
			return true;
		}
		if($table=="journal_entry_depreciation")
		{
			return true;
		}
		if($table=="journal_entry_general_journal")
		{
			return true;
		}
		if($table=="journal_entry_inventory_adjustment")
		{
			return true;
		}
		if($table=="journal_entry_petty_cash")
		{
			return true;
		}
		if($table=="journal_entry_project_replenishment")
		{
			return true;
		}
		if($table=="journal_entry_purchases")
		{
			return true;
		}
		if($table=="journal_entry_replenishment")
		{
			return true;
		}
		if($table=="journal_entry_service_revenue")
		{
			return true;
		}
		if($table=="Credit_Card_monitoring")
		{
			return true;
		}
		if($table=="sales_report_per_item Chart")
		{
			return false;
		}
		if($table=="Leave_for_approval")
		{
			return true;
		}
		if($table=="loan_for_approval")
		{
			return true;
		}
		if($table=="loan_detail_for_approval")
		{
			return true;
		}
		if($table=="Overtime_for_approval")
		{
			return true;
		}
		if($table=="Purchase_Request_for_approval")
		{
			return true;
		}
		if($table=="purchase_request_detail_approval")
		{
			return false;
		}
		if($table=="Production_Request_for_approval")
		{
			return true;
		}
		if($table=="production_request_detail_for_approval")
		{
			return false;
		}
		if($table=="Inventory_Transfer_for_approval")
		{
			return true;
		}
		if($table=="inventory_transfer_detail_for_approval")
		{
			return false;
		}
		if($table=="Leave_for_checking")
		{
			return true;
		}
		if($table=="Loan_for_checking")
		{
			return true;
		}
		if($table=="loan_detail_for_checking")
		{
			return true;
		}
		if($table=="Overtime_for_checking")
		{
			return true;
		}
		if($table=="Purchase_Request_for_checking")
		{
			return true;
		}
		if($table=="Production_Request_for_checking")
		{
			return true;
		}
		if($table=="Inventory_Transfer_for_checking")
		{
			return true;
		}
		if($table=="inventory_transfer_detail_for_checking")
		{
			return false;
		}
		if($table=="attendance_type")
		{
			return true;
		}
		if($table=="Backload_for_approval")
		{
			return true;
		}
		if($table=="backload_detail_for_approval")
		{
			return false;
		}
		if($table=="Backload_for_checking")
		{
			return true;
		}
		if($table=="backload_detail_for_checking")
		{
			return false;
		}
		if($table=="Cash_Receipt_for_approval")
		{
			return true;
		}
		if($table=="Cash_Receipt_for_checking")
		{
			return true;
		}
		if($table=="cash_receipt_detail_for_checking")
		{
			return false;
		}
		if($table=="cash_receipt_detail_for_approval")
		{
			return false;
		}
		if($table=="Payroll_Entry_for_approval")
		{
			return true;
		}
		if($table=="Payroll_Entry_for_checking")
		{
			return true;
		}
		if($table=="payroll_entry_detail_for_approval")
		{
			return false;
		}
		if($table=="payroll_entry_detail_for_checking")
		{
			return false;
		}
		if($table=="Process_Payroll_for_approval")
		{
			return true;
		}
		if($table=="Process_Payroll_for_checking")
		{
			return true;
		}
		if($table=="process_payroll_detail_for_approval")
		{
			return false;
		}
		if($table=="process_payroll_detail_for_checking")
		{
			return false;
		}
		if($table=="Service_Report_for_approval")
		{
			return true;
		}
		if($table=="Service_Report_for_checking")
		{
			return true;
		}
		if($table=="service_report_detail_for_approval")
		{
			return false;
		}
		if($table=="service_report_detail_for_checking")
		{
			return false;
		}
		if($table=="Banch Reports")
		{
			return true;
		}
		if($table=="journal_entry_production")
		{
			return true;
		}
		if($table=="journal_entry_deposit")
		{
			return true;
		}
		if($table=="production_request_bom")
		{
			return true;
		}
		if($table=="production_bom")
		{
			return true;
		}
		if($table=="company_info")
		{
			return true;
		}
		if($table=="return")
		{
			return true;
		}
		if($table=="return_detail")
		{
			return false;
		}
		if($table=="fixed_asset_issue")
		{
			return true;
		}
		if($table=="fixed_asset_issue_detail")
		{
			return false;
		}
		if($table=="production_request_detail_for_checking")
		{
			return false;
		}
		if($table=="cash_disbursment_detail_for_approval")
		{
			return false;
		}
		if($table=="cash_disbursment_detail_for_checking")
		{
			return false;
		}
		if($table=="purchase_request_detail_for_checking")
		{
			return false;
		}
		if($table=="trip_ticket_for_approval")
		{
			return true;
		}
		if($table=="trip_ticket_for_checking")
		{
			return true;
		}
		if($table=="trip_detail_for_approval")
		{
			return true;
		}
		if($table=="trip_detail_for_checking")
		{
			return true;
		}
		if($table=="sales_report")
		{
			return false;
		}
		if($table=="Customer_Balance_Report")
		{
			return false;
		}
		if($table=="Customer_Balance_Report_detail")
		{
			return false;
		}
		if($table=="Collection_Report_per_Customer")
		{
			return false;
		}
		if($table=="Aging_of_AR_Report")
		{
			return false;
		}
		if($table=="Aging_of_AR_Report_detail")
		{
			return false;
		}
		if($table=="Payment_per_Supplier_Report")
		{
			return false;
		}
		if($table=="Aging of_AP_Report")
		{
			return false;
		}
		if($table=="Aging of_AP_Report_detail")
		{
			return false;
		}
		if($table=="Inventory_Balance_Report")
		{
			return false;
		}
		if($table=="Inventory_Valuation_Report")
		{
			return false;
		}
		if($table=="Inventory_Below_Reorder_Point_Report")
		{
			return false;
		}
		if($table=="Sales_Report_per_BP")
		{
			return false;
		}
		if($table=="Sales_Report_per_Item")
		{
			return false;
		}
		if($table=="Sales_Report_per_Cost_Center")
		{
			return false;
		}
		if($table=="Sales_Report_per_BP_detail")
		{
			return false;
		}
		if($table=="Sales_Report_per_Item_detail")
		{
			return false;
		}
		if($table=="Sales_Report_per_Cost_Center_detail")
		{
			return false;
		}
		if($table=="Purchase_Report")
		{
			return false;
		}
		if($table=="Purchase_Report_per_BP")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Item")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Cost_Center")
		{
			return false;
		}
		if($table=="Purchase_Report_per_BP_detail")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Item_detail")
		{
			return false;
		}
		if($table=="Purchase_Report_per_Cost_Center_detail")
		{
			return false;
		}
		if($table=="Transaction Registry")
		{
			return false;
		}
		if($table=="Sales_Report_per_sales_rep")
		{
			return false;
		}
		if($table=="PDC_Registry_Report")
		{
			return false;
		}
		if($table=="Available_Vehicles")
		{
			return false;
		}
		if($table=="Trip_Ticket_Report")
		{
			return false;
		}
		if($table=="Purchase_Request_Report")
		{
			return false;
		}
		if($table=="Purchase_Import_Costing")
		{
			return false;
		}
		if($table=="Production_Costing_Report")
		{
			return false;
		}
		if($table=="Production_Report")
		{
			return false;
		}
		if($table=="Closed_Opportunities")
		{
			return false;
		}
		if($table=="Cases_with_Sotutions")
		{
			return false;
		}
		if($table=="Totals_Cases_Created")
		{
			return false;
		}
		if($table=="Totals_Open_Cases_by_Agent")
		{
			return false;
		}
		if($table=="Campaign_Contacts")
		{
			return false;
		}
		if($table=="Campaign_leads")
		{
			return false;
		}
		if($table=="Campaign_ROI_Analysis")
		{
			return false;
		}
		if($table=="Campaign_Revenue")
		{
			return false;
		}
		if($table=="Opportunity_Schedule")
		{
			return false;
		}
		if($table=="Sales_by_Account")
		{
			return false;
		}
		if($table=="Sales_by_Lead_Source")
		{
			return false;
		}
		if($table=="Sales_by_Partner")
		{
			return false;
		}
		if($table=="Sales_by_Rep")
		{
			return false;
		}
		if($table=="Leave_Ledger_Report")
		{
			return false;
		}
		if($table=="Leave_Summary")
		{
			return false;
		}
		if($table=="Payroll_Register")
		{
			return false;
		}
		if($table=="Employee_Leave_History")
		{
			return false;
		}
		if($table=="Employee_Register")
		{
			return false;
		}
		if($table=="DR_Reports")
		{
			return false;
		}
		if($table=="Sales_Order_Report")
		{
			return false;
		}
		if($table=="Case_History")
		{
			return false;
		}
		if($table=="quality_control")
		{
			return true;
		}
		if($table=="quality_control_detail")
		{
			return false;
		}
		if($table=="budget")
		{
			return true;
		}
		if($table=="budget_detail")
		{
			return false;
		}
		if($table=="repairs_and_maintenance")
		{
			return true;
		}
		if($table=="production_form")
		{
			return true;
		}
		if($table=="bluewave_employees")
		{
			return true;
		}
		if($table=="bluewave_employees_detail")
		{
			return false;
		}
		if($table=="bluewave_employees_detail2")
		{
			return false;
		}
		if($table=="bluewave_employees_detail3")
		{
			return false;
		}
		if($table=="bluewave_employees_detail4")
		{
			return false;
		}
		if($table=="bluewave_employees_detail5")
		{
			return false;
		}
		if($table=="bluewave_employees_detail6")
		{
			return false;
		}
		if($table=="rfp")
		{
			return true;
		}
		if($table=="telex")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_detail")
		{
			return false;
		}
		if($table=="repair_list")
		{
			return true;
		}
		if($table=="marketing_colateral")
		{
			return true;
		}
		if($table=="email")
		{
			return true;
		}
		if($table=="accessories")
		{
			return true;
		}
		if($table=="sales_order_materials_detail")
		{
			return false;
		}
		if($table=="sales_order_progress_billing_detail")
		{
			return false;
		}
		if($table=="sub_contract")
		{
			return true;
		}
		if($table=="sub_contract_billing_detail")
		{
			return false;
		}
		if($table=="sub_contract_detail")
		{
			return true;
		}
		if($table=="Monthly_Pag-ibig_Summary_Report")
		{
			return false;
		}
		if($table=="Monthly_Philhealth_Report")
		{
			return false;
		}
		if($table=="Monthly_Philhealth_Summary_Report")
		{
			return false;
		}
		if($table=="Monthly_SSS_Report")
		{
			return false;
		}
		if($table=="Monthly_SSS_Report_by_Department_Report")
		{
			return false;
		}
		if($table=="Monthly_Withholding_Tax_Prooflist_Report")
		{
			return false;
		}
		if($table=="Monthly_Witholding_Tax_Collection_List_by_Department_Report")
		{
			return false;
		}
		if($table=="Overtime_Summary_Report")
		{
			return false;
		}
		if($table=="Monthly_Pag-ibig_Report")
		{
			return false;
		}
		if($table=="sales_order")
		{
			return true;
		}
		if($table=="sales_order_detail")
		{
			return false;
		}
		if($table=="vat_relief_importation")
		{
			return true;
		}
		if($table=="vat_relief_purchases")
		{
			return true;
		}
		if($table=="vat_relief_sales")
		{
			return true;
		}
		if($table=="journal_ppe_disposal")
		{
			return true;
		}
		if($table=="credit_memo_detail_cgs")
		{
			return true;
		}
		if($table=="marketing_request_form")
		{
			return true;
		}
		if($table=="Quotation_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Sales_Order_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Delivery_Receipt_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Sales_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Backload_Dashboard_Customer")
		{
			return false;
		}
		if($table=="Purchase_Request_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Purchase_Order_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Purchase_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Cash_Disbursement_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Debit_Memo_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Purchase_Request_Dashboard_Item")
		{
			return false;
		}
		if($table=="Purchase_Order_Dashboard_Item")
		{
			return false;
		}
		if($table=="Purchase_Order_Receiving_Dashboard_Item")
		{
			return false;
		}
		if($table=="Production_Dashboard_Item")
		{
			return false;
		}
		if($table=="sub_contract_for_approval")
		{
			return true;
		}
		if($table=="sub_contract_for_checking")
		{
			return true;
		}
		if($table=="sub_contract_detail_for_approval")
		{
			return true;
		}
		if($table=="sub_contract_detail_for_checking")
		{
			return true;
		}
		if($table=="budget_for_approval")
		{
			return true;
		}
		if($table=="budget_for_checking")
		{
			return true;
		}
		if($table=="budget_detail_for_checking")
		{
			return true;
		}
		if($table=="budget_detail_for_approval")
		{
			return true;
		}
		if($table=="undertime_for_approval")
		{
			return true;
		}
		if($table=="undertime_for_checking")
		{
			return true;
		}
		if($table=="request_for_payment_for_approval")
		{
			return true;
		}
		if($table=="request_for_payment_for_checking")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_detail_for_approval")
		{
			return false;
		}
		if($table=="request_for_payment_detail_for_approval")
		{
			return false;
		}
		if($table=="request_for_payment_detail_for_checking")
		{
			return false;
		}
		if($table=="repairs_and_maintenance_for_approval")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_for_checking")
		{
			return true;
		}
		if($table=="repairs_and_maintenance_detail_for_checking")
		{
			return false;
		}
		if($table=="Disposal_for_checking")
		{
			return true;
		}
		if($table=="Active_campaign_report")
		{
			return false;
		}
		if($table=="For_Billing_report")
		{
			return false;
		}
		if($table=="sales_order_for_project_mngmt")
		{
			return false;
		}
		if($table=="inventory_transfer_cost_detail")
		{
			return false;
		}
		if($table=="Supplier_Balance_Report_Details")
		{
			return false;
		}
		if($table=="Supplier_Balance_Report")
		{
			return false;
		}
		if($table=="Inventory_per_Cost_center_Report")
		{
			return false;
		}
		if($table=="Deposit_Report")
		{
			return false;
		}
		if($table=="SO_for_Billing_Report")
		{
			return false;
		}
		if($table=="Billing_due_dates_Report")
		{
			return false;
		}
		if($table=="Packing_List_Report")
		{
			return false;
		}
		if($table=="Open_Trip_Ticket_Report")
		{
			return false;
		}
		if($table=="Transfer_Report")
		{
			return false;
		}
		if($table=="Production_Report_invw")
		{
			return false;
		}
		if($table=="Supply_per_Department__Report_invw")
		{
			return false;
		}
		if($table=="Item_Balances_Report_invw")
		{
			return false;
		}
		if($table=="Open_Case_Report_s")
		{
			return false;
		}
		if($table=="Sales_Order_per_Campaign_Report_marketing")
		{
			return false;
		}
		if($table=="Sales_per_campaign_Report_marketing")
		{
			return false;
		}
		if($table=="Asset_per_Accountability_Report_invw")
		{
			return false;
		}
		if($table=="Deposit_in_transit_Report")
		{
			return false;
		}
		if($table=="Outstanding_Checks_Report")
		{
			return false;
		}
		if($table=="Absences_Detail_Report")
		{
			return false;
		}
		if($table=="Absences_Report")
		{
			return false;
		}
		if($table=="Attendance_Report")
		{
			return false;
		}
		if($table=="DTR_Report")
		{
			return false;
		}
		if($table=="Summary_of_Tardiness_Report")
		{
			return false;
		}
		if($table=="Followup_Report")
		{
			return false;
		}
		if($table=="Coming_Meeting_Report")
		{
			return false;
		}
		if($table=="Meeting_Report")
		{
			return false;
		}
		if($table=="Next_Action_Report")
		{
			return false;
		}
		if($table=="Calls_Report")
		{
			return false;
		}
		if($table=="sales_per_sales_rep_Report")
		{
			return false;
		}
		if($table=="Expense_per_Project_Report")
		{
			return false;
		}
		if($table=="Tardiness_Report_Summary")
		{
			return false;
		}
		if($table=="Timekeeping_(Hours_Worked)_Report_Summary")
		{
			return false;
		}
		if($table=="Withholding_Tax_Collection_List_per_Month_Report")
		{
			return false;
		}
		if($table=="Business_Owner_Dashboard")
		{
			return false;
		}
		if($table=="Finance_Dashboard")
		{
			return false;
		}
		if($table=="Purchasing_Dashboard")
		{
			return false;
		}
		if($table=="Production_Dashboard")
		{
			return false;
		}
		if($table=="Marketing_Dashboard")
		{
			return false;
		}
		if($table=="Support_Dashboard")
		{
			return false;
		}
		if($table=="Sales_Dashboard")
		{
			return false;
		}
		if($table=="Human_Resource_Dashboard")
		{
			return false;
		}
		if($table=="Project_Manager_Dashboard")
		{
			return false;
		}
		if($table=="System_Admistration_Dashboard")
		{
			return false;
		}
		if($table=="purchase_report_per_item Chart")
		{
			return false;
		}
		if($table=="System_Audit_Report")
		{
			return false;
		}
		if($table=="sale_cost_detail")
		{
			return false;
		}
		if($table=="currency_exchange_rate")
		{
			return true;
		}
		if($table=="cash_receipt_cost_detail")
		{
			return false;
		}
		if($table=="production_cost_detail")
		{
			return false;
		}
		if($table=="Employee")
		{
			return false;
		}
		if($table=="Quotation_Dashboard")
		{
			return false;
		}
		if($table=="Sales_Order_Dashboard")
		{
			return false;
		}
		if($table=="Reimbursement_Dashboard")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_SaleRep")
		{
			return false;
		}
		if($table=="Loan_Dashboard")
		{
			return false;
		}
		if($table=="Leave_Dashboard")
		{
			return false;
		}
		if($table=="Over_Time_Dashboard")
		{
			return false;
		}
		if($table=="Undertime_Dashboard")
		{
			return false;
		}
		if($table=="Fieldwork_Dashboard")
		{
			return false;
		}
		if($table=="Change_Time_Dashboard")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_Employee")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="Transaction_Registry_Dashboard_Customer")
		{
			return false;
		}
		if($table=="lyl_estimate_dr")
		{
			return true;
		}
		if($table=="lyl_estimate_dr_detail")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_aluminum")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_e_accessories")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_glass")
		{
			return false;
		}
		if($table=="sum_dr_qty")
		{
			return true;
		}
		if($table=="check_book_registry")
		{
			return true;
		}
		if($table=="check_book_registry_detail")
		{
			return false;
		}
		if($table=="vat_type")
		{
			return true;
		}
		if($table=="quotation_detail")
		{
			return false;
		}
		if($table=="bal_purchase_order_detail")
		{
			return false;
		}
		if($table=="bal_sales_detail")
		{
			return false;
		}
		if($table=="pending_items_reminders")
		{
			return false;
		}
		if($table=="petty_cash_for_liquidation")
		{
			return false;
		}
		if($table=="payment_method")
		{
			return true;
		}
		if($table=="account_type")
		{
			return true;
		}
		if($table=="phase")
		{
			return true;
		}
		if($table=="item_cost_recalculation")
		{
			return true;
		}
		if($table=="issue_components")
		{
			return true;
		}
		if($table=="issue_components_detail")
		{
			return false;
		}
		if($table=="unbuild_assemblies")
		{
			return true;
		}
		if($table=="unbuild_assemblies_detail")
		{
			return false;
		}
		if($table=="demand_plan")
		{
			return true;
		}
		if($table=="input_vat_allocation")
		{
			return true;
		}
		if($table=="case_type")
		{
			return true;
		}
		if($table=="qc_inspection")
		{
			return true;
		}
		if($table=="packing_list_for_checking")
		{
			return true;
		}
		if($table=="packing_list_for_approval")
		{
			return true;
		}
		if($table=="packing_list_detail_for_checking")
		{
			return false;
		}
		if($table=="packing_list_detail_for_approval")
		{
			return false;
		}
		if($table=="disposed_inv_detail")
		{
			return false;
		}
		if($table=="disposed_inv")
		{
			return true;
		}
		if($table=="disposed_inv_for_checking")
		{
			return true;
		}
		if($table=="disposed_inv_for_approval")
		{
			return true;
		}
		if($table=="disposed_inv_detail_for_checking")
		{
			return false;
		}
		if($table=="disposed_inv_detail_for_approval")
		{
			return false;
		}
		if($table=="For_Approval_Dashboard")
		{
			return false;
		}
		if($table=="For_Checking_Dashboard")
		{
			return false;
		}
		if($table=="Customer_For_Approval")
		{
			return false;
		}
		if($table=="request_for_payment_report")
		{
			return false;
		}
		if($table=="credit_memo_report")
		{
			return false;
		}
		if($table=="debit_memo_report")
		{
			return false;
		}
		if($table=="production_request_report")
		{
			return false;
		}
		if($table=="Supplies_Balance_report")
		{
			return false;
		}
		if($table=="approved_sales_order")
		{
			return false;
		}
		if($table=="purchase_order_for_receiving")
		{
			return false;
		}
		if($table=="Dashboard")
		{
			return false;
		}
		if($table=="packing_list")
		{
			return true;
		}
		if($table=="packing_list_detail")
		{
			return false;
		}
		if($table=="open_quote")
		{
			return true;
		}
		if($table=="open_estimates")
		{
			return true;
		}
		if($table=="open_po")
		{
			return true;
		}
		if($table=="open_pr")
		{
			return true;
		}
		if($table=="open_production_request")
		{
			return true;
		}
		if($table=="open_qc")
		{
			return true;
		}
		if($table=="open_receiving")
		{
			return true;
		}
		if($table=="open_request_for_payment")
		{
			return true;
		}
		if($table=="open_so")
		{
			return true;
		}
		if($table=="open_so_for_invoice")
		{
			return true;
		}
		if($table=="open_so_for_project_management")
		{
			return true;
		}
		if($table=="open_backload")
		{
			return true;
		}
		if($table=="purchase_order_receiving_detail")
		{
			return false;
		}
		if($table=="Purchase_Order_Receiving_Dashboard_Supplier")
		{
			return false;
		}
		if($table=="avg_inv")
		{
			return true;
		}
		if($table=="open_backload_Report")
		{
			return false;
		}
		if($table=="open_estimates_Report")
		{
			return false;
		}
		if($table=="open_po_Report")
		{
			return false;
		}
		if($table=="open_pr_Report")
		{
			return false;
		}
		if($table=="open_production_request_Report")
		{
			return false;
		}
		if($table=="open_qc_Report")
		{
			return false;
		}
		if($table=="open_so_for_project_management_Report")
		{
			return false;
		}
		if($table=="open_so_for_invoice_Report")
		{
			return false;
		}
		if($table=="open_so_Report")
		{
			return false;
		}
		if($table=="open_receiving_Report")
		{
			return false;
		}
		if($table=="monthly_consuption_for_production_Report")
		{
			return false;
		}
		if($table=="issue_components_for_approval")
		{
			return true;
		}
		if($table=="issue_components_for_checking")
		{
			return true;
		}
		if($table=="issue_components_detail_for_checking")
		{
			return false;
		}
		if($table=="issue_components_detail_for_approval")
		{
			return false;
		}
		if($table=="fieldwork_for_approval")
		{
			return true;
		}
		if($table=="fieldwork_for_checking")
		{
			return true;
		}
		if($table=="Purchases_Order_for_checking")
		{
			return true;
		}
		if($table=="Purchases_Order_for_approval")
		{
			return true;
		}
		if($table=="Receiving_for_checking")
		{
			return true;
		}
		if($table=="Receiving_for_approval")
		{
			return true;
		}
		if($table=="inventory_tranfer_Report")
		{
			return false;
		}
		if($table=="Purchase_vs_Production_Report")
		{
			return false;
		}
		if($table=="cash_sales_Report")
		{
			return false;
		}
		if($table=="Center_Replenishment_for_approval")
		{
			return true;
		}
		if($table=="Center_Replenishment_for_checking")
		{
			return true;
		}
		if($table=="Purchase_vs_Production")
		{
			return true;
		}
		if($table=="Production_Summary")
		{
			return false;
		}
		if($table=="pending_production_request")
		{
			return false;
		}
		if($table=="unbuild_assemblies_for_checking")
		{
			return true;
		}
		if($table=="unbuild_assemblies_for_approval")
		{
			return true;
		}
		if($table=="unbuild_assemblies_detail_for_checking")
		{
			return true;
		}
		if($table=="quality_control_for_approval")
		{
			return true;
		}
		if($table=="quality_control_for_checking")
		{
			return true;
		}
		if($table=="quality_control_detail_for_approval")
		{
			return false;
		}
		if($table=="raw_cake_balance")
		{
			return false;
		}
		if($table=="bal_cashreceipt")
		{
			return true;
		}
		if($table=="bal_cashpayment")
		{
			return true;
		}
		if($table=="opportunity")
		{
			return true;
		}
		if($table=="Current_Accounts")
		{
			return true;
		}
		if($table=="bal_lyl_acc")
		{
			return true;
		}
		if($table=="bal_lyl_glass")
		{
			return true;
		}
		if($table=="bal_lyl_eacc")
		{
			return true;
		}
		if($table=="bal_lyl_allum")
		{
			return true;
		}
		if($table=="opportunity_details")
		{
			return false;
		}
		if($table=="Collection_Report_per_Sales_Rep")
		{
			return false;
		}
		if($table=="Inventory_per_lot_no")
		{
			return false;
		}
		if($table=="marketing_request_form_for_checking")
		{
			return true;
		}
		if($table=="marketing_request_form_for_approval")
		{
			return true;
		}
		if($table=="Accounts_Payable_Dashboard")
		{
			return false;
		}
		if($table=="201")
		{
			return true;
		}
		if($table=="Cashflow_forcast")
		{
			return false;
		}
		if($table=="Business_Owner_Sales_Report")
		{
			return false;
		}
		if($table=="Business_Owner_Purchase_Report")
		{
			return false;
		}
		if($table=="Business_Owner_Cash_Balance")
		{
			return false;
		}
		if($table=="Business_Owner_Top_Customer_Income")
		{
			return false;
		}
		if($table=="AR_Billing_due_dates_Report")
		{
			return false;
		}
		if($table=="AR_Aging_of_AR_Report")
		{
			return false;
		}
		if($table=="AR_Top_5_Customer_balances")
		{
			return false;
		}
		if($table=="AR_Progress_Billing_Alert")
		{
			return false;
		}
		if($table=="Account_Receivable_Dashboard")
		{
			return false;
		}
		if($table=="Finance_Cash_Balance")
		{
			return false;
		}
		if($table=="Finance_approved_request_for_payment")
		{
			return false;
		}
		if($table=="Finance_Cash_flow_forcast")
		{
			return false;
		}
		if($table=="Finance_Approved_Employee_Loan")
		{
			return false;
		}
		if($table=="Finance_Cash_Balances")
		{
			return false;
		}
		if($table=="AP_Aging_of_Payables")
		{
			return false;
		}
		if($table=="Purchasing_Item_below_reorder")
		{
			return false;
		}
		if($table=="production_per_item")
		{
			return false;
		}
		if($table=="AP_Top_5_Supplier_balances")
		{
			return false;
		}
		if($table=="Warehouse_Item_balances")
		{
			return false;
		}
		if($table=="DR_per_Item")
		{
			return false;
		}
		if($table=="Logistic_Open_Trip_Ticket")
		{
			return false;
		}
		if($table=="Logistic_Available_Vehicles")
		{
			return false;
		}
		if($table=="Marketing_Open_Campaign")
		{
			return false;
		}
		if($table=="Marketing_Sales_per_campaign")
		{
			return false;
		}
		if($table=="Support_Open_Case_Report")
		{
			return false;
		}
		if($table=="Support_Service_center")
		{
			return false;
		}
		if($table=="Sale_Meeting_Report")
		{
			return false;
		}
		if($table=="Sales_Next_Action_Report")
		{
			return false;
		}
		if($table=="HR_attendance_summary")
		{
			return false;
		}
		if($table=="HR_Birthday_Alert")
		{
			return false;
		}
		if($table=="HR_holiday")
		{
			return false;
		}
		if($table=="Project_Expense_per_Project")
		{
			return false;
		}
		if($table=="Project_Expense_per_Project_graph")
		{
			return false;
		}
		if($table=="Petty_Cash_Balance")
		{
			return false;
		}
		if($table=="Petty_Cash_Unliquidated")
		{
			return false;
		}
		if($table=="Petty_Cash_Purchases_per_Item")
		{
			return false;
		}
		if($table=="Petty_Cash_Dashboard")
		{
			return false;
		}
		if($table=="Accounting_Income_per_Center")
		{
			return false;
		}
		if($table=="open_quote_Report")
		{
			return false;
		}
		if($table=="Open_cases_per_agent")
		{
			return false;
		}
		if($table=="Marketing_sales_per_campaing_chart")
		{
			return false;
		}
		if($table=="Logistics_Dashboard")
		{
			return false;
		}
		if($table=="Accounting_Dashboard")
		{
			return false;
		}
		if($table=="AP_open_po_receiving")
		{
			return false;
		}
		if($table=="Production_Inventory_Balance_Report")
		{
			return false;
		}
		if($table=="Production_WIP")
		{
			return false;
		}
		if($table=="Warehouse_Dashboard")
		{
			return false;
		}
		if($table=="Warehouse_Inventory_Balance_Report")
		{
			return false;
		}
		if($table=="logistic_open_inventory_tranfer")
		{
			return false;
		}
		if($table=="Sales_Leads")
		{
			return false;
		}
		if($table=="Sales_opportunity_Next_Action")
		{
			return false;
		}
		if($table=="Sales_Active_opportunity")
		{
			return false;
		}
		if($table=="intercompany_sales_order_detail")
		{
			return false;
		}
		if($table=="intercompany_sales_order")
		{
			return true;
		}
		if($table=="production_detail")
		{
			return false;
		}
		if($table=="quality_control_detail_for_checking")
		{
			return true;
		}
		if($table=="lyl_estimate_for_approval")
		{
			return true;
		}
		if($table=="lyl_estimate_dr_for_approval")
		{
			return true;
		}
		if($table=="lyl_estimate_detail_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_aluminum_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_e_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_glass_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_aluminum_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_e_accessories_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_glass_for_approval")
		{
			return false;
		}
		if($table=="lyl_estimate_for_checking")
		{
			return true;
		}
		if($table=="lyl_estimate_detail_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_aluminum_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_e_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_detail_glass_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_for_checking")
		{
			return true;
		}
		if($table=="lyl_estimate_dr_detail_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_aluminum_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_e_accessories_for_checking")
		{
			return false;
		}
		if($table=="lyl_estimate_dr_detail_glass_for_checking")
		{
			return false;
		}
		if($table=="EWT_Certificates_summay")
		{
			return false;
		}
		if($table=="1601e")
		{
			return true;
		}
		if($table=="1601eform")
		{
			return true;
		}
		if($table=="1601fform")
		{
			return true;
		}
		if($table=="tax_person_status")
		{
			return true;
		}
		if($table=="journal_entry_inv_transfer")
		{
			return true;
		}
		if($table=="Recon_withdraw")
		{
			return true;
		}
		if($table=="lot")
		{
			return true;
		}
		if($table=="serial_no")
		{
			return true;
		}
		if($table=="request_for_quote")
		{
			return true;
		}
		if($table=="request_for_quoter_detail")
		{
			return false;
		}
		if($table=="request_for_quote_for_checking")
		{
			return true;
		}
		if($table=="request_for_quote_for_approval")
		{
			return true;
		}
		if($table=="request_for_quoter_detail_for_checking")
		{
			return false;
		}
		if($table=="request_for_quoter_detail_for_approval")
		{
			return false;
		}
		if($table=="estimate_cost")
		{
			return false;
		}
		if($table=="airlines")
		{
			return false;
		}
		if($table=="airport")
		{
			return false;
		}
		if($table=="inco_terms")
		{
			return false;
		}
		if($table=="seaports")
		{
			return false;
		}
		if($table=="shipment_classification")
		{
			return false;
		}
		if($table=="shipping_lines")
		{
			return false;
		}
		if($table=="bal_sales_order_detail")
		{
			return false;
		}
		if($table=="project_cont_seal")
		{
			return false;
		}
		if($table=="project_house")
		{
			return true;
		}
		if($table=="billable_liquidation")
		{
			return false;
		}
		if($table=="billable_pettycash")
		{
			return false;
		}
		if($table=="billable_checkvoucher")
		{
			return false;
		}
		if($table=="projects_dashboard")
		{
			return false;
		}
		if($table=="employees")
		{
			return false;
		}
		if($table=="admin_rights")
		{
			return false;
		}
		if($table=="admin_members")
		{
			return true;
		}
		if($table=="admin_users")
		{
			return true;
		}
		if($table=="company")
		{
			return false;
		}
		if($table=="notifiy quotation Report")
		{
			return false;
		}
		if($table=="expenses Report")
		{
			return false;
		}
		if($table=="petty cash release")
		{
			return true;
		}
		if($table=="petty cash replenishment")
		{
			return true;
		}
		if($table=="Employee Advance Release")
		{
			return true;
		}
		if($table=="Employee Advance Replenishment")
		{
			return true;
		}
		if($table=="Liquidation Release")
		{
			return true;
		}
		if($table=="Liquidation Replenishment")
		{
			return true;
		}
		if($table=="Billable Cost Report")
		{
			return false;
		}
		if($table=="centerrep_pettycash")
		{
			return false;
		}
		if($table=="centerrep_empadvance")
		{
			return false;
		}
		if($table=="centerrep_liquidation")
		{
			return false;
		}
		if($table=="replenishment_pettycash")
		{
			return false;
		}
		if($table=="replenishment_liquidation")
		{
			return false;
		}
		if($table=="replenishment_empadv")
		{
			return false;
		}
		if($table=="bank_statement")
		{
			return false;
		}
		if($table=="other_charges")
		{
			return false;
		}
		if($table=="change_password")
		{
			return true;
		}
		if($table=="project_liquidation_detail2")
		{
			return false;
		}
		if($table=="balance_advance")
		{
			return false;
		}
		if($table=="project_replenishment_deposited")
		{
			return true;
		}
		if($table=="bal_center_replenishment")
		{
			return false;
		}
		if($table=="Project and Pettycash Report")
		{
			return false;
		}
		if($table=="Project and EmpAdv Report")
		{
			return false;
		}
		if($table=="Project and Liquidation Report")
		{
			return false;
		}
		if($table=="Project and Sales Report")
		{
			return false;
		}
		if($table=="Project and Voucher Report")
		{
			return false;
		}
		if($table=="projects_view")
		{
			return true;
		}
		if($table=="projects_lite")
		{
			return true;
		}
		if($table=="shipping_date")
		{
			return false;
		}
		if($table=="entry_detail_sales")
		{
			return false;
		}
		if($table=="entry_detail_pettycash")
		{
			return false;
		}
		if($table=="entry_detail_cash_disbursement")
		{
			return false;
		}
		if($table=="representative")
		{
			return false;
		}
		if($table=="sales_sub_invoice")
		{
			return false;
		}
		if($table=="search_cash_disbursement")
		{
			return false;
		}
		if($table=="sales_business_partner")
		{
			return true;
		}
		if($table=="canvas")
		{
			return true;
		}
		if($table=="canvas_detail")
		{
			return false;
		}
		if($table=="request_for_payment")
		{
			return false;
		}
		if($table=="request_for_payment_detail")
		{
			return false;
		}
		if($table=="po_netpr")
		{
			return false;
		}
		if($table=="request_for_payment_imp")
		{
			return false;
		}
		if($table=="birsalesrelief")
		{
			return false;
		}
	}
}
?>