<?php
include_once(getabspath("classes/printpage.php"));

function DisplayMasterTableInfoForPrint_unbuild_assemblies($params)
{
	global $cman;
	
	$detailtable = $params["detailtable"];
	$keys = $params["keys"];
	
	$xt = new Xtempl();
	
	$tName = "unbuild_assemblies";
	$xt->eventsObject = getEventObject($tName);
	
	$mParams  = array();
	$mParams["xt"] = &$xt;
	$mParams["pageType"] = PAGE_PRINT;
	$mParams["tName"] = $tName;
	$masterPage = new PrintPage($mParams);
	
	$cipherer = new RunnerCipherer( $tName );
	$settings = new ProjectSettings($tName, PAGE_PRINT);
	$connection = $cman->byTable( $tName );
	
	$masterQuery = $settings->getSQLQuery();
	$viewControls = new ViewControlsContainer($settings, PAGE_PRINT, $masterPage);
	
	$where = "";
	$keysAssoc = array();
	$showKeys = "";

	if( $detailtable == "unbuild_assemblies_detail" )
	{
		$keysAssoc["id"] = $keys[1-1];
				$where.= RunnerPage::_getFieldSQLDecrypt("id", $connection , $settings , $cipherer) . "=" . $cipherer->MakeDBValue("id", $keys[1-1], "", true);
		
				$keyValue = $viewControls->showDBValue("id", $keysAssoc);
		$showKeys.= " ".GetFieldLabel("unbuild_assemblies","id").": ".$keyValue;
		$xt->assign('showKeys', $showKeys);	
	}
	
	if( !$where )
		return;
	
	$str = SecuritySQL("Export", $tName );
	if( strlen($str) )
		$where.= " and ".$str;
	
	$strWhere = whereAdd( $masterQuery->m_where->toSql($masterQuery), $where );
	if( strlen($strWhere) )
		$strWhere= " where ".$strWhere." ";
		
	$strSQL = $masterQuery->HeadToSql().' '.$masterQuery->FromToSql().$strWhere.$masterQuery->TailToSql();
	LogInfo($strSQL);
	
	$data = $cipherer->DecryptFetchedArray( $connection->query( $strSQL )->fetchAssoc() );
	if( !$data )
		return;
	
	// reassign pagetitlelabel function adding extra params
	$xt->assign_function("pagetitlelabel", "xt_pagetitlelabel", array("record" => $data, "settings" => $settings));	
	
	$keylink = "";
	$keylink.= "&key1=".runner_htmlspecialchars(rawurlencode(@$data["id"]));
	
	$xt->assign("TXNID_mastervalue", $viewControls->showDBValue("TXNID", $data, $keylink));
	$format = $settings->getViewFormat("TXNID");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("TXNID")))
		$class = ' rnr-field-number';
		
	$xt->assign("TXNID_class", $class); // add class for field header as field value
	$xt->assign("Transadate_mastervalue", $viewControls->showDBValue("Transadate", $data, $keylink));
	$format = $settings->getViewFormat("Transadate");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Transadate")))
		$class = ' rnr-field-number';
		
	$xt->assign("Transadate_class", $class); // add class for field header as field value
	$xt->assign("Cost_Center_mastervalue", $viewControls->showDBValue("Cost_Center", $data, $keylink));
	$format = $settings->getViewFormat("Cost_Center");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Cost_Center")))
		$class = ' rnr-field-number';
		
	$xt->assign("Cost_Center_class", $class); // add class for field header as field value
	$xt->assign("Remarks_mastervalue", $viewControls->showDBValue("Remarks", $data, $keylink));
	$format = $settings->getViewFormat("Remarks");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("Remarks")))
		$class = ' rnr-field-number';
		
	$xt->assign("Remarks_class", $class); // add class for field header as field value
	$xt->assign("ref_no_mastervalue", $viewControls->showDBValue("ref_no", $data, $keylink));
	$format = $settings->getViewFormat("ref_no");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("ref_no")))
		$class = ' rnr-field-number';
		
	$xt->assign("ref_no_class", $class); // add class for field header as field value
	$xt->assign("location_mastervalue", $viewControls->showDBValue("location", $data, $keylink));
	$format = $settings->getViewFormat("location");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("location")))
		$class = ' rnr-field-number';
		
	$xt->assign("location_class", $class); // add class for field header as field value
	$xt->assign("approved_by_mastervalue", $viewControls->showDBValue("approved_by", $data, $keylink));
	$format = $settings->getViewFormat("approved_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("approved_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("approved_by_class", $class); // add class for field header as field value
	$xt->assign("checked_by_mastervalue", $viewControls->showDBValue("checked_by", $data, $keylink));
	$format = $settings->getViewFormat("checked_by");
	$class = " rnr-field-text";
	if($format == FORMAT_FILE) 
		$class = ' rnr-field-file'; 
	if($format == FORMAT_AUDIO)
		$class = ' rnr-field-audio';
	if($format == FORMAT_CHECKBOX)
		$class = ' rnr-field-checkbox';
	if($format == FORMAT_NUMBER || IsNumberType($settings->getFieldType("checked_by")))
		$class = ' rnr-field-number';
		
	$xt->assign("checked_by_class", $class); // add class for field header as field value

	$layout = GetPageLayout("unbuild_assemblies", 'masterprint');
	if( $layout )
		$xt->assign("pageattrs", 'class="'.$layout->style." page-".$layout->name.'"');

	$xt->displayPartial(GetTemplateName("unbuild_assemblies", "masterprint"));
}

?>