<?php
class ErrorHandler
{
	var $errorstack = array();
	function handle_mail_error($errno, $errstr, $errfile, $errline)
	{
		if(strpos($errstr,"It is not safe to rely on the system's timezone settings."))
			return;	
		$this->errorstack []= array('number' => $errno, 'description' => $errstr, 'file' => $errfile, 'line' => $errline);
	}
	function getErrorMessage()
	{
		$msg="";
		foreach($this->errorstack as $err)
		{
			if($msg)
				$msg.="\r\n";
			$msg.=$err['description'];
		}
		return $msg;
	}
}

class facebookWrapper
{
	var $fbObj = null;

	function facebookWrapper()
	{
		include_once('plugins/facebook/facebook.php');
		$this->fbObj = new Facebook(array(
			'appId'  => GetGlobalData("FBappId",""),
			'secret' => GetGlobalData("FBappSecret","")
		));
		
	}
	
	function getCookieName()
	{
		return "fbsr_" . GetGlobalData("FBappId","");
	}
	
	function FBgetUserInfo() {
		$fbme = array();
		try {
			$uid = $this->fbObj->getUser();
			$fbme = $this->fbObj->api('/'.$uid);
		} catch (FacebookApiException $e) {
			print_r($e);
		}
		return $fbme;
	}
	
	function FBgetLoginUrl($params=array()){
		$url = "http://";
		if( $_SERVER["HTTPS"] && $_SERVER["HTTPS"] != "off")
			$url = "https://";
		$url .= $_SERVER["HTTP_HOST"] . substr($_SERVER['REQUEST_URI'], 0, strrpos($_SERVER['REQUEST_URI'], '/') + 1) .GetTableLink("login");
		return $this->fbObj->getLoginUrl(array('display'=>'popup', 'redirect_uri'=>$url));
	}
	
	function FBgetSignedRequest(){
		return $this->fbObj->getSignedRequest();
	}
	
	function FBgetAppId(){
		return $this->fbObj->getAppId();
	}
}

/**
	PHPRunner wrapper for mail() function.
	$params array Input paramaters.
	The following parameters are supported:
	'from' Sender email address. If none specified an email address from the wizard will be used.
	'to' Receiver email address.
	'body' Plain text message body.
	'htmlbody' Html message body (do not use 'body' parameter in this case).
	'charset' Html message charset. If none specified the default website charset will be used.
	
	Returns array with data:
	"mailed" - indicates wheter mail sent or not
	"errors" - array of errors
		Each error is an array with the following keys:
		"number" - error number
		"description" - error description
		"file" - name of the php file in which error happened
		"line" - line number on which error happened
 
 * @param Array params
 * @return Array
 * @intellisense		
 */

function runner_mail($params)
{
	$customSMTP = "1";
	if (!GetGlobalData("useBuiltInMailer", false))
	{
		include_once(getabspath('libs/phpmailer/class.phpmailer.php'));
		include_once(getabspath('libs/phpmailer/class.smtp.php'));
		return runner_mail_smtp($params);
	}
	
	$from = isset($params['from']) ? $params['from'] : "";
	if(!$from)
	{
		$from = "info@8box.solutions";
	}
	$to = isset($params['to']) ? $params['to'] : "";
	$body = isset($params['body']) ? $params['body'] : "";
	$cc = isset($params['cc']) ? $params['cc'] : "";
	$bcc = isset($params['bcc']) ? $params['bcc'] : "";
	$replyTo = isset($params['replyTo']) ? $params['replyTo'] : "";
	$priority = isset($params['priority']) ? $params['priority'] : "";
	$charset = "";
	$isHtml = false;
	if(!$body)
	{
		$body = isset($params['htmlbody']) ? $params['htmlbody'] : "";
		$charset = isset($params['charset']) ? $params['charset'] : "";
		if(!$charset)
			$charset = "utf-8";
		$isHtml = true;
	}
	$subject = $params['subject'];

	//
	$header = "";
	if($isHtml)
	{
		$header .= "MIME-Version: 1.0\r\n";
		$header .= 'Content-Type: text/html;' . ( $charset ? ' charset=' . $charset . ';' : '' ) . "\r\n";
	}

	if($from)
	{
		if(strpos($from, '<') !== false)
			$header .= 'From: ' . $from . "\r\n";
		else
			$header .= 'From: <' . $from . ">\r\n";

		@ini_set("sendmail_from", $from);
	}
	if($cc)
		$header .= 'Cc: ' . $cc . "\r\n";
	if($bcc)
		$header .= 'Bcc: ' . $bcc . "\r\n";
	
	if ($priority)
		$header .= 'X-Priority: '.$priority."\r\n";
		
	if($replyTo)
	{
		if(strpos($replyTo, '<') !== false)
			$header .= 'Reply-to: '.$replyTo."\r\n";
		else
			$header .= 'Reply-to: <'.$replyTo.">\r\n";
	}
	
		
	$eh = new ErrorHandler();
	set_error_handler(array($eh, "handle_mail_error"));

	$res = false;
	if(!$header)
	{
		$res = mail($to, $subject, $body);
	}
	else
	{
		$res = mail($to, $subject, $body, $header);
	}
		
	restore_error_handler();
	return array('mailed' => $res, 'errors' => $eh->errorstack, "message"=> nl2br($eh->getErrorMessage()));
}
/**
 * Gets absolute path
 *
 * @param string $path
 * @return string
 * @intellisense
 */
function getabspath($path) 
{
	// get path to the root
	$pathToRoot = substr(dirname(__FILE__),0,strlen(dirname(__FILE__))-strlen("/include"));
	// cheks if there already we have absolute path
	if ($pathToRoot=="" || strpos($path, $pathToRoot) !== false)
		return $path;
	
	// add \ or / if needed
	if (substr($path, 0, 1) != "/" && substr($path, 0, 1) != "\\")
		$pathToRoot .= "/";	
	
	$realPath = $pathToRoot.$path;
	return $realPath;
}

/**
 * Check if the path is absolute or not basing on data
 * obtained from the current file directory's path
 * @param String path
 * @return Boolean 
 */
function isAbsolutePath($path)
{
	if( runner_substr($path, 0, 2) == "\\\\"  )
		return true;
	
	$pathToRoot = dirname(__FILE__);
	
	if( runner_substr($path, 0, 1) == "\/" && runner_substr($pathToRoot, 0, 1) == "\/")
		return true;
	
	$windowsPatter = '/^[a-z]{1}:\\\/i';
	if( preg_match($windowsPatter, $pathToRoot) &&  preg_match($windowsPatter, $path))
		return true;

	return false;
}

/**
 * Gets absolute url
 *
 * @param string $uri
 * @return string
 * @intellisense
 */
function getabsurl($uri) 
{
	$here = 'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
	$realUrl = preg_replace('~#.*$~s', '', $here);
	$realUrl = preg_replace('~\?.*$~s', '', $realUrl);
	$realUrl = preg_replace('~/[^/]*$~s', '/'.$uri, $realUrl);
	return $realUrl;
}

/**
 * @intellisense
 */
function myfile_exists($filename)
{
	$file = @fopen($filename,"rb");
	if($file)
	{
		fclose($file);
		return true;
	}
	else
		return false;
}

/**
 * @intellisense
 */
function try_create_new_file($filename)
{
	$file = @fopen($filename,"x");
	if($file)
	{
		fclose($file);
		return true;
	}
	else
		return false;
}

function append_to_file( $filename, $str )
{
	$h = @fopen( $filename, "a" );
	if( !$h )
		return;
	fputs( $h, $str );
	fclose( $h );
}

//	read the whole file and return contents
/**
 * @intellisense
 */
function myfile_get_contents($filename, $mode = "rb")
{
	if(!is_uploaded_file($filename) && !file_exists($filename))
		return false;
	$handle = fopen($filename, $mode);
	if(!$handle)
		return false;
	fseek($handle, 0 , SEEK_END);
	$fsize = ftell($handle);
	fseek($handle, 0 , SEEK_SET);
	
	if($fsize)
		$contents = fread($handle, $fsize);
	else
		$contents="";
	fclose($handle);
	return $contents;
}

/**
 * @intellisense
 */
function myurl_get_contents($url)
{
	return file_get_contents($url);
}

/**
 * @intellisense
 */
function printfile($filename)
{
	$file = fopen($filename, "rb");
	$bufsize = 8*1024;
	while(!feof($file))
		echo fread($file, $bufsize);
	fclose($file);
}

/**
 * @intellisense
 */
function printfileByRange($filename, $startPos, $endPos)
{
	$fileSize = filesize($filename);
	$length = $endPos - $startPos + 1;
	$file = fopen($filename, "rb");
	if(fseek($file, $startPos) == 0)
	{
		$bufsize = 8*1024;
		if($length < $bufsize)
			$bufsize = $length;
		$totalRead = 0;
		while(!feof($file) && $totalRead < $length)
		{
			//reset time limit for big files
        	set_time_limit(0);
			print(fread($file, $bufsize));
			flush();
			if(ob_get_level())
        		ob_flush();
			$totalRead += $bufsize;
			if($totalRead + $bufsize > $length)
				$bufsize = $length - $totalRead;
		}
	}
	fclose($file);
}

/**
 * @intellisense
 */
function CreateThumbnail($value, $size, $ext)
{	
	if(!function_exists("imagecreatefromstring"))
		return $value;

	$error_handler=set_error_handler("empty_error_handler");
	$image = imagecreatefromstring($value);
	if($error_handler)
		set_error_handler($error_handler);

	if(!$image)
		return $value;
				
	$width_old = imagesx($image);
	$height_old = imagesy($image);	
	
	if($width_old>$size || $height_old>$size){
		if($width_old>=$height_old)
		{
			$final_height=(integer)($height_old*$size/$width_old);
			$final_width=$size;
		}
		else
		{
			$final_width=(integer)($width_old*$size/$height_old);
			$final_height=$size;
		}
		
	 
	    $image_resized = imagecreatetruecolor( $final_width, $final_height );
	 
	    if ($ext==".GIF" || $ext=="GIF" || $ext==".PNG" || $ext=="PNG") {
	      $trnprt_indx = imagecolortransparent($image);
		  
	      // If we have a specific transparent color
	      if ($trnprt_indx >= 0) {
	 		
	     	// when index more than imagecolorstotal may occurs problems with gif
		    $totalColors = imagecolorstotal($image);	      	
		    if ($trnprt_indx>=$totalColors && $totalColors>0){
		    	$trnprt_indx = imagecolorstotal($image)-1;
		    }
	      	
	        // Get the original image's transparent color's RGB values
	        $trnprt_color    = imagecolorsforindex($image, $trnprt_indx);
	 		
	        // Allocate the same color in the new image resource
	        $trnprt_indx    = imagecolorallocatealpha($image_resized, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue'],127);
	        $trnprt_indx    = imagecolorallocate($image_resized, 255,255,255);
	        // Completely fill the background of the new image with allocated color.
	        imagefill($image_resized, 0, 0, $trnprt_indx);
 	 
	        // Set the background color for new image to transparent
	        imagecolortransparent($image_resized, $trnprt_indx);
	 
	      } 
	      // Always make a transparent background color for PNGs that don't have one allocated already
	      elseif ($ext==".PNG" || $ext=="PNG") {
	 
	        // Turn off transparency blending (temporarily)
	        imagealphablending($image_resized, false);
	 
	        // Create a new transparent color for image
	        $color = imagecolorallocatealpha($image_resized, 0, 0, 0, 127);
	 
	        // Completely fill the background of the new image with allocated color.
	        imagefill($image_resized, 0, 0, $color);
	 
	        // Restore transparency blending
	        imagesavealpha($image_resized, true);
	      }
	    }	 	
	 	
	 	imagecopyresampled($image_resized, $image, 0, 0, 0, 0, $final_width, $final_height, $width_old, $height_old);	    
	 	
	    ob_start();
		if($ext==".JPG" || $ext=="JPEG")
			imagejpeg($image_resized);
		elseif($ext==".PNG")
			imagepng($image_resized);
		else
			imagegif($image_resized);
		$ret=ob_get_contents();
		ob_end_clean();
		imagedestroy($image);
		imagedestroy($image_resized);
		return $ret;
	}
	imagedestroy($image);
	return $value;
	
}
/**
 * @intellisense
 */
function mysprintf($format, $params)
{
	$params2 = $params;
	array_unshift($params2, $format);
	return call_user_func_array('sprintf', $params2);
}

/**
 * @intellisense
 */
function now()
{
	return strftime("%Y-%m-%d %H:%M:%S");
}

/**
 * refine value passed by POST or GET method
 * @intellisense
 */
function refine($str)
{
	if(get_magic_quotes_gpc())
		return stripslashes($str);
	return $str;
}

/**
 * suggest image type by extension
 * @intellisense
 */
function SupposeImageType($file)
{
	if(strlen($file)>1 && $file[0]=='B' && $file[1]=='M')
		return "image/bmp";
	if(strlen($file)>2 &&  $file[0]=='G' && $file[1]=='I' && $file[2]=='F')
		return "image/gif";
	if(strlen($file)>3 &&  ord($file[0])==0xff && ord($file[1])==0xd8 && ord($file[2])==0xff)
		return "image/jpeg";
	if(strlen($file)>8 &&  ord($file[0])==0x89 && ord($file[1])==0x50 && ord($file[2])==0x4e && ord($file[3])==0x47
					   &&  ord($file[4])==0x0d && ord($file[5])==0x0a && ord($file[6])==0x1a && ord($file[7])==0x0a)
		return "image/png";
}

/**
 * @intellisense
 */
function prepare_file($value,$field,$controltype,$postfilename, $id)
{
	$filename="";
	$file=&$_FILES["value_".GoodFieldName($field)."_".$id];
	if($file["error"] && $file["error"]!=4)
		return false;
	if(trim($postfilename))
		$filename=refine(trim($postfilename));
	else
		$filename=$file['name'];
	if(substr($controltype,4,1)=="1")
	{
		$filename="";
		return array("filename" => "", "value" => "");
	}
	if(substr($controltype,4,1)=="0")
		return false;
	$ret=myfile_get_contents($file['tmp_name']);
	if(!$ret)
		return false;
	return array("filename" => $filename, "value" => $ret);
}

/**
 * @intellisense
 */
function prepare_upload($field, $controltype, $postfilename, $value, $table, $id, &$pageObject)
{
	$abs = $pageObject->pSet->isAbsolute($field);
	$file=&$_FILES["value_".GoodFieldName($field)."_".$id];
	$sbstr1 = substr($controltype,6,1);
	if($file["error"] || $value == "")
	{
		if($file["error"] != 4  && $sbstr1 != "1")
		return false;
	}	
	if($sbstr1 == "1")
	{
		if(strlen($postfilename))
		{
			$pageObject->filesToDelete[]=new DeleteFile($postfilename, $pageObject->pSet->getUploadFolder($field), $abs);
			if($pageObject->pSet->getCreateThumbnail($field,$table))
				$pageObject->filesToDelete[]=new DeleteFile($pageObject->pSet->getStrThumbnail($field).$postfilename, $pageObject->pSet->getUploadFolder($field), $abs);
		}
		return "";
	}
	if(substr($controltype,6,1)=="0")
		return false;
	if(strlen($file['tmp_name']))
	{
		if(!$pageObject->pSet->getResizeOnUpload($field))
		{
			$pageObject->filesToMove[] = new MoveFile($file['tmp_name'],$value, $pageObject->pSet->getUploadFolder($field),$abs);
		}
		else
		{
			$contents = myfile_get_contents($file['tmp_name']);
			$ext = CheckImageExtension($file["name"]);
			$thumb = CreateThumbnail($contents, $pageObject->pSet->getNewImageSize($field), $ext);
			$pageObject->filesToSave[] = new SaveFile($thumb,$value, $pageObject->pSet->getUploadFolder($field),$abs);
		}
	}
	return $value;
}

/**
 * @intellisense
 */
function FieldSubmitted($field)
{
	return in_assoc_array("type_".GoodFieldName($field),$_POST) || in_assoc_array("value_".GoodFieldName($field),$_POST) 
		|| in_assoc_array("value_".GoodFieldName($field),$_FILES);
}

/**
 * @intellisense
 */
function GetUploadedFileContents($name)
{
	return myfile_get_contents($_FILES[$name]['tmp_name']);
}

/**
 * @intellisense
 */
function GetUploadedFileName($name)
{
	return $_FILES[$name]["name"];
}

/**
 * @param &Array values
 * @param &Array blobfields
 * @param RunnerPage pageobject
 * @return Array
 * @intellisense
 */
function PrepareBlobs(&$values, &$blobfields, $pageObject)
{
	$blobs = array();
	
	if( $pageObject->connection->dbType == nDATABASE_Oracle || $pageObject->connection->dbType == nDATABASE_DB2 || $pageObject->connection->dbType == nDATABASE_Informix )
	{
		//	replace blobs with EMPTY_BLOB()
		foreach($blobfields as $bfield)
		{
			$blobs[ $pageObject->getTableField( $bfield ) ] = $values[ $bfield ];
			
			if( $pageObject->connection->dbType == nDATABASE_Oracle )
				$values[ $bfield ] = "EMPTY_BLOB()";
			else
				$values[ $bfield ] = "?";
		}
	}
	else
	{	
		//	no special processing required
		$blobfields = array();
	}

	return $blobs;
}

/**
 * @intellisense
 * @param RunnerPage pageObj
 * @param String strSQL
 * @param &Array blobs
 */
function ExecuteUpdate( &$pageObj, $strSQL, &$blobs )  
{
	$blobTypes = array();
	if( $pageObj->connection->dbType == nDATABASE_Informix )
	{
		foreach($blobs as $fieldname => $fieldvalue)
		{
			$blobTypes[ $fieldname ] = $pageObj->pSet->getFieldType( $fieldname );
		}
	}
	LogInfo($strSQL);
	if( !$pageObj->connection->execWithBlobProcessing( $strSQL, $blobs, $blobTypes ) )
	{
		$pageObj->setDatabaseError( $pageObj->connection->lastError() );
		return false;
	}
	return true;
}

/**
 * @intellisense
 */
function runner_move_uploaded_file($source, $dest)
{
	move_uploaded_file($source, $dest);
}

/**
 * @intellisense
 */
function runner_save_file($filename, $contents)
{
	if(file_exists($filename))
		@unlink($filename);
	$th = fopen($filename, "w");
	fwrite($th, $contents);
	fclose($th);
}

/**
 * @intellisense
 */
function runner_delete_file($file)
{
	if(myfile_exists($file))
		@unlink($file);
}

/**
 * @intellisense
 */
function runner_copy_file($source, $dest)
{
	copy($source, $dest);
}

/**
 * @intellisense
 */
function GetCurrentYear()
{
	$tm=localtime(time(),true);
	return $tm["tm_year"]+1900;
}

/**
 * @intellisense
 */
function sortMembers(&$arr)
{
	usort($arr, "sortfunc_members");
}

/**
 * @intellisense
 */
function sortfunc_members(&$a,&$b)
{
	global $sortgroup,$sortorder;
	$gcount=count($a["usergroup_boxes"]["data"]);
	for($i=0;$i<$gcount;$i++)
		if($a["usergroup_boxes"]["data"][$i]["usergroup_box"]["data"][0]["group"]==$sortgroup)
			break;
	if($i==$gcount || $a["usergroup_boxes"]["data"][$i]["usergroup_box"]["data"][0]["checked"]==$b["usergroup_boxes"]["data"][$i]["usergroup_box"]["data"][0]["checked"])
	{
//	compare by username
		if($a["user"]==$b["user"])
			return 0;
		if($a["user"]>$b["user"])
			return 1;
		return -1;
	}
	if($sortorder=="a" && $a["usergroup_boxes"]["data"][$i]["usergroup_box"]["data"][0]["checked"]=="")
		return 1;
	if($sortorder=="d" && $b["usergroup_boxes"]["data"][$i]["usergroup_box"]["data"][0]["checked"]=="")
		return 1;
	return -1;
}

/**
 * return refined POST or GET value - single value or array
 * @intellisense
 */
function postvalue($name)
{
	if(isset($_POST[$name]))
		$value=$_POST[$name];
	else if(isset($_GET[$name]))
		$value=$_GET[$name];
	else
		return "";
	if(!is_array($value))
		return refine($value);
	$ret=array();
	foreach($value as $key=>$val)
		$ret[$key]=refine($val);
	return $ret;
}

function getCustomMapIcon( $field, $table="")
{
	global $strTableName;
	$icon = "";
	if(!$table)
		$table = $strTableName;
	return $icon;
}

/**
 * return custom expression
 * @intellisense
 */
function CustomExpression($value, $data, $field, $ptype, $table="")
{
	global $strTableName;
	if(!$table)
		$table = $strTableName;
				if($table=="item" && $field=="id")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["itemform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="cash_receipt" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
//$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["ar"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["cash_receipt"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="cash_receipt" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["creceiptform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";;
		return $value;
	}	
				if($table=="cash_receipt" && $field=="print_journal")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_cash_receipt_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Journal</a>";;
		return $value;
	}	
				if($table=="cash_receipt" && $field=="credit_debit_note")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["credit_debit_note"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="cash_receipt" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Cash_Receipt_ERP_v2_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="purchase" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["purchaseform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="purchase" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["purchaseform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="purchase" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Credit_Purchase_ERP_v21_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="Print")
	{
		if($data['status'] ="Approved"){

//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["cashdisform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Voucher</a>";
}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=check1_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Check</a>";
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="check_print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $value['check_print'] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="2307")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=2307_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>2307</a>";;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="wslipt")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=withrawal_slip_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Withdrawal Slip</a>";;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="papplication")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=pay_application_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Pay Application</a>";;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="print_journal")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_cashdisbursement_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Journal</a>";;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_cashdisbursement_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="general_journal" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["gjournalform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}

;
		return $value;
	}	
				if($table=="general_journal" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=General_Journal_ERP_skyfreight_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="report_center" && $field=="Print")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="report_center" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Sales Report" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Disbursement Reports" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Financial Reports" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchase Reports" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Receivable Reports" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Taxation Reports" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="beg_bal" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="General Journal Reports" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Inventory Reports" && $field=="file")
	{
		$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="bank_recon" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="deposit" && $field=="Print")
	{
		if($data['status'] =="Approved"){	
	
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["depositform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
	
}	
	
else	
{	
$value ="";	
}	











;
		return $value;
	}	
				if($table=="deposit" && $field=="Journal")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_deposit_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Journal</a>";;
		return $value;
	}	
				if($table=="deposit" && $field=="Check Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=check_deposit_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
;
		return $value;
	}	
				if($table=="deposit" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=fundtransfer_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="recon_CR" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Cash_Receipt_8boox.rptdesign&txnid=".$data['id']."&ea=".$data['company']."'>Print</a>";;
		return $value;
	}	
				if($table=="Recon_CV" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Cash_Disbursement_8boox.rptdesign=".$data['id']."&ea=".$data['company']."'>Print</a>";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part1")
	{
		$value ="            <div>frm2550q:optAmend:_1=truefrm2550q:optAmend:_1=</div> \r\n
            <div>frm2550q:optAmend:_2=falsefrm2550q:optAmend:_2=</div> \r\n
            <div>frm2550q:RtnMonth=12frm2550q:RtnMonth=</div> \r\n
";
;
		return $value;
	}	
				if($table=="2550q" && $field=="Part2")
	{
		$value ="            <div>frm2550q:AmendedRtnY=falsefrm2550q:AmendedRtnY=</div> \r\n
            <div>frm2550q:AmendedRtnN=truefrm2550q:AmendedRtnN=</div> \r\n
            <div>frm2550q:OptShortPrd1=falsefrm2550q:OptShortPrd1=</div> \r\n
            <div>frm2550q:OptShortPrd2=truefrm2550q:OptShortPrd2=</div> \r\n
";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part3")
	{
		$value ="            <div>frm2550q:OptTreaty1=falsefrm2550q:OptTreaty1=</div>\r\n						
            <div>frm2550q:OptTreaty2=truefrm2550q:OptTreaty2=</div>	\r\n					
            <div>frm2550q:lstTaxTreaty=0frm2550q:lstTaxTreaty=</div>\r\n";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part4")
	{
		$value ="            <div>frm2550q:txtTax16A=0.00frm2550q:txtTax16A=</div>	\r\n					
            <div>frm2550q:txtTax16B=0.00frm2550q:txtTax16B=</div>			\r\n			
            <div>frm2550q:txtTax17=0.00frm2550q:txtTax17=</div>		\r\n				
            <div>frm2550q:txtTax18=0.00frm2550q:txtTax18=</div>		\r\n";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part5")
	{
		$value ="            <div>frm2550q:txtTax20A=0.00frm2550q:txtTax20A=</div>	\r\n					
            <div>frm2550q:txtTax20B=0.00frm2550q:txtTax20B=</div>	\r\n					
            <div>frm2550q:txtTax20C=0.00frm2550q:txtTax20C=</div>	\r\n					
            <div>frm2550q:txtTax20D=0.00frm2550q:txtTax20D=</div>	\r\n					
            <div>frm2550q:txtTax20E=0.00frm2550q:txtTax20E=</div>	\r\n					
            <div>frm2550q:txtTax20F=0.00frm2550q:txtTax20F=</div>	\r\n";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part6")
	{
		$value ="            <div>frm2550q:txtTax21G=0.00frm2550q:txtTax21G=</div> \r\n	
            <div>frm2550q:txtTax21H=0.00frm2550q:txtTax21H=</div>	\r\n
            <div>frm2550q:txtTax21I=0.00frm2550q:txtTax21I=</div>	\r\n
            <div>frm2550q:txtTax21J=0.00frm2550q:txtTax21J=</div>	\r\n
            <div>frm2550q:txtTax21K=0.00frm2550q:txtTax21K=</div>	\r\n
            <div>frm2550q:txtTax21L=0.00frm2550q:txtTax21L=</div>	\r\n
            <div>frm2550q:txtTax21M=0.00frm2550q:txtTax21M=</div>	\r\n
            <div>frm2550q:txtTax21N=0.00frm2550q:txtTax21N=</div>	\r\n
            <div>frm2550q:txtTax21O=0.00frm2550q:txtTax21O=</div>	\r\n
";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part7")
	{
		$value ="            <div>frm2550q:txtTax23B=0.00frm2550q:txtTax23B=</div>
            <div>frm2550q:txtTax23C=0.00frm2550q:txtTax23C=</div>
            <div>frm2550q:txtTax23D=0.00frm2550q:txtTax23D=</div>
            <div>frm2550q:txtTax23E=0.00frm2550q:txtTax23E=</div>
";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part8")
	{
		$value ="            <div>frm2550q:txtTax26A=0.00frm2550q:txtTax26A=</div> \r\n
            <div>frm2550q:txtTax26B=0.00frm2550q:txtTax26B=</div>\r\n
            <div>frm2550q:txtTax26C=0.00frm2550q:txtTax26C=</div>\r\n
            <div>frm2550q:txtTax26D=0.00frm2550q:txtTax26D=</div>\r\n
            <div>frm2550q:txtTax26E=0.00frm2550q:txtTax26E=</div>\r\n
            <div>frm2550q:txtTax26F=0.00frm2550q:txtTax26F=</div>\r\n
            <div>frm2550q:txtTax26G=0.00frm2550q:txtTax26G=</div>\r\n
            <div>frm2550q:txtTax26H=0.00frm2550q:txtTax26H=</div>\r\n
";;
		return $value;
	}	
				if($table=="2550q" && $field=="Part9")
	{
		$value="            <div>frm2550q:txtTax28A=0.00frm2550q:txtTax28A=</div>	\r\n
            <div>frm2550q:txtTax28B=0.00frm2550q:txtTax28B=</div>	\r\n
            <div>frm2550q:txtTax28C=0.00frm2550q:txtTax28C=</div>	\r\n
            <div>frm2550q:txtTax28D=0.00frm2550q:txtTax28D=</div>	\r\n
";;
		return $value;
	}	
				if($table=="2550q" && $field=="part10")
	{
		$value ="            <div>txtinputtaxSched4=0.00txtinputtaxSched4=</div>
            <div>txtTaxableSaleSched4=0.00txtTaxableSaleSched4=</div>
            <div>txtInputTaxnotDirectSched4=0.00txtInputTaxnotDirectSched4=</div>
            <div>txtTotalInputTaxnotDirectSched4=0.00txtTotalInputTaxnotDirectSched4=</div>
            <div>txtTotalSaleSched4=0.00txtTotalSaleSched4=</div>
            <div>txtTotalInputSaletoGovernmentSched4=0.00txtTotalInputSaletoGovernmentSched4=</div>
            <div>txtlessStdTaxSched4=0.00txtlessStdTaxSched4=</div>
            <div>txtTotal20BSched4=0.00txtTotal20BSched4=</div>
            <div>txtinputtaxSched5=0.00txtinputtaxSched5=</div>
            <div>txtTotSaleSched5=0.00txtTotSaleSched5=</div>
            <div>txtAmountInputnotDirectSched5=0.00txtAmountInputnotDirectSched5=</div>
            <div>txtProductnotDirectSched5=0.00txtProductnotDirectSched5=</div>
            <div>txtSumTotalSaleSched5=0.00txtSumTotalSaleSched5=</div>
            <div>txtTotal20CSched5=0.00txtTotal20CSched5=</div>
            <div>txtmodalTotal23A=0.00txtmodalTotal23A=</div>
            <div>txtmodalTotalSched6AppliedCurrent=0.00txtmodalTotalSched6AppliedCurrent=</div>
            <div>txtmodalTotal23B=0.00txtmodalTotal23B=</div>
            <div>txtmodalTotalSched7AppliedCurrent=0.00txtmodalTotalSched7AppliedCurrent=</div> \r\n
            <div>txtmodalTotal23C=0.00txtmodalTotal23C=</div>\r\n
            <div>txtmodalTotalSched8AppliedCurrent=0.00txtmodalTotalSched8AppliedCurrent=</div>\r\n
            <div>txtFinalFlag=0txtFinalFlag=</div>\r\n
            <div>txtEnroll=NtxtEnroll=</div>\r\n
            <div>ebirOnlineConfirmUsername=ebirOnlineConfirmUsername=</div>\r\n
            <div>ebirOnlineUsername=ebirOnlineUsername=</div>\r\n
            <div>ebirOnlineSecret=ebirOnlineSecret=</div>\r\n
            <div>txtEmail=mark@8boxsolutions.comtxtEmail=</div>\r\n
            <div>driveSelectTPExport=0driveSelectTPExport=</div>\r\n
            \r\n
\r\n
            All Rights Reserved BIR 2012.
";;
		return $value;
	}	
				if($table=="dr" && $field=="wo_price")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["wopform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="dr" && $field=="w_price")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["wpform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="dr" && $field=="Print1")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["drpform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="purchase_order" && $field=="Print")
	{
		if($data['status'] ="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["poform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="purchase_order" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=PO_skyfreight_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="purchase_order_receiving" && $field=="Print")
	{
		if($data['status'] ="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["poreceivingform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="purchase_order_receiving" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=PO_Receiving_ERP_v2_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="ppe_list" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="reimbursement" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["breimbursementform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";

}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="reimbursement" && $field=="Print2")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=empsummary_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="reimbursement" && $field=="Print3")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=empdetails_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="reimbursement" && $field=="print_journal")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_reimbursement_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Journal</a>";;
		return $value;
	}	
				if($table=="reimbursement" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=empsummary_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="quotation" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["quoform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="case" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="projects" && $field=="Print2")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=export_air_master.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="projects" && $field=="Print3")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=export_sea_master.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="production" && $field=="Print")
	{
		if($data['status'] ="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["productionform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="issue" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["issueform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="disposed" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["disposedform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="backload" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["backloadform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="backload_detail" && $field=="ref_id")
	{
		$value="";;
		return $value;
	}	
				if($table=="payroll_item" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="trip_ticket" && $field=="print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["tticketform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="accident" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="attendance" && $field=="file")
	{
		$value = "<image src ='../attendancepic/"  . $data["file"] . "' width='200' height ='100' />";
		return $value;
	}	
				if($table=="medical" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="position" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="service_center" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="seminar" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="service_report" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["sreportform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="training" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="fixed_assets_return" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["fixedassetsreturnform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Prospect_customers" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="petty_cash" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pcashform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";

}

else
{
$value ="";
}

;
		return $value;
	}	
				if($table=="petty_cash" && $field=="Summary")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Petty_Cash_Summary_ERP_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&NewParameter=".date('Y-m-d', strtotime($data['Transadate'] . '-1 week'))."&NewParameter1=" . date('Y-m-d', strtotime($data['Transadate'] . '+1 day'))   ."&NewParameter2=".$data['Account No']."&NewParameter3=".$data['Account No']."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";

;
		return $value;
	}	
				if($table=="petty_cash" && $field=="print_journal")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_pettycash_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Journal</a>";;
		return $value;
	}	
				if($table=="petty_cash" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Petty_Cash_ERP_skyfreight_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="center_replenishment" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["centerrepleform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";;
		return $value;
	}	
				if($table=="center_replenishment" && $field=="print_journal")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_centerrep_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Journal</a>";;
		return $value;
	}	
				if($table=="credit_memo" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["creditmemoform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="credit_memo" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Credit_Memo_skyfreight_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="debit_memo" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["debitmemoform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="debit_memo" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Debit_Memo_ERP_v2_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="debit_memo_detail" && $field=="ref_id")
	{
		$value = "";;
		return $value;
	}	
				if($table=="project_replenishment" && $field=="Print")
	{
		if($data['Net_pay'] > -1){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";

}

else
{
$value ="";
};
		return $value;
	}	
				if($table=="project_replenishment" && $field=="Print1")
	{
		if($data['Net_pay'] > -1){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform2"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";

}

else
{
$value ="";
};
		return $value;
	}	
				if($table=="project_replenishment" && $field=="print_journal")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=journal_entry_projectreplenishment_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Journal</a>";;
		return $value;
	}	
				if($table=="project_replenishment" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Project_Replenishment_ERP_v-skyfreight_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="payroll_mode" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="sales" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["salesform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Billing Statement USD and PHP</a>";

}

else
{
$value ="";
};
		return $value;
	}	
				if($table=="sales" && $field=="Print2")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCPHPonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales" && $field=="Print3")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales" && $field=="Print4")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales" && $field=="Print5")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales" && $field=="Statement of Charge PHP only")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCPHPonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Statement of Charge PHP only</a>";
		return $value;
	}	
				if($table=="sales" && $field=="Deposit (Credit) Note PHP only")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Deposit (Credit) Note PHP only</a>";
		return $value;
	}	
				if($table=="sales" && $field=="Statement of Charge w/ USD")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Statement of Charge w/ USD</a>";
		return $value;
	}	
				if($table=="sales" && $field=="Deposit (Credit) Note w/ USD")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Deposit (Credit) Note w/ USD</a>";
		return $value;
	}	
				if($table=="sales" && $field=="billing_total")
	{
		$value = $data["Net_pay"] + $data["Vat_Amount"];
$value = number_format($value, 2);

;
		return $value;
	}	
				if($table=="sales" && $field=="masteriv")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=master_invoice_try3.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales" && $field=="masterivnd")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=master_invoice_try3_no_design.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales" && $field=="subiv")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=sub_invoice_try3.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales" && $field=="subivnd")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=sub_invoice_try3_no_design.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="Sales_Order_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Sales_Order_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Sales_Order_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Sales_Order_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Quotation_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Qoutation_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Quotation_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Qoutation_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Reimbursement_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Reimbursement_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Reimbursement_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Reimbursement_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Project_Replenishment_for_checking" && $field=="Print")
	{
		
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Project_Replenishment_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Project_Replenishment_for_approval" && $field=="Print")
	{
		
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Project_Replenishment_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_Order_for_checking2" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Purchase_Order_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_Order_for_approval2" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Purchase_Order_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Receiving_for_checking2" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "PO_Receiving_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Receiving_for_approval2" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "PO_Receiving_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Delivery_Receipt_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Delivery_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Delivery_Receipt_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Delivery_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Production_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Production_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Production_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Production_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Issue_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Supply_Issue_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Issue_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Supply_Issue_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Return_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Return_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Disposal_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Supply_Dispose_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Fixed_Asset_Issue_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Issue_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Fixed_Asset_Issue_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Issue_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Fixed_Asset_Return_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Return_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Fixed_Asset_Return_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Return_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Petty_Cash_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Petty_Cash_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Petty_Cash_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Petty_Cash_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Deposit_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Deposit_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Deposit_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Deposit_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Credit_Memo_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Credit_Memo_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Credit_Memo_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Credit_Memo_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Debit_Memo_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Debit_Memo_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="debit_memo_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Debit_Memo_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_for_checking" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["apv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_for_checking" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Credit_Purchase_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_for_approval" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["apv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_for_approval" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Credit_Purchase_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Sales_for_checking" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Credit_Sale_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Sales_for_approval" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Credit_Sale_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_checking" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["cv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_checking" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["cv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_checking" && $field=="check_print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $value['check_print'] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_approval" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["cv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_approval" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["cv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_approval" && $field=="check_print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $value['check_print'] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="document" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["gv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="General_Journal_for_checking" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["gv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="General_Journal_for_approval" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["gv"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="estimate" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["estimateform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="purchase_request" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["prequestform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="purchase_request" && $field=="Print2")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Purchase_Request_skyfreight_Capex_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Capex</a>";;
		return $value;
	}	
				if($table=="purchase_request" && $field=="Print3")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Purchase_Request_skyfreight_MPool_S2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>MPool</a>";;
		return $value;
	}	
				if($table=="purchase_request" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Purchase_Request_skyfreight_PRF_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="inventory_adj" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["inventoryadjform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="inventory_tranfer" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["inventorytransform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="inventory_tranfer" && $field=="signature")
	{
		$value = "<image src='../signaturepic/"  . $data["signature"] . "' width='200' height ='100' />";
		return $value;
	}	
				if($table=="Customers" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Suppliers" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Statement_of_Account" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["soaccountform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Statement_of_Account" && $field=="cost_center")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOA_ERP_v3.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Statement_of_Account" && $field=="company")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOA_ERP_v4.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Change_Time_Schedule_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Return_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Change_Time_Schedule_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Return_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Inventory_Adjustment_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Return_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Inventory_Adjustment_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Return_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="for_checking" && $field=="View")
	{
		$value = "<a href='" . str_replace(" ","_",$data["Transaction"]) . "_for_checking_list.php'>View</a>";;
		return $value;
	}	
				if($table=="for_approval" && $field=="View")
	{
		$value = "<a href='" .  str_replace(" ","_",$data["Transaction"]) . "_for_approval_list.php'>View</a>";;
		return $value;
	}	
				if($table=="Estimate_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Qoutation_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Estimate_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Qoutation_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Prospect_customers_to_Customer" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="lyl_estimate" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["lylestimateform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="lyl_estimate" && $field=="Quotation")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=lyl_estimate_quote_ERP_v2.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
;
		return $value;
	}	
				if($table=="production_request" && $field=="Print")
	{
		if($data['status'] ="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["prorequestform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="Leave_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="loan_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Overtime_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchase_Request_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "PO_Receiving_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Production_Request_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Production_Request_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Inventory_Transfer_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Transfer_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Inventory_Transfer_for_approval" && $field=="signature")
	{
		$value = "<image src='../signaturepic/"  . $data["signature"] . "' width='200' height ='100' />";
		return $value;
	}	
				if($table=="Leave_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Loan_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Overtime_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchase_Request_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "PO_Receiving_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Production_Request_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Production_Request_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Inventory_Transfer_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Transfer_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Inventory_Transfer_for_checking" && $field=="signature")
	{
		$value = "<image src='../signaturepic/"  . $data["signature"] . "' width='200' height ='100' />";
		return $value;
	}	
				if($table=="Backload_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["backloadform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="backload_detail_for_approval" && $field=="ref_id")
	{
		$value="";;
		return $value;
	}	
				if($table=="Backload_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["backloadform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="backload_detail_for_checking" && $field=="ref_id")
	{
		$value="";;
		return $value;
	}	
				if($table=="Cash_Receipt_for_approval" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["ar"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Receipt_for_approval" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["creceiptform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Receipt_for_checking" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["ar"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Cash_Receipt_for_checking" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["creceiptform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Payroll_Entry_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["payrollform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Payroll_Entry_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["payrollform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Process_Payroll_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["ppayrollform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Process_Payroll_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["ppayrollform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Service_Report_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["sreportform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Service_Report_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["sreportform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Banch Reports" && $field=="file")
	{
		//$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";

//$value = "<a href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$data['company']."&CostCenter=".  $_SESSION['CC'] . "'>Print</a>";


//$value = "<a target='_blank' href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."'>Print</a>";

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=".$data['file']."&ea=".$_SESSION["ea"]."&CostCenter=".  $_SESSION['CC'] . "'>Print</a>";;
		return $value;
	}	
				if($table=="return" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["returnform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="fixed_asset_issue" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Fixed_Asset_Issue_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="trip_ticket_for_approval" && $field=="print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["tticketform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="trip_ticket_for_checking" && $field=="print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["tticketform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="quality_control" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["qcontrol"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="budget" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["budgetform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="budget" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Budget_ERP_v2_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
				if($table=="repairs_and_maintenance" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["rmaintenanceform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="sales_order" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["sorderform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="vat_relief_importation" && $field=="Reconciliation")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=list_of_importation.rptdesign&txnid=".$data['Vat_period']."&ea=".$_SESSION["ea"]."'>Print</a>";
;
		return $value;
	}	
				if($table=="vat_relief_purchases" && $field=="Reconciliation")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=list_of_purchases.rptdesign&txnid=".$data['Vat_period']."&ea=".$_SESSION["ea"]."'>Print</a>";
;
		return $value;
	}	
				if($table=="vat_relief_sales" && $field=="Reconciliation")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=list_of_sales.rptdesign&txnid=".$data['Vat_period']."&ea=".$_SESSION["ea"]."'>Print</a>";
;
		return $value;
	}	
				if($table=="marketing_request_form" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["mrform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="Disposal_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Supply_Dispose_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Open_Trip_Ticket_Report" && $field=="print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["tticketform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="lyl_estimate_dr" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["lylesdrform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="pending_items_reminders" && $field=="view")
	{
		//$value = "<a href='" . $data["View"] . "'>View</a>";


$value = $data["View"] ;;
		return $value;
	}	
				if($table=="pending_items_reminders" && $field=="Create")
	{
		$value = "<a href='" . $data["view"] . "'>View</a>";;
		return $value;
	}	
				if($table=="issue_components" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["issuecom"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="disposed_inv" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["disinvform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}

;
		return $value;
	}	
				if($table=="For_Approval_Dashboard" && $field=="View")
	{
		$value = "<a href='" .  str_replace(" ","_",$data["Transaction"]) . "_for_approval_list.php'>View</a>";;
		return $value;
	}	
				if($table=="For_Checking_Dashboard" && $field=="View")
	{
		$value = "<a href='" . str_replace(" ","_",$data["Transaction"]) . "_for_checking_list.php'>View</a>";;
		return $value;
	}	
				if($table=="packing_list" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["plist"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
};
		return $value;
	}	
				if($table=="fieldwork_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["fieldworkform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="fieldwork_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["fieldworkform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_Order_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Purchase_Order_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Purchases_Order_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Purchase_Order_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Receiving_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "PO_Receiving_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Receiving_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "PO_Receiving_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Center_Replenishment_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Center_Replenishment_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Center_Replenishment_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Center_Replenishment_ERP.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="quality_control_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["qcform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="quality_control_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["qcform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Current_Accounts" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". "Medtek_salesInvoice.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="marketing_request_form_for_checking" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["mrform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="marketing_request_form_for_approval" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["mrform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
}

else
{
$value ="";
}



;
		return $value;
	}	
				if($table=="logistic_open_inventory_tranfer" && $field=="signature")
	{
		$value = "<image src='../signaturepic/"  . $data["signature"] . "' width='200' height ='100' />";
		return $value;
	}	
				if($table=="lyl_estimate_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["lylestimateform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="lyl_estimate_dr_for_approval" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["lylesdrform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="lyl_estimate_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["lylestimateform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="lyl_estimate_dr_for_checking" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["lylesdrform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="project_house" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=export_air_house.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="project_house" && $field=="Print3")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=export_sea_house.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="petty cash release" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pcashform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}

;
		return $value;
	}	
				if($table=="petty cash release" && $field=="Summary")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Petty_Cash_Summary_ERP.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&NewParameter=".date('Y-m-d', strtotime($data['Transadate'] . '-1 week'))."&NewParameter1=" . date('Y-m-d', strtotime($data['Transadate'] . '+1 day'))   ."&NewParameter2=".$data['Account No']."&NewParameter3=".$data['Account No']."'>Print</a>";

;
		return $value;
	}	
				if($table=="petty cash replenishment" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pcashform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}

;
		return $value;
	}	
				if($table=="petty cash replenishment" && $field=="Summary")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Petty_Cash_Summary_ERP.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&NewParameter=".date('Y-m-d', strtotime($data['Transadate'] . '-1 week'))."&NewParameter1=" . date('Y-m-d', strtotime($data['Transadate'] . '+1 day'))   ."&NewParameter2=".$data['Account No']."&NewParameter3=".$data['Account No']."'>Print</a>";

;
		return $value;
	}	
				if($table=="Employee Advance Release" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["breimbursementform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="Employee Advance Replenishment" && $field=="Print")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["breimbursementform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";

}

else
{
$value ="";
}
;
		return $value;
	}	
				if($table=="Liquidation Release" && $field=="Print")
	{
		
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Liquidation Release" && $field=="Print1")
	{
		
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform2"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Liquidation Replenishment" && $field=="Print")
	{
		
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="Liquidation Replenishment" && $field=="Print1")
	{
		
$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform2"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="project_replenishment_deposited" && $field=="Print")
	{
		if($data['Net_pay'] > -1){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";

}

else
{
$value ="";
};
		return $value;
	}	
				if($table=="project_replenishment_deposited" && $field=="Print1")
	{
		if($data['Net_pay'] > -1){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["pjrepform2"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";

}

else
{
$value ="";
};
		return $value;
	}	
				if($table=="projects_view" && $field=="Print1")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=sky-master.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="projects_view" && $field=="Print2")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=export_air_master.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>"



;
		return $value;
	}	
				if($table=="projects_view" && $field=="Edit")
	{
		$value = "<a href= 'projects_edit.php?editid1=".$data['id']."'>Edit</a>"
;
		return $value;
	}	
				if($table=="projects_view" && $field=="income_statement")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=project_incomestatement.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Income Statement</a>";;
		return $value;
	}	
				if($table=="projects_lite" && $field=="Print2")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=export_air_master.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="projects_lite" && $field=="Print3")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=export_sea_master.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Print")
	{
		//$value ="<a href='cash_sales_Print_print.php?txnid=".$data['id']."'>Print</a>";
if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["salesform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Billing Statement USD and PHP</a>";

}

else
{
$value ="";
};
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Print2")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCPHPonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Print3")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Print4")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Print5")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Statement of Charge PHP only")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCPHPonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Statement of Charge PHP only</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Deposit (Credit) Note PHP only")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNonly.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Deposit (Credit) Note PHP only</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Statement of Charge w/ USD")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=SOCusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Statement of Charge w/ USD</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="Deposit (Credit) Note w/ USD")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=DCNusd.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>Deposit (Credit) Note w/ USD</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="billing_total")
	{
		$value = $data["Net_pay"] + $data["Vat_Amount"];
$value = number_format($value, 2);

;
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="masteriv")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=master_invoice_try3.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="masterivnd")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=master_invoice_try3_no_design.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="subiv")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=sub_invoice_try3.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="subivnd")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=sub_invoice_try3_no_design.rptdesign&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";
		return $value;
	}	
				if($table=="canvas" && $field=="Print")
	{
		$value = "<a href='" . $_SESSION["path"] . "frameset?__report=". $_SESSION["prequestform"] ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."'>Print</a>";;
		return $value;
	}	
				if($table=="canvas" && $field=="EMO")
	{
		if($data['status'] =="Approved"){

$value = "<a href='" . $_SESSION["path"] . "frameset?__report=Purchase_Request_skyfreight_PRF_emo_S2.rptdesign" ."&txnid=".$data['id']."&ea=".$_SESSION["ea"]."&&__dpi=96&__format=pdf&__pageoverflow=2&__overwrite=false'>EMO</a>";



}

else
{
$value ="";
}


;
		return $value;
	}	
	return $value;
}


/**
 * return custom expression for file
 * @intellisense
 */
function fileCustomExpression($file, $data, $field, $ptype, $table="")
{
	$value = "";
	global $strTableName;
	if(!$table)
		$table = $strTableName;
				if($table=="item" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="cash_receipt" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="cash_receipt" && $field=="ewt_certificate")
	{
		;
		return $value;
	}	
				if($table=="purchase" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="cash_disbursment" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="general_journal" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="deposit" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="dr" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="dr" && $field=="signature")
	{
		;
		return $value;
	}	
				if($table=="purchase_order" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="purchase_order_receiving" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="item_group" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="reimbursement" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="quotation" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="issue" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="backload" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="vehicle" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="service_report" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="fixed_assets_return" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="petty_cash" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="center_replenishment" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="credit_memo" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="debit_memo" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="project_replenishment" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="project_replenishment" && $field=="deposit_file")
	{
		;
		return $value;
	}	
				if($table=="sales" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Sales_Order_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Sales_Order_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Quotation_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Quotation_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Reimbursement_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Reimbursement_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Project_Replenishment_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Project_Replenishment_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchases_Order_for_checking2" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchases_Order_for_approval2" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Receiving_for_checking2" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Receiving_for_approval2" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Delivery_Receipt_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Delivery_Receipt_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Production_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Production_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Issue_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Issue_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Return_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Return_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Fixed_Asset_Issue_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Fixed_Asset_Issue_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Fixed_Asset_Return_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Fixed_Asset_Return_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Petty_Cash_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Petty_Cash_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Deposit_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Deposit_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Credit_Memo_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Credit_Memo_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Debit_Memo_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="debit_memo_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchases_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchases_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Sales_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Sales_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Cash_Disbursement_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="General_Journal_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="General_Journal_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="submission_details" && $field=="File")
	{
		;
		return $value;
	}	
				if($table=="estimate" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="purchase_request" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Estimate_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Estimate_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="2301" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_detail" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="production_request" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Credit_Card_monitoring" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Leave_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="loan_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Request_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Production_Request_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Inventory_Transfer_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Leave_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Loan_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Request_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Production_Request_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Inventory_Transfer_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Backload_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Backload_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Cash_Receipt_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Cash_Receipt_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Service_Report_for_approval" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="Service_Report_for_checking" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="return" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="fixed_asset_issue" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Available_Vehicles" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="bluewave_employees" && $field=="Photo_File")
	{
		;
		return $value;
	}	
				if($table=="bluewave_employees" && $field=="Thumbmark_File")
	{
		;
		return $value;
	}	
				if($table=="bluewave_employees" && $field=="File")
	{
		;
		return $value;
	}	
				if($table=="marketing_colateral" && $field=="company")
	{
		;
		return $value;
	}	
				if($table=="sub_contract" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="sales_order" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Quotation_Dashboard_Customer" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Delivery_Receipt_Dashboard_Customer" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Delivery_Receipt_Dashboard_Customer" && $field=="signature")
	{
		;
		return $value;
	}	
				if($table=="Sales_Dashboard_Customer" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Backload_Dashboard_Customer" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Request_Dashboard_Supplier" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Order_Dashboard_Supplier" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Dashboard_Supplier" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Debit_Memo_Dashboard_Supplier" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Request_Dashboard_Item" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Order_Dashboard_Item" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Order_Receiving_Dashboard_Item" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="sub_contract_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="sub_contract_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="request_for_payment_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="request_for_payment_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Deposit_Report" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Deposit_in_transit_Report" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Outstanding_Checks_Report" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="sales_per_sales_rep_Report" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Quotation_Dashboard" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Sales_Order_Dashboard" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Reimbursement_Dashboard" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Loan_Dashboard" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_dr" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_dr_detail" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="issue_components" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="disposed_inv_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="production_request_report" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="approved_sales_order" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="purchase_order_for_receiving" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="issue_components_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="issue_components_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchases_Order_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Purchases_Order_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Receiving_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Receiving_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="cash_sales_Report" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="cash_sales_Report" && $field=="ewt_certificate")
	{
		;
		return $value;
	}	
				if($table=="Center_Replenishment_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Center_Replenishment_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="unbuild_assemblies_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="unbuild_assemblies_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="201" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="DR_per_Item" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="DR_per_Item" && $field=="signature")
	{
		;
		return $value;
	}	
				if($table=="Logistic_Available_Vehicles" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_dr_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_detail_for_approval" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_dr_detail_for_approval" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_detail_for_checking" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_dr_for_checking" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="lyl_estimate_dr_detail_for_checking" && $field=="picture")
	{
		;
		return $value;
	}	
				if($table=="request_for_quote_for_approval" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="notifiy quotation Report" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="petty cash release" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="petty cash replenishment" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Employee Advance Release" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Employee Advance Replenishment" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Liquidation Release" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="Liquidation Replenishment" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="project_replenishment_deposited" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="project_replenishment_deposited" && $field=="deposit_file")
	{
		;
		return $value;
	}	
				if($table=="sales_business_partner" && $field=="file")
	{
		;
		return $value;
	}	
				if($table=="canvas" && $field=="file")
	{
		;
		return $value;
	}	
	return $value;
}

/**
 * return Lookup Wizard Where expression
 * @intellisense
 */
function GetLWWhere($field, $ptype, $table = "")
{
	global $strTableName;
	if(!$table) 
		$table = $strTableName;
				if($table=="item" && $field=="Vat Type")
	{
		return "purchase_only = 0";
	}
				if($table=="item" && $field=="purchase_vat_type")
	{
		return "purchase_only = 1";
	}
				if($table=="cash_receipt" && $field=="bank")
	{
		return " type = 'Receipt' or  type = 'Both'";
	}
				if($table=="cash_receipt" && $field=="ref_no")
	{
		return "Status = 'Approved'";
	}
				if($table=="cash_receipt" && $field=="checked_by")
	{
		return "transaction = 35 AND  type = 'Checker'";
	}
				if($table=="cash_receipt" && $field=="approved_by")
	{
		return "transaction = 35 AND  type = 'Approver'";
	}
				if($table=="purchase" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="purchase" && $field=="approved_by")
	{
		return "transaction = 2 AND  type = 'Approver'";
	}
				if($table=="purchase" && $field=="checked_by")
	{
		return "transaction = 2 AND  type = 'Checker'";
	}
				if($table=="cash_disbursment" && $field=="bank")
	{
		return " type = 'Disbursement' or  type = 'Both'";
	}
				if($table=="cash_disbursment" && $field=="checked_by")
	{
		return "transaction = 3 AND  type = 'Checker'";
	}
				if($table=="cash_disbursment" && $field=="approved_by")
	{
		return "transaction = 3 AND  type = 'Approver'";
	}
				if($table=="general_journal" && $field=="approved_by")
	{
		return "transaction = 4 AND  type = 'Approver'";
	}
				if($table=="general_journal" && $field=="checked_by")
	{
		return "transaction = 4 AND  type = 'Checker'";
	}
				if($table=="bank_recon" && $field=="default_chart_of_account")
	{
		return " `Cash Account` = 1 ";
	}
				if($table=="deposit" && $field=="checked_by")
	{
		return "transaction = 31 AND  type = 'Checker'";
	}
				if($table=="deposit" && $field=="approved_by")
	{
		return "transaction = 31 AND  type = 'Approver'";
	}
				if($table=="recon_CR" && $field=="Business_Partner")
	{
		return " type = 'Customer' ";
	}
				if($table=="Recon_CV" && $field=="Business_Partner")
	{
		return " type = 'Supplier' ";
	}
				if($table=="dr" && $field=="checked_by")
	{
		return "transaction = 12 AND  type = 'Checker'";
	}
				if($table=="dr" && $field=="approved_by")
	{
		return "transaction = 12 AND  type = 'Approver'";
	}
				if($table=="dr" && $field=="driver")
	{
		return " type = 'Employee'";
	}
				if($table=="purchase_order" && $field=="approved_by")
	{
		return "transaction = 11 AND  type = 'Approver'";
	}
				if($table=="purchase_order" && $field=="checked_by")
	{
		return "transaction = 11 AND  type = 'Checker'";
	}
				if($table=="purchase_order_receiving" && $field=="approved_by")
	{
		return "transaction = 36 AND  type = 'Approver'";
	}
				if($table=="purchase_order_receiving" && $field=="checked_by")
	{
		return "transaction = 36 AND  type = 'Checker'";
	}
				if($table=="System_preference" && $field=="default_receipt_bank")
	{
		return " type = 'Receipt' or type = 'Both'";
	}
				if($table=="System_preference" && $field=="default_disbursement_bank")
	{
		return " type = 'Disbursement' or type = 'Both'";
	}
				if($table=="ppe_list" && $field=="vat_type")
	{
		return "purchase_only =1 ";
	}
				if($table=="reimbursement" && $field=="Business_Partner")
	{
		return " type = 'Employee'";
	}
				if($table=="reimbursement" && $field=="checked_by")
	{
		return "transaction = 9 AND  type = 'Checker'";
	}
				if($table=="reimbursement" && $field=="approved_by")
	{
		return "transaction = 9 AND  type = 'Approver'";
	}
				if($table=="reimbursement_detail" && $field=="Description")
	{
		return "`Item Type` <> 'Inventory'";
	}
				if($table=="quotation" && $field=="Business_Partner")
	{
		return "(business_partner.`type` = 'Customer') OR   (business_partner.`type` = 'Opportunity') OR   (business_partner.`type` = 'Customer and Supplier')";
	}
				if($table=="quotation" && $field=="checked_by")
	{
		return "transaction = 8 AND  type = 'Checker'";
	}
				if($table=="quotation" && $field=="approved_by")
	{
		return "transaction = 8 AND  type = 'Approver'";
	}
				if($table=="production" && $field=="approved_by")
	{
		return "transaction = 22 AND  type = 'Approver'";
	}
				if($table=="production" && $field=="checked_by")
	{
		return "transaction = 22 AND  type = 'Checker'";
	}
				if($table=="issue" && $field=="approved_by")
	{
		return "transaction = 13 AND  type = 'Approver'";
	}
				if($table=="issue" && $field=="checked_by")
	{
		return "transaction = 13 AND  type = 'Checker'";
	}
				if($table=="disposed" && $field=="approved_by")
	{
		return "transaction = 24 AND  type = 'Approver'";
	}
				if($table=="disposed" && $field=="checked_by")
	{
		return "transaction = 24 AND  type = 'Checker'";
	}
				if($table=="backload" && $field=="Business_Partner")
	{
		return " type = 'Customer'  Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="backload" && $field=="ref_no")
	{
		return "Status = 'Approved'";
	}
				if($table=="backload" && $field=="approved_by")
	{
		return "transaction = 16 AND  type = 'Approver'";
	}
				if($table=="backload" && $field=="checked_by")
	{
		return "transaction = 16 AND  type = 'Checker'";
	}
				if($table=="backload_detail" && $field=="VAT_Type")
	{
		return "purchase_only =0";
	}
				if($table=="trip_ticket" && $field=="approved_by")
	{
		return "transaction = 19 AND  type = 'Approver'";
	}
				if($table=="trip_ticket" && $field=="checked_by")
	{
		return "transaction = 19 AND  type = 'Checker'";
	}
				if($table=="service_report" && $field=="checked_by")
	{
		return "transaction = 11 AND  type = 'Checker'";
	}
				if($table=="service_report" && $field=="approved_by")
	{
		return "transaction = 11 AND  type = 'Approver'";
	}
				if($table=="service_report_detail" && $field=="VAT_Type")
	{
		return " purchase_only =0 ";
	}
				if($table=="fixed_assets_return" && $field=="approved_by")
	{
		return "transaction = 15 AND  type = 'Approver'";
	}
				if($table=="fixed_assets_return" && $field=="checked_by")
	{
		return "transaction = 15 AND  type = 'Checker'";
	}
				if($table=="cash_disbursement_detail2" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="cash_receipt_detail2" && $field=="VAT_Type")
	{
		return " purchase_only = 0";
	}
				if($table=="petty_cash" && $field=="approved_by")
	{
		return "transaction = 27 AND  type = 'Approver'";
	}
				if($table=="petty_cash" && $field=="checked_by")
	{
		return "transaction = 27 AND  type = 'Checker'";
	}
				if($table=="petty_cash_detail" && $field=="VAT_Type")
	{
		return " purchase_only = 1 ";
	}
				if($table=="center_replenishment" && $field=="approved_by")
	{
		return "transaction = 25 AND  type = 'Approver'";
	}
				if($table=="center_replenishment" && $field=="checked_by")
	{
		return "transaction = 25 AND  type = 'Checker'";
	}
				if($table=="center_replenishment_detail" && $field=="VAT_Type")
	{
		return " purchase_only = 1";
	}
				if($table=="credit_memo" && $field=="checked_by")
	{
		return "transaction = 6 AND  type = 'Checker'";
	}
				if($table=="credit_memo" && $field=="approved_by")
	{
		return "transaction = 6 AND  type = 'Approver'";
	}
				if($table=="credit_memo_detail" && $field=="VAT_Type")
	{
		return " purchase_only = 0 ";
	}
				if($table=="debit_memo" && $field=="approved_by")
	{
		return "transaction = 7 AND  type = 'Approver'";
	}
				if($table=="debit_memo" && $field=="checked_by")
	{
		return "transaction = 7 AND  type = 'Checker'";
	}
				if($table=="project_replenishment" && $field=="Business_Partner")
	{
		return " type = 'Employee'";
	}
				if($table=="project_replenishment" && $field=="approved_by")
	{
		return "transaction = 21 AND  type = 'Approver'";
	}
				if($table=="project_replenishment" && $field=="checked_by")
	{
		return "transaction = 21 AND  type = 'Checker'";
	}
				if($table=="project_replenishment_detail" && $field=="Description")
	{
		return "`Item Type` <> 'Inventory'";
	}
				if($table=="project_replenishment_detail" && $field=="VAT_Type")
	{
		return " purchase_only = 1";
	}
				if($table=="sales" && $field=="checked_by")
	{
		return "transaction = 1 AND  type = 'Checker'";
	}
				if($table=="sales" && $field=="approved_by")
	{
		return "transaction = 1 AND  type = 'Approver'";
	}
				if($table=="sales" && $field=="vattype2")
	{
		return " purchase_only = 0";
	}
				if($table=="sales_detail" && $field=="VAT_Type")
	{
		return " purchase_only = 0";
	}
				if($table=="purchase_detail" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="dr_detail" && $field=="VAT_Type")
	{
		return "purchase_only = 0";
	}
				if($table=="purchase_order_detail" && $field=="Description")
	{
		return "`Item Type` = 'Inventory'";
	}
				if($table=="purchase_order_detail" && $field=="VAT_Type")
	{
		return " purchase_only =1";
	}
				if($table=="project_replenishment_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only = 1";
	}
				if($table=="project_replenishment_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only = 1";
	}
				if($table=="center_replenishment_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only = 1";
	}
				if($table=="center_replenishment_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only = 1";
	}
				if($table=="purchase_order_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only =1";
	}
				if($table=="purchase_order_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only =1";
	}
				if($table=="purchase_order_receiving_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only =1";
	}
				if($table=="purchase_order_receiving_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only =1";
	}
				if($table=="dr_detail_for_checking" && $field=="VAT_Type")
	{
		return "purchase_only = 0";
	}
				if($table=="dr_detail_for_approval" && $field=="VAT_Type")
	{
		return "purchase_only = 0";
	}
				if($table=="petty_cash_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only = 1 ";
	}
				if($table=="petty_cash_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only = 1 ";
	}
				if($table=="credit_memo_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only = 0 ";
	}
				if($table=="credit_memo_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only = 0 ";
	}
				if($table=="Purchases_for_checking" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchases_for_approval" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Sales_for_checking" && $field=="Business_Partner")
	{
		return " type = 'Customer'  Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Sales_for_approval" && $field=="Business_Partner")
	{
		return " type = 'Customer'  Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="credit_sales_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only = 0";
	}
				if($table=="credit_sales_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only = 0";
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="bank")
	{
		return " type = 'Disbursment' or  type = 'Both'";
	}
				if($table=="check_voucher_detail2_for_checking" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="bank")
	{
		return " type = 'Disbursment' or  type = 'Both'";
	}
				if($table=="check_voucher_detail2_for_approval" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="estimate" && $field=="checked_by")
	{
		return "transaction = 29 AND  type = 'Checker'";
	}
				if($table=="estimate" && $field=="approved_by")
	{
		return "transaction = 39 AND  type = 'Approver'";
	}
				if($table=="estimate_detail" && $field=="VAT_Type")
	{
		return "purchase_only = 0";
	}
				if($table=="purchase_request" && $field=="approved_by")
	{
		return "transaction = 30 AND  type = 'Approver'";
	}
				if($table=="purchase_request" && $field=="checked_by")
	{
		return "transaction = 30 AND  type = 'Checker'";
	}
				if($table=="purchase_request_detail" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="inventory_adj" && $field=="checked_by")
	{
		return "transaction = 5 AND  type = 'Checker'";
	}
				if($table=="inventory_adj" && $field=="approved_by")
	{
		return "transaction = 5 AND  type = 'Approver'";
	}
				if($table=="inventory_tranfer" && $field=="approved_by")
	{
		return "transaction = 32 AND  type = 'Approver'";
	}
				if($table=="inventory_tranfer" && $field=="checked_by")
	{
		return "transaction = 32 AND  type = 'Checker'";
	}
				if($table=="Change_Time_Schedule_for_approval" && $field=="approved_by")
	{
		return "transaction = 40 AND  type = 'Approver'";
	}
				if($table=="Change_Time_Schedule_for_checking" && $field=="approved_by")
	{
		return "transaction = 40 AND  type = 'Approver'";
	}
				if($table=="Inventory_Adjustment_for_checking" && $field=="checked_by")
	{
		return "transaction = 6 AND  type = 'Checker'";
	}
				if($table=="Inventory_Adjustment_for_checking" && $field=="approved_by")
	{
		return "transaction = 6 AND  type = 'Approver'";
	}
				if($table=="Inventory_Adjustment_for_approval" && $field=="checked_by")
	{
		return "transaction = 6 AND  type = 'Checker'";
	}
				if($table=="Inventory_Adjustment_for_approval" && $field=="approved_by")
	{
		return "transaction = 6 AND  type = 'Approver'";
	}
				if($table=="Estimate_for_approval" && $field=="checked_by")
	{
		return "transaction = 33 AND  type = 'Checker'";
	}
				if($table=="Estimate_for_approval" && $field=="approved_by")
	{
		return "transaction = 33 AND  type = 'Approver'";
	}
				if($table=="Estimate_for_checking" && $field=="checked_by")
	{
		return "transaction = 33 AND  type = 'Checker'";
	}
				if($table=="Estimate_for_checking" && $field=="approved_by")
	{
		return "transaction = 33 AND  type = 'Approver'";
	}
				if($table=="estimate_detail_for_checking" && $field=="VAT_Type")
	{
		return "purchase_only = 0";
	}
				if($table=="estimate_detail_for_approval" && $field=="VAT_Type")
	{
		return "purchase_only = 0";
	}
				if($table=="lyl_estimate" && $field=="checked_by")
	{
		return "transaction = 50 AND  type = 'Checker'";
	}
				if($table=="lyl_estimate" && $field=="approved_by")
	{
		return "transaction = 50 AND  type = 'Approver'";
	}
				if($table=="production_request" && $field=="approved_by")
	{
		return "transaction = 30 AND  type = 'Approver'";
	}
				if($table=="production_request" && $field=="checked_by")
	{
		return "transaction = 30 AND  type = 'Checker'";
	}
				if($table=="Credit_Card_monitoring" && $field=="bank")
	{
		return " type = 'Receipt' or  type = 'Both'";
	}
				if($table=="Credit_Card_monitoring" && $field=="checked_by")
	{
		return "transaction = 1 AND  type = 'Checker'";
	}
				if($table=="Credit_Card_monitoring" && $field=="approved_by")
	{
		return "transaction = 1 AND  type = 'Approver'";
	}
				if($table=="loan_for_approval" && $field=="checked_by")
	{
		return "transaction = 23 AND  type = 'Checker'";
	}
				if($table=="loan_for_approval" && $field=="approved_by")
	{
		return "transaction = 23 AND  type = 'Approver'";
	}
				if($table=="Overtime_for_approval" && $field=="approved_by")
	{
		return "transaction = 20 AND  type = 'Approver'";
	}
				if($table=="Overtime_for_approval" && $field=="checked_by")
	{
		return "transaction = 20 AND  type = 'Checker'";
	}
				if($table=="Purchase_Request_for_approval" && $field=="approved_by")
	{
		return "transaction = 34 AND  type = 'Approver'";
	}
				if($table=="Purchase_Request_for_approval" && $field=="checked_by")
	{
		return "transaction = 34 AND  type = 'Checker'";
	}
				if($table=="purchase_request_detail_approval" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="Production_Request_for_approval" && $field=="approved_by")
	{
		return "transaction = 26 AND  type = 'Checker'";
	}
				if($table=="Production_Request_for_approval" && $field=="checked_by")
	{
		return "transaction = 26 AND  type = 'Checker'";
	}
				if($table=="Inventory_Transfer_for_approval" && $field=="approved_by")
	{
		return "transaction = 36 AND  type = 'Approver'";
	}
				if($table=="Inventory_Transfer_for_approval" && $field=="checked_by")
	{
		return "transaction = 36 AND  type = 'Checker'";
	}
				if($table=="Loan_for_checking" && $field=="checked_by")
	{
		return "transaction = 23 AND  type = 'Checker'";
	}
				if($table=="Loan_for_checking" && $field=="approved_by")
	{
		return "transaction = 23 AND  type = 'Approver'";
	}
				if($table=="Overtime_for_checking" && $field=="approved_by")
	{
		return "transaction = 20 AND  type = 'Approver'";
	}
				if($table=="Overtime_for_checking" && $field=="checked_by")
	{
		return "transaction = 20 AND  type = 'Checker'";
	}
				if($table=="Purchase_Request_for_checking" && $field=="approved_by")
	{
		return "transaction = 34 AND  type = 'Approver'";
	}
				if($table=="Purchase_Request_for_checking" && $field=="checked_by")
	{
		return "transaction = 34 AND  type = 'Checker'";
	}
				if($table=="Production_Request_for_checking" && $field=="approved_by")
	{
		return "transaction = 26 AND  type = 'Checker'";
	}
				if($table=="Production_Request_for_checking" && $field=="checked_by")
	{
		return "transaction = 26 AND  type = 'Checker'";
	}
				if($table=="Inventory_Transfer_for_checking" && $field=="approved_by")
	{
		return "transaction = 36 AND  type = 'Approver'";
	}
				if($table=="Inventory_Transfer_for_checking" && $field=="checked_by")
	{
		return "transaction = 36 AND  type = 'Checker'";
	}
				if($table=="Backload_for_approval" && $field=="Business_Partner")
	{
		return " type = 'Customer'  Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Backload_for_approval" && $field=="checked_by")
	{
		return "transaction = 18 AND  type = 'Checker'";
	}
				if($table=="backload_detail_for_approval" && $field=="VAT_Type")
	{
		return "purchase_only =0";
	}
				if($table=="Backload_for_checking" && $field=="Business_Partner")
	{
		return " type = 'Customer'  Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="backload_detail_for_checking" && $field=="VAT_Type")
	{
		return "purchase_only =0";
	}
				if($table=="Cash_Receipt_for_approval" && $field=="bank")
	{
		return " type = 'Receipt' or  type = 'Both'";
	}
				if($table=="Cash_Receipt_for_approval" && $field=="checked_by")
	{
		return "transaction = 1 AND  type = 'Checker'";
	}
				if($table=="Cash_Receipt_for_approval" && $field=="approved_by")
	{
		return "transaction = 1 AND  type = 'Approver'";
	}
				if($table=="Cash_Receipt_for_checking" && $field=="bank")
	{
		return " type = 'Receipt' or  type = 'Both'";
	}
				if($table=="Payroll_Entry_for_approval" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Payroll_Entry_for_approval" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Payroll_Entry_for_checking" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Payroll_Entry_for_checking" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Process_Payroll_for_approval" && $field=="approved_by")
	{
		return "transaction = 32 AND  type = 'Approver'";
	}
				if($table=="Process_Payroll_for_approval" && $field=="checked_by")
	{
		return "transaction = 32 AND  type = 'Checker'";
	}
				if($table=="Process_Payroll_for_checking" && $field=="approved_by")
	{
		return "transaction = 32 AND  type = 'Approver'";
	}
				if($table=="Process_Payroll_for_checking" && $field=="checked_by")
	{
		return "transaction = 32 AND  type = 'Checker'";
	}
				if($table=="Service_Report_for_approval" && $field=="checked_by")
	{
		return "transaction = 11 AND  type = 'Checker'";
	}
				if($table=="Service_Report_for_approval" && $field=="approved_by")
	{
		return "transaction = 11 AND  type = 'Approver'";
	}
				if($table=="Service_Report_for_checking" && $field=="checked_by")
	{
		return "transaction = 11 AND  type = 'Checker'";
	}
				if($table=="Service_Report_for_checking" && $field=="approved_by")
	{
		return "transaction = 11 AND  type = 'Approver'";
	}
				if($table=="service_report_detail_for_approval" && $field=="VAT_Type")
	{
		return " purchase_only =0 ";
	}
				if($table=="service_report_detail_for_checking" && $field=="VAT_Type")
	{
		return " purchase_only =0 ";
	}
				if($table=="return" && $field=="approved_by")
	{
		return "transaction = 26 AND  type = 'Approver'";
	}
				if($table=="return" && $field=="checked_by")
	{
		return "transaction = 26 AND  type = 'Approver'";
	}
				if($table=="fixed_asset_issue" && $field=="approved_by")
	{
		return "transaction = 14 AND  type = 'Approver'";
	}
				if($table=="fixed_asset_issue" && $field=="checked_by")
	{
		return "transaction = 14 AND  type = 'Checker'";
	}
				if($table=="purchase_request_detail_for_checking" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="trip_ticket_for_approval" && $field=="approved_by")
	{
		return "transaction = 19 AND  type = 'Approver'";
	}
				if($table=="trip_ticket_for_approval" && $field=="checked_by")
	{
		return "transaction = 19 AND  type = 'Checker'";
	}
				if($table=="trip_ticket_for_checking" && $field=="approved_by")
	{
		return "transaction = 19 AND  type = 'Approver'";
	}
				if($table=="trip_ticket_for_checking" && $field=="checked_by")
	{
		return "transaction = 19 AND  type = 'Checker'";
	}
				if($table=="Collection_Report_per_Customer" && $field=="bank")
	{
		return " type = 'Receipt' or  type = 'Both'";
	}
				if($table=="Payment_per_Supplier_Report" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Payment_per_Supplier_Report" && $field=="bank")
	{
		return " type = 'Disbursement' or  type = 'Both'";
	}
				if($table=="Purchase_Report" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchase_Report_per_BP" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchase_Report_per_Item" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchase_Report_per_Cost_Center" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchase_Report_per_BP_detail" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchase_Report_per_Item_detail" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchase_Report_per_Cost_Center_detail" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Production_Costing_Report" && $field=="approved_by")
	{
		return "transaction = 26 AND  type = 'Approver'";
	}
				if($table=="Production_Costing_Report" && $field=="checked_by")
	{
		return "transaction = 26 AND  type = 'Checker'";
	}
				if($table=="Payroll_Register" && $field=="approved_by")
	{
		return "transaction = 32 AND  type = 'Approver'";
	}
				if($table=="Payroll_Register" && $field=="checked_by")
	{
		return "transaction = 32 AND  type = 'Checker'";
	}
				if($table=="quality_control" && $field=="checked_by")
	{
		return "transaction = 52 AND  type = 'Checker'";
	}
				if($table=="quality_control" && $field=="approved_by")
	{
		return "transaction = 52 AND  type = 'Approver'";
	}
				if($table=="budget" && $field=="checked_by")
	{
		return "transaction = 41 AND  type = 'Checker'";
	}
				if($table=="budget" && $field=="approved_by")
	{
		return "transaction = 41 AND  type = 'Approver'";
	}
				if($table=="sub_contract" && $field=="checked_by")
	{
		return "transaction = 40 AND  type = 'Checker'";
	}
				if($table=="sub_contract" && $field=="approved_by")
	{
		return "transaction = 40 AND  type = 'Approver'";
	}
				if($table=="Monthly_Pag-ibig_Summary_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_Pag-ibig_Summary_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Monthly_Philhealth_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_Philhealth_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Monthly_Philhealth_Summary_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_Philhealth_Summary_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Monthly_SSS_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_SSS_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Monthly_SSS_Report_by_Department_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_SSS_Report_by_Department_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Monthly_Withholding_Tax_Prooflist_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_Withholding_Tax_Prooflist_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Monthly_Witholding_Tax_Collection_List_by_Department_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_Witholding_Tax_Collection_List_by_Department_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="Monthly_Pag-ibig_Report" && $field=="approved_by")
	{
		return "transaction = 38 AND  type = 'Approver'";
	}
				if($table=="Monthly_Pag-ibig_Report" && $field=="checked_by")
	{
		return "transaction = 38 AND  type = 'Checker'";
	}
				if($table=="sales_order" && $field=="checked_by")
	{
		return "transaction = 27 AND  type = 'Checker'";
	}
				if($table=="sales_order" && $field=="approved_by")
	{
		return "transaction = 27 AND  type = 'Approver'";
	}
				if($table=="sales_order_detail" && $field=="VAT_Type")
	{
		return "purchase_only = 0";
	}
				if($table=="marketing_request_form" && $field=="approved_by")
	{
		return "transaction = 45 AND  type = 'Approver'";
	}
				if($table=="marketing_request_form" && $field=="check_by")
	{
		return "transaction = 45 AND  type = 'Checker'";
	}
				if($table=="Quotation_Dashboard_Customer" && $field=="Business_Partner")
	{
		return "type  <> 'Supplier'  ";
	}
				if($table=="Quotation_Dashboard_Customer" && $field=="checked_by")
	{
		return "transaction = 9 AND  type = 'Checker'";
	}
				if($table=="Quotation_Dashboard_Customer" && $field=="approved_by")
	{
		return "transaction = 9 AND  type = 'Approver'";
	}
				if($table=="Delivery_Receipt_Dashboard_Customer" && $field=="approved_by")
	{
		return "transaction = 13 AND  type = 'Approver'";
	}
				if($table=="Delivery_Receipt_Dashboard_Customer" && $field=="checked_by")
	{
		return "transaction = 13 AND  type = 'Checker'";
	}
				if($table=="Delivery_Receipt_Dashboard_Customer" && $field=="driver")
	{
		return " type = 'Employee'";
	}
				if($table=="Sales_Dashboard_Customer" && $field=="checked_by")
	{
		return "transaction = 1 AND  type = 'Checker'";
	}
				if($table=="Sales_Dashboard_Customer" && $field=="approved_by")
	{
		return "transaction = 1 AND  type = 'Approver'";
	}
				if($table=="Backload_Dashboard_Customer" && $field=="Business_Partner")
	{
		return " type = 'Customer'  Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Backload_Dashboard_Customer" && $field=="approved_by")
	{
		return "transaction = 18 AND  type = 'Approver'";
	}
				if($table=="Backload_Dashboard_Customer" && $field=="checked_by")
	{
		return "transaction = 18 AND  type = 'Checker'";
	}
				if($table=="Purchase_Request_Dashboard_Supplier" && $field=="approved_by")
	{
		return "transaction = 34 AND  type = 'Approver'";
	}
				if($table=="Purchase_Request_Dashboard_Supplier" && $field=="checked_by")
	{
		return "transaction = 34 AND  type = 'Checker'";
	}
				if($table=="Purchase_Order_Dashboard_Supplier" && $field=="approved_by")
	{
		return "transaction = 12 AND  type = 'Approver'";
	}
				if($table=="Purchase_Order_Dashboard_Supplier" && $field=="checked_by")
	{
		return "transaction = 12 AND  type = 'Checker'";
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="approved_by")
	{
		return "transaction = 3 AND  type = 'Approver'";
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="checked_by")
	{
		return "transaction = 3 AND  type = 'Checker' ";
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="bank")
	{
		return " type = 'Disbursement' or  type = 'Both'";
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="checked_by")
	{
		return "transaction = 4 AND  type = 'Checker'";
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="approved_by")
	{
		return "transaction = 4 AND  type = 'Approver'";
	}
				if($table=="Debit_Memo_Dashboard_Supplier" && $field=="approved_by")
	{
		return "transaction = 8 AND  type = 'Approver'";
	}
				if($table=="Debit_Memo_Dashboard_Supplier" && $field=="checked_by")
	{
		return "transaction = 8 AND  type = 'Checker'";
	}
				if($table=="Purchase_Request_Dashboard_Item" && $field=="approved_by")
	{
		return "transaction = 34 AND  type = 'Approver'";
	}
				if($table=="Purchase_Request_Dashboard_Item" && $field=="checked_by")
	{
		return "transaction = 34 AND  type = 'Checker'";
	}
				if($table=="Purchase_Order_Dashboard_Item" && $field=="approved_by")
	{
		return "transaction = 12 AND  type = 'Approver'";
	}
				if($table=="Purchase_Order_Dashboard_Item" && $field=="checked_by")
	{
		return "transaction = 12 AND  type = 'Checker'";
	}
				if($table=="Production_Dashboard_Item" && $field=="approved_by")
	{
		return "transaction = 26 AND  type = 'Approver'";
	}
				if($table=="Production_Dashboard_Item" && $field=="checked_by")
	{
		return "transaction = 26 AND  type = 'Checker'";
	}
				if($table=="Deposit_Report" && $field=="checked_by")
	{
		return "transaction = 35 AND  type = 'Checker'";
	}
				if($table=="Deposit_Report" && $field=="approved_by")
	{
		return "transaction = 35 AND  type = 'Approver'";
	}
				if($table=="Open_Trip_Ticket_Report" && $field=="approved_by")
	{
		return "transaction = 19 AND  type = 'Approver'";
	}
				if($table=="Open_Trip_Ticket_Report" && $field=="checked_by")
	{
		return "transaction = 19 AND  type = 'Checker'";
	}
				if($table=="Deposit_in_transit_Report" && $field=="checked_by")
	{
		return "transaction = 35 AND  type = 'Checker'";
	}
				if($table=="Deposit_in_transit_Report" && $field=="approved_by")
	{
		return "transaction = 35 AND  type = 'Approver'";
	}
				if($table=="Outstanding_Checks_Report" && $field=="Business_Partner")
	{
		return " type = 'Supplier' Or  type = 'Customer and Supplier' Or  type = 'Employee' ";
	}
				if($table=="Outstanding_Checks_Report" && $field=="bank")
	{
		return " type = 'Disbursement' or  type = 'Both'";
	}
				if($table=="Outstanding_Checks_Report" && $field=="checked_by")
	{
		return "transaction = 4 AND  type = 'Checker'";
	}
				if($table=="Outstanding_Checks_Report" && $field=="approved_by")
	{
		return "transaction = 4 AND  type = 'Approver'";
	}
				if($table=="sales_per_sales_rep_Report" && $field=="checked_by")
	{
		return "transaction = 1 AND  type = 'Checker'";
	}
				if($table=="sales_per_sales_rep_Report" && $field=="approved_by")
	{
		return "transaction = 1 AND  type = 'Approver'";
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="approved_by")
	{
		return "transaction = 32 AND  type = 'Approver'";
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="checked_by")
	{
		return "transaction = 32 AND  type = 'Checker'";
	}
				if($table=="Quotation_Dashboard" && $field=="Business_Partner")
	{
		return "type  <> 'Supplier'  ";
	}
				if($table=="Quotation_Dashboard" && $field=="checked_by")
	{
		return "transaction = 9 AND  type = 'Checker'";
	}
				if($table=="Quotation_Dashboard" && $field=="approved_by")
	{
		return "transaction = 9 AND  type = 'Approver'";
	}
				if($table=="Sales_Order_Dashboard" && $field=="checked_by")
	{
		return "transaction = 1 AND  type = 'Checker'";
	}
				if($table=="Sales_Order_Dashboard" && $field=="approved_by")
	{
		return "transaction = 1 AND  type = 'Approver'";
	}
				if($table=="Reimbursement_Dashboard" && $field=="checked_by")
	{
		return "transaction = 10 AND  type = 'Checker'";
	}
				if($table=="Reimbursement_Dashboard" && $field=="approved_by")
	{
		return "transaction = 10 AND  type = 'Approver'";
	}
				if($table=="Loan_Dashboard" && $field=="checked_by")
	{
		return "transaction = 23 AND  type = 'Checker'";
	}
				if($table=="Loan_Dashboard" && $field=="approved_by")
	{
		return "transaction = 23 AND  type = 'Approver'";
	}
				if($table=="lyl_estimate_dr" && $field=="checked_by")
	{
		return "transaction = 51 AND  type = 'Checker'";
	}
				if($table=="lyl_estimate_dr" && $field=="approved_by")
	{
		return "transaction = 51 AND  type = 'Approver'";
	}
				if($table=="quotation_detail" && $field=="VAT_Type")
	{
		return "purchase_only =0";
	}
				if($table=="issue_components" && $field=="approved_by")
	{
		return "transaction = 48 AND  type = 'Approver'";
	}
				if($table=="issue_components" && $field=="checked_by")
	{
		return "transaction = 48 AND  type = 'Checker'";
	}
				if($table=="unbuild_assemblies" && $field=="approved_by")
	{
		return "transaction = 49 AND  type = 'Approver'";
	}
				if($table=="unbuild_assemblies" && $field=="checked_by")
	{
		return "transaction = 49 AND  type = 'Checker'";
	}
				if($table=="disposed_inv" && $field=="approved_by")
	{
		return "transaction = 53 AND  type = 'Approver'";
	}
				if($table=="disposed_inv" && $field=="checked_by")
	{
		return "transaction = 53 AND  type = 'Checker'";
	}
				if($table=="production_request_report" && $field=="approved_by")
	{
		return "transaction = 44 AND  type = 'Checker'";
	}
				if($table=="production_request_report" && $field=="checked_by")
	{
		return "transaction = 44 AND  type = 'Checker'";
	}
				if($table=="approved_sales_order" && $field=="ref_no")
	{
		return "Status = 'Approved'";
	}
				if($table=="approved_sales_order" && $field=="prepared_by")
	{
		return "transaction = 27 AND  type = 'Approver'";
	}
				if($table=="approved_sales_order" && $field=="checked_by")
	{
		return "transaction = 27 AND  type = 'Checker'";
	}
				if($table=="approved_sales_order" && $field=="approved_by")
	{
		return "transaction = 27 AND  type = 'Approver'";
	}
				if($table=="purchase_order_for_receiving" && $field=="approved_by")
	{
		return "transaction = 36 AND  type = 'Approver'";
	}
				if($table=="purchase_order_for_receiving" && $field=="checked_by")
	{
		return "transaction = 36 AND  type = 'Cheker'";
	}
				if($table=="packing_list" && $field=="checked_by")
	{
		return "transaction = 25 AND  type = 'Checker'";
	}
				if($table=="packing_list" && $field=="approved_by")
	{
		return "transaction = 54 AND  type = 'Approver'";
	}
				if($table=="purchase_order_receiving_detail" && $field=="VAT_Type")
	{
		return "purchase_only =1";
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="approved_by")
	{
		return "transaction = 36 AND  type = 'Approver'";
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="checked_by")
	{
		return "transaction = 36 AND  type = 'Checker'";
	}
				if($table=="issue_components_for_approval" && $field=="approved_by")
	{
		return "transaction = 48 AND  type = 'Approver'";
	}
				if($table=="issue_components_for_approval" && $field=="checked_by")
	{
		return "transaction = 48 AND  type = 'Checker'";
	}
				if($table=="issue_components_for_checking" && $field=="approved_by")
	{
		return "transaction = 48 AND  type = 'Approver'";
	}
				if($table=="issue_components_for_checking" && $field=="checked_by")
	{
		return "transaction = 48 AND  type = 'Checker'";
	}
				if($table=="cash_sales_Report" && $field=="bank")
	{
		return " type = 'Receipt' or  type = 'Both'";
	}
				if($table=="cash_sales_Report" && $field=="ref_no")
	{
		return "Status = 'Approved'";
	}
				if($table=="cash_sales_Report" && $field=="checked_by")
	{
		return "transaction = 35 AND  type = 'Checker'";
	}
				if($table=="cash_sales_Report" && $field=="approved_by")
	{
		return "transaction = 35 AND  type = 'Approver'";
	}
				if($table=="unbuild_assemblies_for_checking" && $field=="approved_by")
	{
		return "transaction = 49 AND  type = 'Approver'";
	}
				if($table=="unbuild_assemblies_for_checking" && $field=="checked_by")
	{
		return "transaction = 49 AND  type = 'Checker'";
	}
				if($table=="unbuild_assemblies_for_approval" && $field=="approved_by")
	{
		return "transaction = 49 AND  type = 'Approver'";
	}
				if($table=="unbuild_assemblies_for_approval" && $field=="checked_by")
	{
		return "transaction = 49 AND  type = 'Checker'";
	}
				if($table=="Collection_Report_per_Sales_Rep" && $field=="bank")
	{
		return " type = 'Receipt' or  type = 'Both'";
	}
				if($table=="marketing_request_form_for_checking" && $field=="approved_by")
	{
		return "transaction = 45 AND  type = 'Approver'";
	}
				if($table=="marketing_request_form_for_checking" && $field=="check_by")
	{
		return "transaction = 45 AND  type = 'Checker'";
	}
				if($table=="marketing_request_form_for_approval" && $field=="approved_by")
	{
		return "transaction = 45 AND  type = 'Approver'";
	}
				if($table=="marketing_request_form_for_approval" && $field=="check_by")
	{
		return "transaction = 45 AND  type = 'Checker'";
	}
				if($table=="production_per_item" && $field=="approved_by")
	{
		return "transaction = 22 AND  type = 'Approver'";
	}
				if($table=="production_per_item" && $field=="checked_by")
	{
		return "transaction = 22 AND  type = 'Checker'";
	}
				if($table=="DR_per_Item" && $field=="approved_by")
	{
		return "transaction = 12 AND  type = 'Approver'";
	}
				if($table=="DR_per_Item" && $field=="checked_by")
	{
		return "transaction = 12 AND  type = 'Checker'";
	}
				if($table=="DR_per_Item" && $field=="driver")
	{
		return " type = 'Employee'";
	}
				if($table=="Logistic_Open_Trip_Ticket" && $field=="checked_by")
	{
		return "transaction = 19 AND  type = 'Checker'";
	}
				if($table=="logistic_open_inventory_tranfer" && $field=="approved_by")
	{
		return "transaction = 32 AND  type = 'Approver'";
	}
				if($table=="logistic_open_inventory_tranfer" && $field=="checked_by")
	{
		return "transaction = 32 AND  type = 'Checker'";
	}
				if($table=="intercompany_sales_order" && $field=="checked_by")
	{
		return "transaction = 46 AND  type = 'Checker'";
	}
				if($table=="intercompany_sales_order" && $field=="approved_by")
	{
		return "transaction = 46 AND  type = 'Approver'";
	}
				if($table=="lyl_estimate_for_approval" && $field=="checked_by")
	{
		return "transaction = 50 AND  type = 'Checker'";
	}
				if($table=="lyl_estimate_for_approval" && $field=="approved_by")
	{
		return "transaction = 50 AND  type = 'Approver'";
	}
				if($table=="lyl_estimate_dr_for_approval" && $field=="checked_by")
	{
		return "transaction = 51 AND  type = 'Checker'";
	}
				if($table=="lyl_estimate_dr_for_approval" && $field=="approved_by")
	{
		return "transaction = 51 AND  type = 'Approver'";
	}
				if($table=="lyl_estimate_for_checking" && $field=="checked_by")
	{
		return "transaction = 50 AND  type = 'Checker'";
	}
				if($table=="lyl_estimate_for_checking" && $field=="approved_by")
	{
		return "transaction = 50 AND  type = 'Approver'";
	}
				if($table=="lyl_estimate_dr_for_checking" && $field=="checked_by")
	{
		return "transaction = 51 AND  type = 'Checker'";
	}
				if($table=="lyl_estimate_dr_for_checking" && $field=="approved_by")
	{
		return "transaction = 51 AND  type = 'Approver'";
	}
				if($table=="request_for_quote" && $field=="approved_by")
	{
		return "transaction = 47 AND  type = 'Approver'";
	}
				if($table=="request_for_quote" && $field=="checked_by")
	{
		return "transaction = 47 AND  type = 'Checker'";
	}
				if($table=="request_for_quoter_detail" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="request_for_quote_for_checking" && $field=="approved_by")
	{
		return "transaction = 47 AND  type = 'Approver'";
	}
				if($table=="request_for_quote_for_checking" && $field=="checked_by")
	{
		return "transaction = 47 AND  type = 'Checker'";
	}
				if($table=="request_for_quote_for_approval" && $field=="approved_by")
	{
		return "transaction = 47 AND  type = 'Approver'";
	}
				if($table=="request_for_quote_for_approval" && $field=="checked_by")
	{
		return "transaction = 47 AND  type = 'Checker'";
	}
				if($table=="billable_liquidation" && $field=="VAT_Type")
	{
		return " purchase_only = 1 ";
	}
				if($table=="billable_pettycash" && $field=="VAT_Type")
	{
		return " purchase_only = 1 ";
	}
				if($table=="billable_checkvoucher" && $field=="VAT_Type")
	{
		return " purchase_only = 1 ";
	}
				if($table=="notifiy quotation Report" && $field=="Business_Partner")
	{
		return "(business_partner.`type` = 'Customer') OR   (business_partner.`type` = 'Opportunity') OR   (business_partner.`type` = 'Customer and Supplier')";
	}
				if($table=="notifiy quotation Report" && $field=="checked_by")
	{
		return "transaction = 8 AND  type = 'Checker'";
	}
				if($table=="notifiy quotation Report" && $field=="approved_by")
	{
		return "transaction = 8 AND  type = 'Approver'";
	}
				if($table=="petty cash release" && $field=="approved_by")
	{
		return "transaction = 27 AND  type = 'Approver'";
	}
				if($table=="petty cash release" && $field=="checked_by")
	{
		return "transaction = 27 AND  type = 'Checker'";
	}
				if($table=="petty cash replenishment" && $field=="approved_by")
	{
		return "transaction = 27 AND  type = 'Approver'";
	}
				if($table=="petty cash replenishment" && $field=="checked_by")
	{
		return "transaction = 27 AND  type = 'Checker'";
	}
				if($table=="Employee Advance Release" && $field=="checked_by")
	{
		return "transaction = 9 AND  type = 'Checker'";
	}
				if($table=="Employee Advance Release" && $field=="approved_by")
	{
		return "transaction = 9 AND  type = 'Approver'";
	}
				if($table=="Employee Advance Replenishment" && $field=="checked_by")
	{
		return "transaction = 9 AND  type = 'Checker'";
	}
				if($table=="Employee Advance Replenishment" && $field=="approved_by")
	{
		return "transaction = 9 AND  type = 'Approver'";
	}
				if($table=="Liquidation Release" && $field=="approved_by")
	{
		return "transaction = 21 AND  type = 'Approver'";
	}
				if($table=="Liquidation Release" && $field=="checked_by")
	{
		return "transaction = 21 AND  type = 'Checker'";
	}
				if($table=="Liquidation Replenishment" && $field=="approved_by")
	{
		return "transaction = 21 AND  type = 'Approver'";
	}
				if($table=="Liquidation Replenishment" && $field=="checked_by")
	{
		return "transaction = 21 AND  type = 'Checker'";
	}
				if($table=="project_replenishment_deposited" && $field=="Business_Partner")
	{
		return " type = 'Employee'";
	}
				if($table=="project_replenishment_deposited" && $field=="approved_by")
	{
		return "transaction = 21 AND  type = 'Approver'";
	}
				if($table=="project_replenishment_deposited" && $field=="checked_by")
	{
		return "transaction = 21 AND  type = 'Checker'";
	}
				if($table=="sales_business_partner" && $field=="checked_by")
	{
		return "transaction = 1 AND  type = 'Checker'";
	}
				if($table=="sales_business_partner" && $field=="approved_by")
	{
		return "transaction = 1 AND  type = 'Approver'";
	}
				if($table=="sales_business_partner" && $field=="vattype2")
	{
		return " purchase_only = 0";
	}
				if($table=="canvas" && $field=="approved_by")
	{
		return "transaction = 30 AND  type = 'Approver'";
	}
				if($table=="canvas" && $field=="checked_by")
	{
		return "transaction = 30 AND  type = 'Checker'";
	}
				if($table=="canvas_detail" && $field=="VAT_Type")
	{
		return "purchase_only = 1";
	}
				if($table=="request_for_payment_detail" && $field=="VAT_Type")
	{
		return " purchase_only =1";
	}
	return "";
}

/**
 * @intellisense
 */
function GetDefaultValue($field, $ptype, $table="")
{
	global $strTableName;
	if(!$table)
		$table=$strTableName;
				if($table=="business_partner" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="business_partner" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="item" && $field=="Vat Type") 
	{
		return "VATable";
	}
				if($table=="item" && $field=="Vat Rate") 
	{
		return 12;
	}
				if($table=="item" && $field=="perpetual_method") 
	{
		return 0;
	}
				if($table=="item" && $field=="automate_depreciation") 
	{
		return 0;
	}
				if($table=="item" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="item" && $field=="purchase_vat_type") 
	{
		return "Purchase of Goods";
	}
				if($table=="item" && $field=="purchase_vat_rate") 
	{
		return 12;
	}
				if($table=="credit_terms" && $field=="Discount Percentage") 
	{
		return 0;
	}
				if($table=="credit_terms" && $field=="Discount Days") 
	{
		return 0;
	}
				if($table=="credit_terms" && $field=="Due Days") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="cash_receipt" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="EWT_Amount") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="cash_receipt" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="collection_discount") 
	{
		return 0;
	}
				if($table=="cash_receipt" && $field=="currecy") 
	{
		return 1;
	}
				if($table=="cash_receipt" && $field=="transaction_type") 
	{
		return "Credit Note";
	}
				if($table=="purchase" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="purchase" && $field=="Payable_Account") 
	{
		return 78;
	}
				if($table=="purchase" && $field=="Terms_Discount_percent") 
	{
		return 0;
	}
				if($table=="purchase" && $field=="Terms_Discount_days") 
	{
		return 0;
	}
				if($table=="purchase" && $field=="Terms_due_date") 
	{
		return 0;
	}
				if($table=="purchase" && $field=="Due_Date") 
	{
		return now();
	}
				if($table=="purchase" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="purchase" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="purchase" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="cash_disbursment" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="cash_disbursment" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="payable_discount") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="cash_disbursment" && $field=="importation") 
	{
		return 0;
	}
				if($table=="cash_disbursment" && $field=="currecy") 
	{
		return 1;
	}
				if($table=="cash_disbursment" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="cash_disbursment" && $field=="payment_method") 
	{
		return 2;
	}
				if($table=="cash_disbursment" && $field=="check_date") 
	{
		return now();
	}
				if($table=="general_journal" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="general_journal" && $field=="taxable") 
	{
		return 1;
	}
				if($table=="beg_bal" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="bank" && $field=="type") 
	{
		return "Both";
	}
				if($table=="bank" && $field=="default") 
	{
		return 0;
	}
				if($table=="bank" && $field=="service_charge") 
	{
		return 0;
	}
				if($table=="accounting_period" && $field=="open") 
	{
		return 0;
	}
				if($table=="deposit" && $field=="transadate") 
	{
		return Now();
	}
				if($table=="deposit" && $field=="modified_date") 
	{
		return now();
	}
				if($table=="recon_CR" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="recon_CR" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="recon_CR" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="recon_CR" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Recon_CV" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Recon_CV" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Recon_CV" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Recon_CV" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="dr" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="dr" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="dr" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="dr" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="dr" && $field=="types_of_dr") 
	{
		return 'Normal Delivery';
	}
				if($table=="purchase_order" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="purchase_order" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="purchase_order" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="purchase_order" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="purchase_order" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="purchase_order" && $field=="invoice_date") 
	{
		return Now();
	}
				if($table=="purchase_order" && $field=="delivery_status") 
	{
		return 'For Receiving';
	}
				if($table=="purchase_order_receiving" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="purchase_order_receiving" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="purchase_order_receiving" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="purchase_order_receiving" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="purchase_order_receiving" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="purchase_order_receiving" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="System_preference" && $field=="accouting_period") 
	{
		return "Calendar";
	}
				if($table=="System_preference" && $field=="fiscal_month_end") 
	{
		return 12;
	}
				if($table=="System_preference" && $field=="allow_pre_period_posting") 
	{
		return 0;
	}
				if($table=="System_preference" && $field=="use_undeposited_account") 
	{
		return 0;
	}
				if($table=="System_preference" && $field=="category") 
	{
		return "Private";
	}
				if($table=="ppe_list" && $field=="start_depreciation_date") 
	{
		return Now();
	}
				if($table=="ppe_list" && $field=="warranty_date") 
	{
		return Now();
	}
				if($table=="meetings" && $field=="date") 
	{
		return Now();
	}
				if($table=="meetings" && $field=="status") 
	{
		return "Planned";
	}
				if($table=="meetings" && $field=="done") 
	{
		return 0;
	}
				if($table=="calls" && $field=="date") 
	{
		return Now();
	}
				if($table=="calls" && $field=="status") 
	{
		return "Planned";
	}
				if($table=="campaign" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="campaign" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="reimbursement" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="reimbursement" && $field=="Payable_Account") 
	{
		return 7;
	}
				if($table=="reimbursement" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="reimbursement_detail" && $field=="Account") 
	{
		return 20;
	}
				if($table=="reimbursement_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="Target_customers" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="quotation" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="quotation" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="case" && $field=="status") 
	{
		return "Open";
	}
				if($table=="case" && $field=="date_of_purchase") 
	{
		return Now();
	}
				if($table=="projects" && $field=="date") 
	{
		return now();
	}
				if($table=="projects" && $field=="classification") 
	{
		return 5;
	}
				if($table=="projects" && $field=="disch_date") 
	{
		return now();
	}
				if($table=="projects" && $field=="desti_date") 
	{
		return now();
	}
				if($table=="projects" && $field=="status1") 
	{
		return OPEN;
	}
				if($table=="projects" && $field=="vol_status") 
	{
		return OPEN;
	}
				if($table=="production" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="production" && $field=="production_status") 
	{
		return Done;
	}
				if($table=="issue" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="disposed" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="backload" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="backload" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="backload" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="vehicle" && $field=="reg_date") 
	{
		return Now();
	}
				if($table=="vehicle" && $field=="available") 
	{
		return 0;
	}
				if($table=="trip_ticket" && $field=="date_added") 
	{
		return Now();
	}
				if($table=="trip_ticket" && $field=="loaded") 
	{
		return 0;
	}
				if($table=="accident" && $field=="accident_date") 
	{
		return Now();
	}
				if($table=="accident" && $field=="report_date") 
	{
		return Now();
	}
				if($table=="approver_list" && $field=="type") 
	{
		return Checker;
	}
				if($table=="attendance" && $field=="date") 
	{
		return Now();
	}
				if($table=="medical" && $field=="med_eval_date") 
	{
		return Now();
	}
				if($table=="medical" && $field=="plan_date") 
	{
		return Now();
	}
				if($table=="medical" && $field=="due_date") 
	{
		return Now();
	}
				if($table=="service_report" && $field=="date_attended") 
	{
		return Now();
	}
				if($table=="service_report" && $field=="date_released") 
	{
		return Now();
	}
				if($table=="fixed_assets_return" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Prospect_customers" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="Prospect_customers" && $field=="next_action_date") 
	{
		return Now();
	}
				if($table=="trip_detail" && $field=="from_date") 
	{
		return Now();
	}
				if($table=="trip_detail" && $field=="to date") 
	{
		return Now();
	}
				if($table=="cash_disbursement_detail2" && $field=="VAT_Type") 
	{
		return "Not Qualified for Input";
	}
				if($table=="cash_disbursement_detail2" && $field=="VAT_Rate") 
	{
		return 0;
	}
				if($table=="cash_disbursement_detail2" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="cash_disbursement_detail2" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="cash_disbursment_detail" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="cash_receipt_detail" && $field=="Account ID") 
	{
		return 5;
	}
				if($table=="cash_receipt_detail" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="cash_receipt_detail2" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="general_journal_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="employee_list" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="petty_cash" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="petty_cash" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="petty_cash" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="petty_cash_detail" && $field=="EWT_Rate") 
	{
		return 0;
	}
				if($table=="petty_cash_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="center_replenishment" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="center_replenishment" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="center_replenishment" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="center_replenishment" && $field=="pettycash_total") 
	{
		return 0;
	}
				if($table=="center_replenishment" && $field=="empadv_total") 
	{
		return 0;
	}
				if($table=="center_replenishment" && $field=="liquidation_total") 
	{
		return 0;
	}
				if($table=="center_replenishment" && $field=="totals") 
	{
		return 0;
	}
				if($table=="center_replenishment_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="credit_memo" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="credit_memo" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="credit_memo" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="credit_memo" && $field=="currency") 
	{
		return "Peso";
	}
				if($table=="debit_memo" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="debit_memo" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="debit_memo" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="project_replenishment" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="project_replenishment" && $field=="Payable_Account") 
	{
		return 20;
	}
				if($table=="project_replenishment" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="project_replenishment" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="project_replenishment" && $field=="balance") 
	{
		return 0;
	}
				if($table=="project_replenishment_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="Sales_Representatives" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="sales" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="sales" && $field=="Receivable_Account") 
	{
		return 5;
	}
				if($table=="sales" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="sales" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="sales" && $field=="currency") 
	{
		return 1;
	}
				if($table=="sales" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="sales" && $field=="type_of_invoice") 
	{
		return "Regular";
	}
				if($table=="sales" && $field=="sv") 
	{
		return 0;
	}
				if($table=="sales_detail" && $field=="Qty") 
	{
		return 1;
	}
				if($table=="sales_detail" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="sales_detail" && $field=="currency_detail") 
	{
		return Peso;
	}
				if($table=="sales_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="tranasactions_for_approval" && $field=="default_status") 
	{
		return "Approved";
	}
				if($table=="tranasactions_for_approval" && $field=="allow_edit_after_approval") 
	{
		return 0;
	}
				if($table=="deposit_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="purchase_detail" && $field=="EWT_Amount") 
	{
		return 0;
	}
				if($table=="purchase_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="purchase_order_detail" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="Sales_Order_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Order_for_checking" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Sales_Order_for_checking" && $field=="currency") 
	{
		return "Peso";
	}
				if($table=="Sales_Order_for_checking" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Sales_Order_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Order_for_approval" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Sales_Order_for_approval" && $field=="currency") 
	{
		return "Peso";
	}
				if($table=="Sales_Order_for_approval" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Quotation_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Quotation_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Reimbursement_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Reimbursement_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Project_Replenishment_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Project_Replenishment_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchases_Order_for_checking2" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchases_Order_for_checking2" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Purchases_Order_for_approval2" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchases_Order_for_approval2" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Receiving_for_checking2" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Receiving_for_checking2" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Receiving_for_checking2" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Receiving_for_checking2" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Receiving_for_checking2" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval2" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval2" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval2" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Receiving_for_approval2" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval2" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Delivery_Receipt_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Delivery_Receipt_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Production_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Production_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Issue_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Issue_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Return_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Return_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Disposal_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Fixed_Asset_Issue_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Fixed_Asset_Issue_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Fixed_Asset_Return_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Fixed_Asset_Return_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Petty_Cash_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Petty_Cash_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Deposit_for_checking" && $field=="transadate") 
	{
		return Now();
	}
				if($table=="Deposit_for_approval" && $field=="transadate") 
	{
		return Now();
	}
				if($table=="Credit_Memo_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Credit_Memo_for_checking" && $field=="currency") 
	{
		return "Peso";
	}
				if($table=="Credit_Memo_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Credit_Memo_for_approval" && $field=="currency") 
	{
		return "Peso";
	}
				if($table=="Purchases_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchases_for_checking" && $field=="Terms_Discount_percent") 
	{
		return 0;
	}
				if($table=="Purchases_for_checking" && $field=="Terms_Discount_days") 
	{
		return 0;
	}
				if($table=="Purchases_for_checking" && $field=="Terms_due_date") 
	{
		return 0;
	}
				if($table=="Purchases_for_checking" && $field=="Due_Date") 
	{
		return now();
	}
				if($table=="Purchases_for_checking" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Purchases_for_checking" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="Purchases_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchases_for_approval" && $field=="Terms_Discount_percent") 
	{
		return 0;
	}
				if($table=="Purchases_for_approval" && $field=="Terms_Discount_days") 
	{
		return 0;
	}
				if($table=="Purchases_for_approval" && $field=="Terms_due_date") 
	{
		return 0;
	}
				if($table=="Purchases_for_approval" && $field=="Due_Date") 
	{
		return now();
	}
				if($table=="Purchases_for_approval" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Purchases_for_approval" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="Sales_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_for_checking" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Sales_for_checking" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Sales_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_for_approval" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Sales_for_approval" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="importation") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="currecy") 
	{
		return 1;
	}
				if($table=="Cash_Disbursement_for_checking" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="check_voucher_detail_for_checking" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="importation") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="currecy") 
	{
		return 1;
	}
				if($table=="Cash_Disbursement_for_approval" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="check_voucher_detail_for_approval" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="General_Journal_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="General_Journal_for_checking" && $field=="taxable") 
	{
		return 1;
	}
				if($table=="General_Journal_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="General_Journal_for_approval" && $field=="taxable") 
	{
		return 1;
	}
				if($table=="for_submissions" && $field=="due_date") 
	{
		return Now();
	}
				if($table=="submission_details" && $field=="side") 
	{
		return "Front";
	}
				if($table=="estimate" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="estimate" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="purchase_request" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="purchase_request" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="purchase_request" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="purchase_request" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="inventory_adj" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="inventory_tranfer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Customers" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="Customers" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="Suppliers" && $field=="type") 
	{
		return "Supplier";
	}
				if($table=="Suppliers" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="Suppliers" && $field=="primary_revenue_type") 
	{
		return "Seller of Goods";
	}
				if($table=="Statement_of_Account" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="Statement_of_Account" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="Change_Time_Schedule_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="Change_Time_Schedule_for_approval" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Change_Time_Schedule_for_approval" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Change_Time_Schedule_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="Change_Time_Schedule_for_checking" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Change_Time_Schedule_for_checking" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Inventory_Adjustment_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Inventory_Adjustment_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Estimate_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Estimate_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Follow_up" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="Follow_up" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="coming_meetings" && $field=="date") 
	{
		return Now();
	}
				if($table=="coming_meetings" && $field=="status") 
	{
		return "Planned";
	}
				if($table=="coming_meetings" && $field=="done") 
	{
		return 0;
	}
				if($table=="2301" && $field=="no_days") 
	{
		return 261;
	}
				if($table=="Prospect_customers_to_Customer" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="lyl_estimate" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="lyl_estimate" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="production_request" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Credit_Card_monitoring" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Credit_Card_monitoring" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Credit_Card_monitoring" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="Credit_Card_monitoring" && $field=="EWT_Amount") 
	{
		return 0;
	}
				if($table=="Credit_Card_monitoring" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Credit_Card_monitoring" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="Credit_Card_monitoring" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Credit_Card_monitoring" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="Leave_for_approval" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Leave_for_approval" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="loan_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="Overtime_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="Purchase_Request_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Request_for_approval" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Production_Request_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Inventory_Transfer_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Leave_for_checking" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Leave_for_checking" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Loan_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="Overtime_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="Purchase_Request_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Request_for_checking" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Production_Request_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Inventory_Transfer_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Backload_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Backload_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Cash_Receipt_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Cash_Receipt_for_approval" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_approval" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_approval" && $field=="EWT_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_approval" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Cash_Receipt_for_approval" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_approval" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_approval" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Cash_Receipt_for_checking" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_checking" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_checking" && $field=="EWT_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_checking" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Cash_Receipt_for_checking" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_checking" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Cash_Receipt_for_checking" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="Payroll_Entry_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="Payroll_Entry_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="Process_Payroll_for_approval" && $field=="date_processed") 
	{
		return Now();
	}
				if($table=="Process_Payroll_for_approval" && $field=="period_from") 
	{
		return Now();
	}
				if($table=="Process_Payroll_for_approval" && $field=="period_to") 
	{
		return Now();
	}
				if($table=="Process_Payroll_for_approval" && $field=="annualized") 
	{
		return 0;
	}
				if($table=="Process_Payroll_for_approval" && $field=="compute_phic") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_approval" && $field=="compute_sss") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_approval" && $field=="compute_pag-ibig") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_approval" && $field=="compute_tax") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_approval" && $field=="include_recurring_benefit") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_approval" && $field=="include_recurring_deductions") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_approval" && $field=="payroll_mode") 
	{
		return "Semi-Monthly";
	}
				if($table=="Process_Payroll_for_checking" && $field=="date_processed") 
	{
		return Now();
	}
				if($table=="Process_Payroll_for_checking" && $field=="period_from") 
	{
		return Now();
	}
				if($table=="Process_Payroll_for_checking" && $field=="period_to") 
	{
		return Now();
	}
				if($table=="Process_Payroll_for_checking" && $field=="annualized") 
	{
		return 0;
	}
				if($table=="Process_Payroll_for_checking" && $field=="compute_phic") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_checking" && $field=="compute_sss") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_checking" && $field=="compute_pag-ibig") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_checking" && $field=="compute_tax") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_checking" && $field=="include_recurring_benefit") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_checking" && $field=="include_recurring_deductions") 
	{
		return 1;
	}
				if($table=="Process_Payroll_for_checking" && $field=="payroll_mode") 
	{
		return "Semi-Monthly";
	}
				if($table=="Service_Report_for_approval" && $field=="date_attended") 
	{
		return Now();
	}
				if($table=="Service_Report_for_checking" && $field=="date_attended") 
	{
		return Now();
	}
				if($table=="return" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="fixed_asset_issue" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="fixed_asset_issue" && $field=="date_of_request") 
	{
		return Now();
	}
				if($table=="fixed_asset_issue" && $field=="date_of_return") 
	{
		return Now();
	}
				if($table=="cash_disbursment_detail_for_approval" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="cash_disbursment_detail_for_checking" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="trip_ticket_for_approval" && $field=="date_added") 
	{
		return Now();
	}
				if($table=="trip_ticket_for_approval" && $field=="loaded") 
	{
		return 0;
	}
				if($table=="trip_ticket_for_checking" && $field=="date_added") 
	{
		return Now();
	}
				if($table=="trip_ticket_for_checking" && $field=="loaded") 
	{
		return 0;
	}
				if($table=="trip_detail_for_approval" && $field=="from_date") 
	{
		return Now();
	}
				if($table=="trip_detail_for_approval" && $field=="to date") 
	{
		return Now();
	}
				if($table=="trip_detail_for_checking" && $field=="from_date") 
	{
		return Now();
	}
				if($table=="trip_detail_for_checking" && $field=="to date") 
	{
		return Now();
	}
				if($table=="sales_report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Collection_Report_per_Customer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Payment_per_Supplier_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Report_per_BP" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Report_per_Item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Report_per_Cost_Center" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Report_per_BP_detail" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Report_per_Item_detail" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Report_per_Cost_Center_detail" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Report_per_BP" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Report_per_Item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Report_per_Cost_Center" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Report_per_BP_detail" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Report_per_Item_detail" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Report_per_Cost_Center_detail" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Report_per_sales_rep" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Request_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Import_Costing" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Production_Costing_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Production_Costing_Report" && $field=="production_status") 
	{
		return Done;
	}
				if($table=="Production_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Closed_Opportunities" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="Cases_with_Sotutions" && $field=="status") 
	{
		return "Open";
	}
				if($table=="Totals_Cases_Created" && $field=="status") 
	{
		return "Open";
	}
				if($table=="Totals_Open_Cases_by_Agent" && $field=="status") 
	{
		return "Open";
	}
				if($table=="Campaign_Contacts" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Campaign_Contacts" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Campaign_leads" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Campaign_leads" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Campaign_Revenue" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Campaign_Revenue" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Opportunity_Schedule" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_by_Account" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_by_Lead_Source" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_by_Partner" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_by_Rep" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Leave_Summary" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Payroll_Register" && $field=="date_processed") 
	{
		return Now();
	}
				if($table=="Payroll_Register" && $field=="period_from") 
	{
		return Now();
	}
				if($table=="Payroll_Register" && $field=="period_to") 
	{
		return Now();
	}
				if($table=="Payroll_Register" && $field=="annualized") 
	{
		return 0;
	}
				if($table=="Payroll_Register" && $field=="compute_phic") 
	{
		return 1;
	}
				if($table=="Payroll_Register" && $field=="compute_sss") 
	{
		return 1;
	}
				if($table=="Payroll_Register" && $field=="compute_pag-ibig") 
	{
		return 1;
	}
				if($table=="Payroll_Register" && $field=="compute_tax") 
	{
		return 1;
	}
				if($table=="Payroll_Register" && $field=="include_recurring_benefit") 
	{
		return 1;
	}
				if($table=="Payroll_Register" && $field=="include_recurring_deductions") 
	{
		return 1;
	}
				if($table=="Payroll_Register" && $field=="payroll_mode") 
	{
		return "Semi-Monthly";
	}
				if($table=="DR_Reports" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Order_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Case_History" && $field=="status") 
	{
		return "Open";
	}
				if($table=="quality_control" && $field=="date") 
	{
		return Now();
	}
				if($table=="quality_control_detail" && $field=="purpose") 
	{
		return 'For Delivery';
	}
				if($table=="quality_control_detail" && $field=="item_status") 
	{
		return 'Good';
	}
				if($table=="budget" && $field=="date") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance" && $field=="date_purchased") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance" && $field=="date") 
	{
		return Now();
	}
				if($table=="production_form" && $field=="Delivery_Date") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Birth_date") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_from") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_To") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_from2") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_to2") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_from3") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_date_to3") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_from4") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_to4") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_Date_from5") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Inclusive_date_to5") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="Date") 
	{
		return Now();
	}
				if($table=="bluewave_employees" && $field=="date_hired") 
	{
		return Now();
	}
				if($table=="bluewave_employees_detail" && $field=="Birthdate1") 
	{
		return Now();
	}
				if($table=="bluewave_employees_detail" && $field=="Birthdate2") 
	{
		return Now();
	}
				if($table=="bluewave_employees_detail4" && $field=="Inclusive_date_to") 
	{
		return Now();
	}
				if($table=="rfp" && $field=="Date_Payment_Needed") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance_detail" && $field=="date_of_prepare") 
	{
		return Now();
	}
				if($table=="marketing_colateral" && $field=="date_published") 
	{
		return Now();
	}
				if($table=="email" && $field=="date") 
	{
		return Now();
	}
				if($table=="sub_contract" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="sub_contract" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="sub_contract" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="sub_contract_billing_detail" && $field=="date") 
	{
		return Now();
	}
				if($table=="sub_contract_detail" && $field=="billing_start_date") 
	{
		return Now();
	}
				if($table=="Overtime_Summary_Report" && $field=="date") 
	{
		return Now();
	}
				if($table=="sales_order" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="sales_order" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="sales_order" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="sales_order" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="sales_order_detail" && $field=="billing_start_date") 
	{
		return Now();
	}
				if($table=="marketing_request_form" && $field=="date_requested") 
	{
		return Now();
	}
				if($table=="marketing_request_form" && $field=="deadline_draft") 
	{
		return Now();
	}
				if($table=="marketing_request_form" && $field=="deadline_final") 
	{
		return Now();
	}
				if($table=="marketing_request_form" && $field=="actual_draft") 
	{
		return Now();
	}
				if($table=="marketing_request_form" && $field=="actual_final") 
	{
		return Now();
	}
				if($table=="Quotation_Dashboard_Customer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Order_Dashboard_Customer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Order_Dashboard_Customer" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Delivery_Receipt_Dashboard_Customer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Dashboard_Customer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Dashboard_Customer" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Sales_Dashboard_Customer" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Backload_Dashboard_Customer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Request_Dashboard_Supplier" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Request_Dashboard_Supplier" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Dashboard_Supplier" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Dashboard_Supplier" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Dashboard_Supplier" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Purchase_Order_Dashboard_Supplier" && $field=="invoice_date") 
	{
		return Now();
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="Terms_Discount_percent") 
	{
		return 0;
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="Terms_Discount_days") 
	{
		return 0;
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="Terms_due_date") 
	{
		return 0;
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="Due_Date") 
	{
		return now();
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Purchase_Dashboard_Supplier" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="importation") 
	{
		return 0;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="currecy") 
	{
		return 1;
	}
				if($table=="Cash_Disbursement_Dashboard_Supplier" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Debit_Memo_Dashboard_Supplier" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Request_Dashboard_Item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Request_Dashboard_Item" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Dashboard_Item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Dashboard_Item" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Dashboard_Item" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Purchase_Order_Dashboard_Item" && $field=="invoice_date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Item" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Item" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Item" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Item" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Production_Dashboard_Item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Production_Dashboard_Item" && $field=="production_status") 
	{
		return Done;
	}
				if($table=="sub_contract_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="sub_contract_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="budget_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="budget_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="undertime_for_approval" && $field=="system_date") 
	{
		return Now();
	}
				if($table=="undertime_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="undertime_for_checking" && $field=="system_date") 
	{
		return Now();
	}
				if($table=="undertime_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="request_for_payment_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="request_for_payment_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance_detail_for_approval" && $field=="date_of_prepare") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance_for_approval" && $field=="date_purchased") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance_for_checking" && $field=="date_purchased") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="repairs_and_maintenance_detail_for_checking" && $field=="date_of_prepare") 
	{
		return Now();
	}
				if($table=="Disposal_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Active_campaign_report" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Active_campaign_report" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="For_Billing_report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="sales_order_for_project_mngmt" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Deposit_Report" && $field=="transadate") 
	{
		return Now();
	}
				if($table=="SO_for_Billing_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Billing_due_dates_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Packing_List_Report" && $field=="delivery_date") 
	{
		return Now();
	}
				if($table=="Open_Trip_Ticket_Report" && $field=="date_added") 
	{
		return Now();
	}
				if($table=="Open_Trip_Ticket_Report" && $field=="loaded") 
	{
		return 0;
	}
				if($table=="Transfer_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Open_Case_Report_s" && $field=="status") 
	{
		return "Open";
	}
				if($table=="Sales_Order_per_Campaign_Report_marketing" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_per_campaign_Report_marketing" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Deposit_in_transit_Report" && $field=="transadate") 
	{
		return Now();
	}
				if($table=="Outstanding_Checks_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Outstanding_Checks_Report" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="Outstanding_Checks_Report" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Outstanding_Checks_Report" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="Outstanding_Checks_Report" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Outstanding_Checks_Report" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="Outstanding_Checks_Report" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="Outstanding_Checks_Report" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Outstanding_Checks_Report" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Outstanding_Checks_Report" && $field=="importation") 
	{
		return 0;
	}
				if($table=="Outstanding_Checks_Report" && $field=="currecy") 
	{
		return 1;
	}
				if($table=="Outstanding_Checks_Report" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Absences_Detail_Report" && $field=="daily_dates") 
	{
		return Now();
	}
				if($table=="Absences_Report" && $field=="daily_dates") 
	{
		return Now();
	}
				if($table=="Followup_Report" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="Followup_Report" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="Coming_Meeting_Report" && $field=="date") 
	{
		return Now();
	}
				if($table=="Coming_Meeting_Report" && $field=="status") 
	{
		return "Planned";
	}
				if($table=="Coming_Meeting_Report" && $field=="done") 
	{
		return 0;
	}
				if($table=="Meeting_Report" && $field=="date") 
	{
		return Now();
	}
				if($table=="Meeting_Report" && $field=="status") 
	{
		return "Planned";
	}
				if($table=="Meeting_Report" && $field=="done") 
	{
		return 0;
	}
				if($table=="Calls_Report" && $field=="date") 
	{
		return Now();
	}
				if($table=="Calls_Report" && $field=="status") 
	{
		return "Planned";
	}
				if($table=="sales_per_sales_rep_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="sales_per_sales_rep_Report" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="sales_per_sales_rep_Report" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="date_processed") 
	{
		return Now();
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="period_from") 
	{
		return Now();
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="period_to") 
	{
		return Now();
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="annualized") 
	{
		return 0;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="compute_phic") 
	{
		return 1;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="compute_sss") 
	{
		return 1;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="compute_pag-ibig") 
	{
		return 1;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="compute_tax") 
	{
		return 1;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="include_recurring_benefit") 
	{
		return 1;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="include_recurring_deductions") 
	{
		return 1;
	}
				if($table=="Withholding_Tax_Collection_List_per_Month_Report" && $field=="payroll_mode") 
	{
		return "Semi-Monthly";
	}
				if($table=="Quotation_Dashboard" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Order_Dashboard" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Order_Dashboard" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Sales_Order_Dashboard" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Reimbursement_Dashboard" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Loan_Dashboard" && $field=="date") 
	{
		return Now();
	}
				if($table=="Leave_Dashboard" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Leave_Dashboard" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Over_Time_Dashboard" && $field=="date") 
	{
		return Now();
	}
				if($table=="Undertime_Dashboard" && $field=="system_date") 
	{
		return Now();
	}
				if($table=="Undertime_Dashboard" && $field=="date") 
	{
		return Now();
	}
				if($table=="Change_Time_Dashboard" && $field=="date") 
	{
		return Now();
	}
				if($table=="Change_Time_Dashboard" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Change_Time_Dashboard" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="lyl_estimate_dr" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="lyl_estimate_dr" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="petty_cash_for_liquidation" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="item_cost_recalculation" && $field=="date") 
	{
		return Now();
	}
				if($table=="item_cost_recalculation" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="item_cost_recalculation" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="issue_components" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="unbuild_assemblies" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="demand_plan" && $field=="date") 
	{
		return Now();
	}
				if($table=="input_vat_allocation" && $field=="date") 
	{
		return Now();
	}
				if($table=="qc_inspection" && $field=="Rev_&_Date") 
	{
		return Now();
	}
				if($table=="packing_list_for_checking" && $field=="delivery_date") 
	{
		return Now();
	}
				if($table=="packing_list_for_approval" && $field=="delivery_date") 
	{
		return Now();
	}
				if($table=="disposed_inv_detail" && $field=="expiry_date") 
	{
		return Now();
	}
				if($table=="disposed_inv" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Customer_For_Approval" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="Customer_For_Approval" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="credit_memo_report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="debit_memo_report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="production_request_report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="approved_sales_order" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="approved_sales_order" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="purchase_order_for_receiving" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="purchase_order_for_receiving" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="purchase_order_for_receiving" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="purchase_order_for_receiving" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="purchase_order_for_receiving" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="packing_list" && $field=="delivery_date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Purchase_Order_Receiving_Dashboard_Supplier" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="monthly_consuption_for_production_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="issue_components_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="issue_components_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="fieldwork_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="fieldwork_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="Purchases_Order_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchases_Order_for_checking" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Purchases_Order_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Purchases_Order_for_approval" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Receiving_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Receiving_for_checking" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Receiving_for_checking" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Receiving_for_checking" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Receiving_for_checking" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="Receiving_for_approval" && $field=="release_date") 
	{
		return Now();
	}
				if($table=="Receiving_for_approval" && $field=="date_of_importation") 
	{
		return Now();
	}
				if($table=="inventory_tranfer_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="cash_sales_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="cash_sales_Report" && $field=="Gross_Sale") 
	{
		return 0;
	}
				if($table=="cash_sales_Report" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="cash_sales_Report" && $field=="EWT_Amount") 
	{
		return 0;
	}
				if($table=="cash_sales_Report" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="cash_sales_Report" && $field=="vatable") 
	{
		return 0;
	}
				if($table=="cash_sales_Report" && $field=="cash_collection") 
	{
		return 0;
	}
				if($table=="cash_sales_Report" && $field=="Net_pay") 
	{
		return 0;
	}
				if($table=="Center_Replenishment_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Center_Replenishment_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Production_Summary" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Production_Summary" && $field=="expiry_date") 
	{
		return Now();
	}
				if($table=="unbuild_assemblies_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="unbuild_assemblies_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="quality_control_for_approval" && $field=="date") 
	{
		return Now();
	}
				if($table=="quality_control_for_checking" && $field=="date") 
	{
		return Now();
	}
				if($table=="Current_Accounts" && $field=="inactive") 
	{
		return 0;
	}
				if($table=="Current_Accounts" && $field=="next_action_date") 
	{
		return Now();
	}
				if($table=="Collection_Report_per_Sales_Rep" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_checking" && $field=="date_requested") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_checking" && $field=="deadline_draft") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_checking" && $field=="deadline_final") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_checking" && $field=="actual_draft") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_checking" && $field=="actual_final") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_approval" && $field=="date_requested") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_approval" && $field=="deadline_draft") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_approval" && $field=="deadline_final") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_approval" && $field=="actual_draft") 
	{
		return Now();
	}
				if($table=="marketing_request_form_for_approval" && $field=="actual_final") 
	{
		return Now();
	}
				if($table=="201" && $field=="no_days") 
	{
		return 261;
	}
				if($table=="Business_Owner_Sales_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Business_Owner_Purchase_Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Finance_approved_request_for_payment" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Finance_Approved_Employee_Loan" && $field=="date") 
	{
		return Now();
	}
				if($table=="production_per_item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="production_per_item" && $field=="production_status") 
	{
		return Done;
	}
				if($table=="DR_per_Item" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="DR_per_Item" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="Logistic_Open_Trip_Ticket" && $field=="date_added") 
	{
		return Now();
	}
				if($table=="Marketing_Open_Campaign" && $field=="start_date") 
	{
		return Now();
	}
				if($table=="Marketing_Open_Campaign" && $field=="end_date") 
	{
		return Now();
	}
				if($table=="Support_Open_Case_Report" && $field=="status") 
	{
		return "Open";
	}
				if($table=="Sale_Meeting_Report" && $field=="date") 
	{
		return Now();
	}
				if($table=="Sale_Meeting_Report" && $field=="status") 
	{
		return "Planned";
	}
				if($table=="Sale_Meeting_Report" && $field=="done") 
	{
		return 0;
	}
				if($table=="HR_holiday" && $field=="date") 
	{
		return Now();
	}
				if($table=="Production_WIP" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="logistic_open_inventory_tranfer" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Sales_Leads" && $field=="type") 
	{
		return "Customer";
	}
				if($table=="intercompany_sales_order" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="production_detail" && $field=="expiry_date") 
	{
		return Now();
	}
				if($table=="lyl_estimate_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="lyl_estimate_dr_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="lyl_estimate_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="lyl_estimate_dr_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="EWT_Certificates_summay" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="EWT_Certificates_summay" && $field=="EWT_Amount") 
	{
		return 0;
	}
				if($table=="request_for_quote" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="request_for_quote_for_checking" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="request_for_quote_for_approval" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="project_house" && $field=="date") 
	{
		return now();
	}
				if($table=="project_house" && $field=="type") 
	{
		return Consolidation;
	}
				if($table=="project_house" && $field=="broker_info") 
	{
		return 888;
	}
				if($table=="project_house" && $field=="disch_date") 
	{
		return now();
	}
				if($table=="project_house" && $field=="desti_date") 
	{
		return now();
	}
				if($table=="project_house" && $field=="status1") 
	{
		return OPEN;
	}
				if($table=="project_house" && $field=="vol_status") 
	{
		return OPEN;
	}
				if($table=="projects_dashboard" && $field=="expected_start_date") 
	{
		return Now();
	}
				if($table=="projects_dashboard" && $field=="expected_finish_date") 
	{
		return Now();
	}
				if($table=="projects_dashboard" && $field=="date") 
	{
		return now();
	}
				if($table=="projects_dashboard" && $field=="disch_date") 
	{
		return now();
	}
				if($table=="projects_dashboard" && $field=="desti_date") 
	{
		return now();
	}
				if($table=="notifiy quotation Report" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="notifiy quotation Report" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="petty cash release" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="petty cash release" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="petty cash release" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="petty cash replenishment" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="petty cash replenishment" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="petty cash replenishment" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Employee Advance Release" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Employee Advance Release" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Employee Advance Replenishment" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Employee Advance Replenishment" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Liquidation Release" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Liquidation Release" && $field=="Payable_Account") 
	{
		return 20;
	}
				if($table=="Liquidation Release" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Liquidation Release" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="Liquidation Replenishment" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="Liquidation Replenishment" && $field=="Payable_Account") 
	{
		return 20;
	}
				if($table=="Liquidation Replenishment" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="Liquidation Replenishment" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="centerrep_pettycash" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="centerrep_empadvance" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="centerrep_liquidation" && $field=="ord") 
	{
		return $_SESSION["Nextnumber"];
	}
				if($table=="project_liquidation_detail2" && $field=="new_balance") 
	{
		return 0;
	}
				if($table=="project_replenishment_deposited" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="project_replenishment_deposited" && $field=="Payable_Account") 
	{
		return 20;
	}
				if($table=="project_replenishment_deposited" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="project_replenishment_deposited" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="project_replenishment_deposited" && $field=="balance") 
	{
		return 0;
	}
				if($table=="projects_view" && $field=="date") 
	{
		return now();
	}
				if($table=="projects_lite" && $field=="date") 
	{
		return now();
	}
				if($table=="projects_lite" && $field=="classification") 
	{
		return 5;
	}
				if($table=="projects_lite" && $field=="disch_date") 
	{
		return now();
	}
				if($table=="projects_lite" && $field=="desti_date") 
	{
		return now();
	}
				if($table=="projects_lite" && $field=="status1") 
	{
		return OPEN;
	}
				if($table=="projects_lite" && $field=="vol_status") 
	{
		return OPEN;
	}
				if($table=="representative" && $field=="type") 
	{
		return "Representative";
	}
				if($table=="sales_business_partner" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="sales_business_partner" && $field=="Receivable_Account") 
	{
		return 5;
	}
				if($table=="sales_business_partner" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="sales_business_partner" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="sales_business_partner" && $field=="currency") 
	{
		return 1;
	}
				if($table=="sales_business_partner" && $field=="exchange_rate") 
	{
		return 1;
	}
				if($table=="sales_business_partner" && $field=="type_of_invoice") 
	{
		return "Regular";
	}
				if($table=="sales_business_partner" && $field=="sv") 
	{
		return 0;
	}
				if($table=="canvas" && $field=="Transadate") 
	{
		return Now();
	}
				if($table=="canvas" && $field=="Due_Date") 
	{
		return Now();
	}
				if($table=="canvas" && $field=="Discount_Amount") 
	{
		return 0;
	}
				if($table=="canvas" && $field=="Taxable") 
	{
		return 1;
	}
				if($table=="request_for_payment" && $field=="Transadate") 
	{
		return now();
	}
				if($table=="request_for_payment" && $field=="Due_Date") 
	{
		return now();
	}
	return "";
}

/**
 * @intellisense
 */
function GetAutoUpdateValue($field, $ptype, $table="")
{
	global $strTableName;
	if(!$table)
		$table=$strTableName;
				if($table=="reimbursement" && $field=="Payable_Account") 
	{
		return 7;
	}
				if($table=="cash_disbursement_detail2" && $field=="VAT_Rate") 
	{
		return 0;
	}
				if($table=="cash_disbursement_detail2" && $field=="Vat_Amount") 
	{
		return 0;
	}
				if($table=="cash_receipt_detail" && $field=="Account ID") 
	{
		return 5;
	}
				if($table=="project_replenishment" && $field=="Payable_Account") 
	{
		return 20;
	}
				if($table=="project_replenishment_deposited" && $field=="Payable_Account") 
	{
		return 20;
	}
	return "";
}

/**
 * @intellisense
 */
function GetUploadFolderExpression($field, $file, $table="")
{
	global $strTableName;
	if(!$table)
		$table = $strTableName;
	return "";
}

/**
 * @intellisense
 */
function mdeleteIndex($i)
{
	return $i-1;
}

/**
 * Call function stack info parser
 * Return array of function calls
 
 * @intellisense
 * @return array
 */
function parse_backtrace($errfFile, $errLine, $splitAsArray = true)
{
    // get backtrace array
    $backtrace = debug_backtrace();
    
    // delete calls to error handler functions
	foreach ($backtrace as $i => $call) 
    {
    	// cut error handlers calls etc.
    	if ($call['function'] == 'parse_backtrace' ||  $call['function'] == 'error_handler' || $call['function'] == 'trigger_error'){
    		array_shift($backtrace);
    		continue;
    	}
    }
    // if no data return empty array
    if (count($backtrace) == 0) {
        return array();
    }
   
    
    $backTraceLen = count($backtrace);
    $backtrace[$backTraceLen]['file'] = $backtrace[$backTraceLen-1]['file'];
    $backtrace[$backTraceLen]['line'] = $backtrace[$backTraceLen-1]['line'];
    $backtrace[$backTraceLen]['function'] =  'Global scope';
    
    
 	// make shift of file: line, for better view. It will show not line where function were called, but line where in function error was happend
    for($i=0;$i<count($backtrace);$i++) 
    {
    	$errorLineBefore = $backtrace[$i]['line'];
    	$errorFileBefore = $backtrace[$i]['file'];
    	$backtrace[$i]['file'] = $errfFile;
    	$backtrace[$i]['line'] = $errLine;
    	$errLine = $errorLineBefore;
    	$errfFile = $errorFileBefore;
    }
    
    // result array with data
    $funCallsArray = array();
    // parse array
    foreach ($backtrace as $i => $call) 
    {    	
    	// proccess the data that may not exist
    	if (isset($call['file']))
    	{
    		// get path to the root
			$pathToRoot = substr(dirname(__FILE__),0,strlen(dirname(__FILE__))-strlen("include"));
			// replace it
			$call['file'] = str_replace($pathToRoot, '', $call['file']);			
    	}
    	else
    	{
    		$call['file'] = '(null)';
			    		
    	}
    	//$call['file'] = !isset($call['file']) ? '(null)' : $call['file'];
    	$call['line'] = !isset($call['line']) ? '0' : $call['line'];
		// proccess file and error line 
        $location = $call['file'] . ':' . $call['line'];
        // if object method was called
        if (isset($call['class']))
        {
        	$function = $call['class'].(isset($call['type']) ? $call['type'] : '.').$call['function'];
        
        }// if function
        else
        {
        	$function = $call['function'];
        }
		// proccess arguments
        $params = '';
        if (isset($call['args'])) 
        {
            $args = array();
            $j=0;
            foreach ($call['args'] as $arg) 
            {
            	$j++;
            	// proccess array
                if (is_array($arg)) 
                {
                	$arrStr = print_r($arg, true);
                    $arrStr = strlen($arrStr) < 200 ? $arrStr : substr($arrStr, 0, 200).'...';
                    $args[] = $j.'.&nbsp;'.runner_htmlspecialchars($arrStr).';';
                } 
                // process objects
                elseif (is_object($arg)) 
                {
                    $args[] = $j.'.&nbsp;'.runner_htmlspecialchars(get_class($arg)).';';
                } 
                // another arguments
                else 
                {
                	$arg = @strlen($arg) < 200 ? $arg : @runner_htmlspecialchars(substr($arg, 0, 200)).'...';
                    $args[] = $j.'.&nbsp;'.$arg.';';
                }
            }            
            $params = implode('<br/> ', $args);
        } 
		// add in finish array all params		
		if (!$splitAsArray)
		{
			$funCallsArray[] = '#'.$i.'&nbsp;&nbsp;'.$function.'('.$params.')&nbsp;&nbsp;called&nbsp;at&nbsp;['.$location.']';
		}
		else 
		{			
			$funCallsArray[] = array('num' => '#'.$i.'.&nbsp;', 'path' => $location, 'func'=>$function, 'args'=>(strlen($params) ? $params : 'N/A'));				
		}		
    }
    
    // return array with call functions strings
    return $funCallsArray;
}

/**
 * display error message
 * @intellisense
 */
function runner_error_handler($errno, $errstr, $errfile, $errline)
{
	global $strLastSQL;
	global $globalSettings;
	
	if ($errno==2048 || $errno == 8)
		return 0;	
	if($errno==8192)
	{
		if($errstr=="Assigning the return value of new by reference is deprecated")
			return 0;
		if(strpos($errstr,"set_magic_quotes_runtime"))
			return 0;
	}

	if ($errno==2){
		if (strpos($errstr,"Can't contact LDAP server"))
			return 0;
		if (strpos($errstr,"Invalid credentials"))
			return 0;
	}
	
	if($errno==2 && strpos($errstr,"has been disabled for security reasons"))
		return 0;
	if($errno==2 && strpos($errstr,"Data is not in a recognized format"))
		return 0;
	if($errno==8 && !strncmp($errstr,"Undefined index",15))
		return 0;
	if(strpos($errstr,"It is not safe to rely on the system's timezone settings."))
		return 0;	
	if(strpos($errstr,"fopen(")===0)
		return 0;
		
	if($errno==2 && strpos($errstr,"facebook.com"))
		return 0;
	if($errno==2 && strpos($errstr,"ldap") !==false )
		return 0;

	if ( !$globalSettings["showDetailedError"] )
	{
		echo $globalSettings["customErrorMessage"];
		exit(0);
	} 
	
	// show error htm
	if(!class_exists("Xtempl"))
		require_once(getabspath("include/xtempl.php"));
		
	$xt = new Xtempl();
	$xt->assign('errno', $errno);
	$xt->assign('errstr', $errstr);
	
	$url = $_SERVER["SERVER_NAME"].$_SERVER["SCRIPT_NAME"]; 
	if(array_key_exists("QUERY_STRING",$_SERVER))
	{ 
		$url .= "?".runner_htmlspecialchars($_SERVER["QUERY_STRING"]);
	}
	
	$xt->assign('url', $url);
	$xt->assign('errfile', $errfile);
	$xt->assign('errline', $errline);
	
	$sqlStr = isset($strLastSQL) ? runner_htmlspecialchars(substr($strLastSQL,0,1024)) : ''; 
	$xt->assign('sqlStr', $sqlStr);
	
	$debugInfoArr = parse_backtrace($errfile, $errline);
	$xt->assign_loopsection('debugRow', $debugInfoArr);	
			
	$xt->displayPartial(GetTemplateName("", 'error'));
	
	exit(0);
}

/**
 * @intellisense
 */
function no_output_done()
{
	if(headers_sent())
		return false;
	if(ob_get_length())
		return false;
	return true;
}

/**
 * @intellisense
 */
function format_currency($val)
{
	return str_format_currency($val);
}

/**
 * @intellisense
 */
function format_number($val,$valDigits = false)
{
	return str_format_number($val,$valDigits);
}

function formatNumberForHTML5($value)
{
	return $value;
}

/**
 * @intellisense
 */
function format_datetime($time)
{
	return str_format_datetime($time);
}

/**
 * @intellisense
 */
function format_time($time)
{
	return str_format_time($time);
}

/**
 * @intellisense
 */
function secondsPassedFrom($datetime)
{
	$arrDateTime=db2time($datetime);
	return time()-mktime($arrDateTime[3],$arrDateTime[4],$arrDateTime[5],$arrDateTime[1],$arrDateTime[2],$arrDateTime[0]);
}

/**
 * @intellisense
 */
function xtempl_call_func($func,&$params)
{
	if(function_exists($func))
	{
		$func($params);
	}
}

/**
 * @intellisense
 */
function echoBinary($string, $bufferSize = 8192)
{
	for ($chars=strlen($string)-1,$start=0;$start <= $chars;$start += $bufferSize) 
		echo substr($string,$start,$bufferSize);
}

/**
 * @intellisense
 */
function echoBinaryPartial($string, $startPos, $endPos, $bufferSize = 8192)
{
	$length = $endPos - $startPos + 1;
	if($length < $bufferSize)
		$bufferSize = $length;
	for ($start = $startPos; $start <= $endPos && $bufferSize > 0;)
	{ 
		echo substr($string, $start, $bufferSize);
		$start += $bufferSize;
		if($start + $bufferSize > $length)
			$bufferSize = $length - $start;
	}
}

/**
 * @intellisense
 */
function setObjectProperty(&$obj,$key,&$value)
{
	$obj->$key = &$value;		
}

/**
 * @intellisense
 */
function returnError404()
{
	header("HTTP/1.0 404 Not Found");
}

/**
 * @intellisense
 */
function execute_events(&$params)
{
	if(function_exists(@$params["custom1"]))
		eval($params["custom1"].'($params);');
}

/**
 * @intellisense
 */
function GetMySQLLastInsertID( $connection )
{
//	select LAST_INSERT_ID() for ASP
	return $connection->getInsertedId();
}

/**
 * @intellisense
 */
function DoUpdateRecord( $pageObject )
{
	return DoUpdateRecordSQL( $pageObject );
}
/**
 * @intellisense
 */
function DoInsertRecord($table, &$avalues, &$blobfields, &$pageObject)
{
	return DoInsertRecordSQL($table, $avalues, $blobfields, $pageObject);	
}

/**
 * @intellisense
 * @param RunnerPage pageObject
 * @return Boolean
 */
function DoInsertRecordOnAdd( &$pageObject )
{
	return DoInsertRecordSQLOnAdd( $pageObject );
}

/**
 * @intellisense
 */
function xtempl_include_header($xt,$fname,$param)
{
	$xt->assign_function($fname,"xt_include",array("file"=>$param));
}


$db_query_safe_errstr ="";
$db_query_safe_err = false;
/**
 * @param String qstring
 * @param &String errstring
 * @param Connection connection (optional)
 * @return Mixed
 * Todo: It should return QueryResult object //#9875
 * @intellisense
 */
/*function db_query_safe($qstring, &$errstring, $connection = null) 
{
	global $db_query_safe_errstr, $db_query_safe_err;
	
	$db_query_safe_errstr = "";
	$db_query_safe_err = false;
	$errhandler = set_error_handler("errhandler_db_query_safe");
	
	if( is_null($connection) )
		$connection = getDefaultConnection();
	
	$rs = $connection->query( $qstring )->getQueryHandle();
	
	set_error_handler( $errhandler );
	$errstring = $db_query_safe_errstr;
	if( $db_query_safe_err )
		return false;
	
	return $rs;
}*/

/**
 * @intellisense
 */
/*function errhandler_db_query_safe($errno, $errstr, $errfile, $errline)
{
	global $db_query_safe_errstr, $db_query_safe_err;
	
	if( $errno==E_ERROR || $errno==E_USER_ERROR )
		$db_query_safe_err = true;

	$db_query_safe_errstr.= "<br>".$errstr;
}*/

/**
 * @intellisense
 */
function binPrint(&$value, $size)
{
	echobig($value,$size); 
}

/**
 * construct "good" field name
 * @intellisense
 */
function GoodFieldName($field)
{
	global $cCharset;
	if ($cCharset == "utf-8"){
		$field = utf8_decode($field);
	}
	$field=(string)$field;	
	$out="";
	for($i=0;$i<strlen($field);$i++)
	{
		$t=substr($field,$i,1);
		if((ord($t)<ord('a') || ord($t)>ord('z')) && (ord($t)<ord('A') || ord($t)>ord('Z')) && (ord($t)<ord('0') || ord($t)>ord('9')))
			$out.='_';
		else
			$out.=$t;
	}
	return $out;
}

/**
 * @intellisense
 */
function xt_getvar(&$xt,$name)
{
	global $testingLinks;
	for($i = count($xt->xt_stack)-1;$i>=0;$i--)
	{
		if(isset($xt->xt_stack[$i][$name]))
			return $xt->xt_stack[$i][$name];
	}
	if(!$xt->testingFlag)
		return false;
		
	if(isset($testingLinks[$name]))
		return "func=\"".$testingLinks[$name]."\"";
	else
		return false;
}

/**
 * @intellisense
 */
function xt_process_template(&$xt,$str)
{
//	parse template file tag by tag
	$varparams=array();
	$start=0;
	$literal=false;
	$len = strlen($str);
	while(true)
	{
		$pos = strpos($str,"{",$start);
		if($pos===false)
		{
			echo substr($str,$start,$len-$start);
			break;
		}
		$section=false;
		$var=false;
		$message=false;
		if(substr($str,$pos+1,6)=="BEGIN ")
			$section=true;
		elseif(substr($str,$pos+1,1)=='$')
			$var=true;
		elseif(substr($str,$pos+1,14)=='mlang_message ')
		{
			$message=true;
		}
		else
		{
//	no tag, just '{' char
			echo substr($str,$start,$pos-$start+1);
			$start=$pos+1;
			continue;
		}
		echo substr($str,$start,$pos-$start);
		if($section)
		{
//	section
			$endpos=strpos($str,"}",$pos);
			if($endpos===false)
			{
				$xt->report_error("Page is broken");
				return;
			}
			$section_name=trim(substr($str,$pos+7,$endpos-$pos-7));
			$endtag="{END ".$section_name."}";
			$endpos1=strpos($str,$endtag,$endpos);
			if($endpos1===false)
			{
				echo "End tag not found:".runner_htmlspecialchars($endtag);
				$xt->report_error("Page is broken");
				return;
			}
			$section=substr($str,$endpos+1,$endpos1-$endpos-1);
			$start=$endpos1+strlen($endtag);
			$sectionVar = xt_getvar($xt,$section_name);
			if($sectionVar===false)
			{
				continue;
			}
			$begin="";
			$end="";
			if(is_array($sectionVar))
			{
				$begin=@$sectionVar["begin"];
				$end=@$sectionVar["end"];
				
				$var=@$sectionVar["data"];
			}
			else
			{
				$var = $sectionVar;
			}
			if(!is_array($var))
			{
//	if section
				echo $begin;
				if(is_array($sectionVar))
					$xt->xt_stack[]=&$sectionVar;
				xt_process_template($xt,$section);
				if(is_array($sectionVar))
					array_pop($xt->xt_stack);
				$xt->processVar($end, $varparams);
			}
			else
			{
//	foreach section
				echo $begin;
				$keys=array_keys($var);
				foreach($keys as $i)
				{
					$xt->xt_stack[]=&$var[$i];
					if(is_array($var[$i]) && isset($var[$i]["begin"]))
						echo $var[$i]["begin"];
					xt_process_template($xt,$section);
					array_pop($xt->xt_stack);
					if(is_array($var[$i]) && isset($var[$i]["end"]))
						echo $var[$i]["end"];
				}
				$xt->processVar($end, $varparams);
			}
		}
		elseif($var)
		{
//	display a variable or call a function
			$endpos=strpos($str,"}",$pos);
			if($endpos===false)
			{
				$xt->report_error("Page is broken");
				return;
			}
			$varparams=array();
			$var_name = trim(substr($str,$pos+2,$endpos-$pos-2));
			if(strpos($var_name," ")!==FALSE)
			{
				$varparams = explode(" ",$var_name);
				$var_name = $varparams[0];
				unset($varparams[0]);
			}
			$start=$endpos+1;
			$var = xt_getvar($xt,$var_name);
			if($var===false)
			{
				continue;
			}	
			$xt->processVar($var, $varparams);
		}
		elseif($message)
		{
			$endpos=strpos($str,"}",$pos);
			if($endpos===false)
			{
				$xt->report_error("Page is broken");
				return;
			}
			$tag = trim(substr($str,$pos+15,$endpos-$pos-15));
			$start=$endpos+1;
			echo runner_htmlspecialchars(mlang_message($tag));
		}
	}
}

/**
 * @intellisense
 */
function parse_addr_list($to)
{
	$addr_arr = array();
	
	$to = preg_replace('/^[\s*,]+|[\s*,]+$/',"", $to);
	$to = preg_replace('/\s+,/',",", $to);
	//split $to by ',' not surrounded by quotes or round brackets	
	$arr = preg_split('/(,(?=([^"]*("[^"]*")?)*$))(?![^\(]*(\),|\)$))/', $to); 
   
  	$matches = array();
    foreach($arr as $item)
	{
		$item = trim($item); 
		if($item != "")
		{
			//match an email not surrounded by quotes or round brackets			
			preg_match_all('/(([A-Za-z\d_\-\.+]+@[A-Za-z\d_\-\.]+\.[A-Za-z\d_\-]+)(?=([^"]*("[^"]*")?)*$))(?![^\(]*(\),|\)$))/', $item, $matches);
			if(count($matches[0]) == 1)
			{
			    $name = preg_replace('/(([A-Za-z\d_\-\.+]+@[A-Za-z\d_\-\.]+\.[A-Za-z\d_\-]+)(?=([^"]*("[^"]*")?)*$))(?![^\(]*(\),|\)$))/',"", $item);
			    $name = preg_replace('/"|<>$/',"", $name);
				$addr_arr[] = array('addr' => $matches[0][0], 'name' => $name);
			}
		}
	}	

	return $addr_arr;
}

/**
 * @intellisense
 */
function runner_mail_smtp($params)
{
	$mail = new PHPMailer();
	$mail->IsSMTP(); // telling the class to use SMTP

	$from = isset($params['from']) ? $params['from'] : "";
	if(!$from)
	{
		$from = "info@8box.solutions";
	}
	$to = isset($params['to']) ? $params['to'] : "";
	$body = isset($params['body']) ? $params['body'] : "";
	
	$subject = $params['subject'];
	
	if ("1" == "1" && "info@8box.solutions"!="" || isset($params['username']))
	{
		$mail->SMTPAuth   = true;                  				// enable SMTP authentication
		$mail->Username   = isset($params['username']) ? $params['username'] : "info@8box.solutions";  		// SMTP username
		$mail->Password   = isset($params['password']) ? $params['password'] : "amdl335";   // SMTP password
	}else{
		$mail->SMTPAuth = false;
	}
	if("1" == "1" && "mail.8box.solutions" != "" || isset($params['host']))
	{
		$mail->Host = isset($params['host']) ? $params['host'] : "mail.8box.solutions";     // sets SMTP server
	}
	else if(ini_get('SMTP') != '')
		$mail->Host = ini_get('SMTP');
		
	if("1" == "1" && "25" != "" || isset($params['port']))
		$mail->Port = isset($params['port']) ? $params['port'] + 0 : "25"+0;     	// set the SMTP port
	else if(ini_get('smtp_port') != '')
		 $mail->Port = ini_get('smtp_port')+0;
	if ("0" == "1")
		$mail->SMTPSecure = "ssl";
	
	
	$mail->SetFrom($from, isset($params['fromName']) ? $params['fromName'] : "");
	
	
	$mail->Subject    = $subject;
	
	if ($to != ""){
		$arr_to = array();
		$arr_to = parse_addr_list($to);
		
		foreach($arr_to as $email){
			$mail->AddAddress($email['addr'], $email['name']);
		}
	}
		
	
	// replyTo
	if ( isset($params['replyTo']) )
		$mail->AddReplyTo($params['replyTo'],"");
		
	// body, htmlbody
	if (isset($params['htmlbody']))
	{
		$mail->AltBody    = $body; 
		$mail->MsgHTML($params['htmlbody']);	
	}
	else
	{
		$mail->Body    = $body;
	}
	
	
	// charset
	if (isset($params['charset']))
		$mail->CharSet = $params['charset'];
	else
		$mail->CharSet = "utf-8";
	

	// priority
	if (isset($params['priority']))
		$mail->Priority = isset($params['priority']);
	
	// CC/BCC
	
	
	if (isset($params['cc'])){
		$arr_cc = array();
		$arr_cc = parse_addr_list($params['cc']);
		
		foreach($arr_cc as $cc){
			$mail->AddCC($cc['addr'], $cc['name']);
		}
	}			
			
	if (isset($params['bcc'])){
		$arr_cc = array();
		$arr_cc = parse_addr_list($params['bcc']);
		
		foreach($arr_cc as $bcc){
			$mail->AddBCC($bcc['addr'], $bcc['name']);
		}
	}

	if(isset($params['attachments']) && is_array($params['attachments'])){
		foreach ($params['attachments'] as $attachment){
			$mail->AddAttachment($attachment['path'], 
				isset($attachment['name']) ? $attachment['name'] : '', 
				isset($attachment["encoding"]) ? $attachment["encoding"] : 'base64', 
				isset($attachment["type"]) ? $attachment["type"] : 'application/octet-stream');
		}
	}	

	$res = $mail->Send();

	return array('mailed' => $res, "message"=> nl2br($mail->ErrorInfo));
}
 
/**
 * @intellisense
 */
function getFileNameFromURL()
{
	$scriptname = $_SERVER["PHP_SELF"];
	$pos = strrpos($scriptname, "/");
	if($pos !== FALSE)
		$scriptname = substr($scriptname, $pos + 1);
	return $scriptname;
}

/**
 * @intellisense
 */
function strlen_bin(&$str)
{
	return strlen($str);
}

/**
 * The code of ODBCFunctions::stripSlashesBinary was 
 * refactored as db_stripslashesbinaryAccess function
 * to convert in ASP correctly
 * @param String str
 * @return String
 * @intellisense
 */
function db_stripslashesbinaryAccess($str)
{
	if( is_array($str) )
		$str = implode('', $str);
	
	//	try to remove ole header for BMP pictures
	$pos = strpos($str, ".Picture");
	if( $pos === false || $pos > 300 )
		return $str;
		
	$pos1 = strpos($str, "BM", $pos);
	if( $pos1 === false || $pos1 > 300 )
		return $str;
	
	return substr($str, $pos1);
}

/**
 * @intellisense
 */
function SendContentLength($len)
{
	header("Content-Length: ".$len);
}

/**
 * @intellisense
 */
function DecodeUTF8($str)
{
	return $str;
}
/**
 * @intellisense
 */
function escapeEntities($str)
{
	return $str;
}

/**
 * @intellisense
 */
function empty_error_handler()
{
	return true;
}

/**
 * @intellisense
 */
function n_printDebug()
{
}

/**
 * @intellisense
 */
function in_arrayi($needle, $haystack)
{
	$found = false;
    foreach( $haystack as $value ) 
	{
        if( strtolower( $value ) == strtolower( $needle ) ) 
            $found = true;
    }   
    return $found; 
}

/**
 * @intellisense
 */
function f_printDebug()
{
	}

if(!function_exists("hex2bin"))
{
/**
 * Convert HEX string to BIN string
 * @param {string} HEX source string
 * @return {string} BIN string
 * @intellisense
 */	
function hex2bin($source) 
	 {
		if(!is_string($source) || strlen($source) == 0 || strlen($source) % 2 > 0)
			return '';
		$bin = "";
		$i = 0;
		do {
			$bin .= chr(hexdec($source[$i].$source[$i + 1]));
			$i += 2;
		} while ($i < strlen($source));
		return $bin;
	}
}

/**
 * @intellisense
 */
function toPHPTime($datevalue)
{
	$arr = db2time($datevalue);
	return mktime($arr[3],$arr[4],$arr[5],$arr[1],$arr[2],$arr[0]);
}

/**
 * @intellisense
 */
function imageCreateThumb($new_width,$new_height,$img_width,$img_height,$file_path,$options,$new_file_path,$uploadedFile)
{
	$new_img = @imagecreatetruecolor($new_width, $new_height);
	switch (strtolower(substr(strrchr($file_path, '.'), 1))) {
		case 'jpg':
		case 'jpeg':
			$src_img = @imagecreatefromjpeg($file_path);
			$image_quality = isset($options['jpeg_quality']) ?
				$options['jpeg_quality'] : 75;
			$success = @imagecopyresampled(
					$new_img,
					$src_img,
					0, 0, 0, 0,
					$new_width,
					$new_height,
					$img_width,
					$img_height
				) && imagejpeg($new_img, $new_file_path, $image_quality);
			break;
		case 'gif':
			@imagecolortransparent($new_img, @imagecolorallocate($new_img, 0, 0, 0));
			$src_img = @imagecreatefromgif($file_path);
			$image_quality = null;
			$success = @imagecopyresampled(
					$new_img,
					$src_img,
					0, 0, 0, 0,
					$new_width,
					$new_height,
					$img_width,
					$img_height
				) && imagegif($new_img, $new_file_path, $image_quality);
			break;
		case 'png':
			@imagecolortransparent($new_img, @imagecolorallocate($new_img, 0, 0, 0));
			@imagealphablending($new_img, false);
			@imagesavealpha($new_img, true);
			$src_img = @imagecreatefrompng($file_path);
			$image_quality = isset($options['png_quality']) ?
				$options['png_quality'] : 9;
			$success = @imagecopyresampled(
					$new_img,
					$src_img,
					0, 0, 0, 0,
					$new_width,
					$new_height,
					$img_width,
					$img_height
				) && imagepng($new_img, $new_file_path, $image_quality);
			break;
		default:
			$src_img = null;
			$success = false;
	}
	// Free up memory (imagedestroy does not delete files):
	@imagedestroy($src_img);
	@imagedestroy($new_img);
	return $success;
}
/**
 * @intellisense
 */
function uploadFiles($option)
{
	$result = null;
	if(isset($_FILES[$option])){
		$result = array();
		$upload = $_FILES[$option];
		if(is_array($upload['tmp_name'])) {
            foreach ($upload['tmp_name'] as $index => $value)
            {
            	$tempFile = array();
				$tempFile['tmp_name'] = $upload['tmp_name'][$index];
                $tempFile['name'] = $upload['name'][$index];
                $tempFile['size'] = $upload['size'][$index];
                $tempFile['type'] = $upload['type'][$index];
                $tempFile['error'] = $upload['error'][$index];
                $result[] = $tempFile;
            }
		}
		else
		{
			$result[] = $upload;
		}
	}
	return $result;
}
/**
 * @intellisense
 */
function upcount_name_callback($matches) 
{
	$index = isset($matches[1]) ? intval($matches[1]) + 1 : 1;
	$ext = isset($matches[2]) ? $matches[2] : '';
	return ' ('.$index.')'.$ext;
}

/**
 * @intellisense
 */
function upcount_name($name) 
{
	return preg_replace_callback(
		'/(?:(?: \(([\d]+)\))?(\.[^.]+))?$/',
		'upcount_name_callback',
		$name,
		1
	);
}

/**
 * @intellisense
 */
function trim_file_name($name, $type, $index, $obj) 
{
        // Remove path information and dots around the filename, to prevent uploading
        // into different directories or replacing hidden system files.
        // Also remove control characters and spaces (\x00..\x20) around the filename:
        $file_name = trim(basename($name,""));
        // Add missing file extension for known image types:
        if (strpos($file_name, '.') === false &&
            preg_match('/^image\/(gif|jpe?g|png)/', $type, $matches)) {
            $file_name .= '.'.$matches[1];
        }
        while(isset($_SESSION["mupload_".$obj->formStamp][$file_name])) {
            $file_name = upcount_name($file_name);
        }
        return $file_name;
    }

/**
 * @intellisense
 */
function upload_File($uploadedFile, $destination)
{
	if ($uploadedFile && is_uploaded_file($uploadedFile["tmp_name"])) 
	{
		move_uploaded_file($uploadedFile["tmp_name"], $destination);
		clearstatcache();
		clearstatcache();
	}
} 

/**
 * GDExist
 * Fake function. Only matter something for ASP, because in PHP GD always exist (since 4.3.0)
 * @intellisense
 */
function GDExist()
{
	return true;
}

/**
 * @intellisense
 */
function makeSurePathExists($abspath)
{
	if(!file_exists($abspath))
	{
		return mkdir($abspath, 0777,  true);
	}
	if(is_dir($abspath))
		return true;
	return false;
}

/**
 * @intellisense
 */
function createControlClass($className, $field, $pageObject, $id, $connection)
{
	include_once(getabspath("classes/controls/".$className.".php"));
	return new $className($field, $pageObject, $id, $connection);
}

/**
 * @intellisense
 */
function createViewControlClass($className, $field, $container, $pageObject)
{
	include_once(getabspath("classes/controls/".$className.".php"));
	return new $className($field, $container, $pageObject);
}

/**
 * @intellisense
 */
function getQueryString()
{
	return getenv('QUERY_STRING') ? urldecode(getenv('QUERY_STRING')) : $_SERVER["QUERY_STRING"];	
}

/**
 * GetTableLink
 * Form proper link for table. Really need for ASP.Net MVC
 * @param {string} Table name
 * @param {string} Page type
 * @param (string) GET query string 
 */
function GetTableLink($table, $pageType = "", $getParams = "")
{
	$url = $table;
	if($pageType != "")
	{
		$url .= "_".$pageType;
	}
	$url .= ".php";
	if($getParams != "")
	{
		$url .= "?".$getParams;
	}
	
	return $url;
}

function GetTemplateName($table, $templateName)
{
	$result = $templateName.".htm";
	if($table != "")
	{
		$result = $table."_".$result;
	}
		
	return $result;
}

function HeaderRedirect($table, $pageType = "", $getParams = "")
{
	header("Location: ".GetTableLink($table, $pageType, $getParams));
}

function cross_sort_arr_y($a,$b)
{
	global $group_sort_y;
	if($group_sort_y[$a]>$group_sort_y[$b])
		return true;
	else
		return false;
}

function SortForCrossTable(&$sort_y)
{	
	usort($sort_y, "cross_sort_arr_y");
}

function getYMDdate($unixTimeStamp)
{
	return date("Y-m-d", $unixTimeStamp);
}

function IsJSONAccepted()
{
	return isset($_SERVER['HTTP_ACCEPT']) && (strpos($_SERVER['HTTP_ACCEPT'], 'application/json') !== false);
}

function GetRootPathForResources($filePath)
{
	return $filePath;
}

function GetPageURLWithGetParams()
{
	$pagename = $_SERVER["REQUEST_URI"];
	if(!$pagename)
	{
		$pagename=basename(__file__);
		$params="";
		foreach($_GET as $k=>$v)
		{
			if(strlen($params))
				$params.="&";
			$params.=rawurlencode($k)."=".rawurlencode($v);
		}
		if(strlen($params))
			$pagename.="?".$params;
	}
	if(strpos($pagename,"?")===false)
	{
		$pagename.="?pdf=1";
	}
	else 
	{
		$pagename.="&pdf=1";
	}
		
	return $pagename;
}

/*
 * Dummy for ASP.Net MVC
 */
function GetWebRootPath()
{
	return "";
}

function GetCaptchaPath()
{
	return "securitycode.php";
}

function GetCaptchaSwfPath()
{
	return "securitycode.swf";
}

function verifyRecaptchaResponse( $response ) {
	$VerifyUrl = "https://www.google.com/recaptcha/api/siteverify?";
	$data = array();
	$data['secret'] = "";
	$data['response'] = $response;
	$data['remoteIp'] = $_SERVER["REMOTE_ADDR"];

	foreach ($data as $key => $value) {
		$req .= $key . '=' . rawurlencode($value) . '&';
	}
	// Cut the last '&'
	$req = substr($req, 0, strlen($req)-1);

	$response = myurl_get_contents($VerifyUrl . $req);
	$answers = my_json_decode($response, true);
	return $answers['success'];
}

function GetMobilePrefixForTemplate()
{
	return "";
}

/**
 * This function is used for my_json_encode() function.
 * It will emulate the JSON_UNESCAPED_UNICODE option for json_encode() function.
 */
function json_mb_encode_numericentity(&$item, $key)
{
	if (is_string($item))
		$item = runner_encode_numeric_entity($item, array(0x80, 0xffff, 0, 0xffff), 'UTF-8');
}

function makeFloat($value)
{
	$value = str_replace(",",".",$value);
	if(is_numeric($value))
		return (float)$value;
	else
		return "";
}

/**
 * Get the data array containing the flag indicating if
 * the string passed is HTML entity and the length of
 * the HTML entity that is set by the string 
 * @param String encodedEntity
 * @return Array
 */
function getHTMLEntityData($encodedEntity) 
{
	$entity = html_entity_decode( $encodedEntity );
	if( $encodedEntity == $entity )
		return array("isHTMLEntity"=> false, "entityLength"=> 0);
		
	return array("isHTMLEntity"=> true, "entityLength"=> runner_strlen( $entity ));	
}

/**
 * PHP html entity decode
 */	
function runner_html_entity_decode($str)
{
	// '&nbsp;' entity is not ASCII code 32 but ASCII code 160 (0xa0)
	return html_entity_decode(str_replace('&nbsp;', ' ', $str), ENT_COMPAT | ENT_HTML401, 'ISO-8859-1');
}

/**
 * PHP htmlspecialchars wrapper
 */	
function runner_htmlspecialchars($str)
{
	global $useUTF8;
	
	if($useUTF8)
		return htmlspecialchars($str);
	
	return htmlspecialchars($str, ENT_COMPAT | ENT_HTML401, 'ISO-8859-1');
}		

/**
 * PHP strlen wrapper
 */
function runner_strlen($str)
{
	global $useUTF8, $mbEnabled;
	
	if( !$useUTF8 )
		return strlen($str);
		
	if( $mbEnabled )
		return mb_strlen($str, 'UTF-8');
	
	//php.net not ISO-8859-1 characters are converted to '?' (one char).
	return strlen( utf8_decode($str) ); 
}

/**
 * PHP strpos wrapper
 */
function runner_strpos($haystack, $needle, $offset = 0)
{
	global $useUTF8, $mbEnabled;
	
	if( !$useUTF8 )
		return strpos($haystack, $needle);
		
	if( $mbEnabled )
		return mb_strpos($haystack, $needle,  $offset, 'UTF-8');
	
	if( $offset < 0 )
		return FALSE;
	
	if( $offset > 0 )
		$haystack = runner_substr($haystack, $offset, runner_strlen($haystack) - $offset);
	
	$pos = strpos($haystack, $needle);
	if( $pos === FALSE ) 
		return $pos;
		
	return $offset + runner_strlen( substr($haystack, 0, $pos) );
}

/**
 * PHP strrpos wrapper
 */
function runner_strrpos($haystack, $needle, $offset = 0)
{
	global $useUTF8, $mbEnabled;
	
	if( !$useUTF8 )
		return strrpos($haystack, $needle, $offset);
		
	if( $mbEnabled )
		return mb_strrpos($haystack, $needle, $offset, 'UTF-8');
	
	if( $offset < 0 )
		$offset = runner_strlen($haystack) + $offset;
	
	if( $offset > 0 )
		$haystack = runner_substr($haystack, $offset, runner_strlen($haystack) - $offset);
	
	$rpos = strrpos($haystack, $needle);
	if( $rpos === FALSE ) 
		return $rpos;
		
	return $offset + runner_strlen( substr($haystack, 0, $rpos) );
}

/**
 * PHP substr wrapper
 * @param String string
 * @param Number start (>= 0)
 * @param Number length (>= 0)
 * @return String
 */
function runner_substr($string, $start, $length)
{
	if( !$length )
		return "";
		
	global $useUTF8, $mbEnabled;
	
	if( !$useUTF8 )
		return substr($string, $start, $length);
	
	if( $mbEnabled ) 	
		return mb_substr($string, $start, $length, 'UTF-8');

	$end = $start + $length;
	//j is the real chars counter;
	$u8start = $u8end = $j = 0;
	for($i = 0; $i < strlen($string), $j < $end; $i++)
	{		
		if($j == $start)
			$u8start = $i;
		
		$ordord = ord($string[$i]);
		switch(true) 
		{
			case (0xFC == (0xFC & $ordord)):
				$i = $i + 5;
			break;
			case (0xF8 == (0xF8 & $ordord)):
				$i = $i + 4;
			break;
			case (0xF0 == (0xF0 & $ordord)):
				$i = $i + 3;
			break;
			case (0xE0 == (0xE0 & $ordord)):
				$i = $i + 2;
			break;
			case (0xC0 == (0xC0 & $ordord)) :
				$i = $i + 1;
		}
		$j++;
	}
	$u8end = $i;

	return substr($string, $u8start, $u8end - $u8start );
}

/**
 * PHP mb_convert_encoding wrapper
 */
function runner_convert_encoding($str, $to_encoding, $from_encoding)
{
	global $mbEnabled;
	
	if( $mbEnabled )
		return mb_convert_encoding($str, $to_encoding, $from_encoding);
 
	return $str;
}

/**
 * PHP mb_encode_numericentity wrapper
 */
function runner_encode_numeric_entity($str, $convmap, $encoding)
{
	global $mbEnabled;
	
	if( $mbEnabled )
		return mb_encode_numericentity($str, $convmap, $encoding); 
	
	return $str;
}

/**
 * PHP mb_decode_numericentity wrapper
 */
function runner_decode_numeric_entity($str, $convmap, $encoding)
{
	global $mbEnabled;
	
	if( $mbEnabled )
		return mb_decode_numericentity($str, $convmap, $encoding);
	
	return $str;	
}

function hasNonAsciiSymbols($str)
{
	$str = "".$str;
	for($i=0; $i<strlen($str); $i++)
	{
		if(ord($str[$i])>127)
			return true;
	}
	return false;
}

function runner_serialize_array($arr)
{
	return serialize($arr);
}

function runner_unserialize_array($arr)
{
	return unserialize($arr);
}

function runner_getimagesize($file_name, $uploadedFile)
{
	return @getimagesize($file_name);
}

function array_merge_assoc($arr1, $arr2)
{
	return array_merge($arr1, $arr2);
}

function getIntervalLimitsExpressions($table, $field, $idx, $isLowerBound)
{
	return getIntervalLimitsExprs($table, $field, $idx, $isLowerBound);
}

/**
 * @return Boolean
 */
function useMySQLiLib()
{
	global $useOldMysqlLib;
	
	if( !$useOldMysqlLib )
		return extension_loaded("mysqli") === true;
	
	return extension_loaded("mysql") !== true;
}

/**
 * @return Boolean
 */
function isSqlsrvExtLoaded()
{
	return extension_loaded("sqlsrv") === true;
}

/**
 * @return Boolean
 */	
function useMSSQLWinConnect()
{
	return strtoupper(substr(PHP_OS, 0, 3)) == "WIN" && substr(PHP_VERSION, 0, 1) > '4';
}

function cutBOM( $line )
{
	if( substr($line, 0, 3) == "\xEF\xBB\xBF" )
		return substr($line, 3);
	return $line;
}

function printBOM( )
{
	echo "\xEF\xBB\xBF";
}

function runner_save_textfile( $fileName, $txtData )
{
	runner_save_file( $fileName, $txtData );	
}

function deleteTemporaryFilesFromDirTMP()
{
	return false;
}

function runner_date_format($param, $date="")
{
	if($date == "")
		return date($param);
	else
		return date($param, $date);
}
?>